# JSON3.jl

[![Build Status](https://travis-ci.com/quinnj/JSON3.jl.svg?branch=master)](https://travis-ci.com/quinnj/JSON3.jl)
[![codecov](https://codecov.io/gh/quinnj/JSON3.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/quinnj/JSON3.jl)

### Documentation

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://quinnj.github.io/JSON3.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://quinnj.github.io/JSON3.jl/dev)

*Yet another JSON package for Julia; this one is for speed and slick struct mapping*

### TL;DR

#### Basic

```julia
# builtin reading/writing
JSON3.read(json_string)
JSON3.write(x)

# custom types
JSON3.read(json_string, T; kw...)
JSON3.write(x)
```

#### More complicated

```julia
# custom types: incrementally update a mutable struct
x = T()
JSON3.read!(json_string, x; kw...)
JSON3.write(x)

# read from file
json_string = read("my.json", String)
JSON3.read(json_string)
JSON3.read(json_string, T; kw...)

# write to file
open("my.json", "w") do f
    JSON3.write(f, x)
    println(f)
end

# write a pretty file
open("my.json", "w") do f
    JSON3.pretty(f, JSON3.write(x))
    println(f)
end

# generate a type from json
using StructTypes
JSON3.@generatetypes json_string_sample
JSON3.read(json_string, JSONTypes.Root)
```

module JSON3

using Parsers, Mmap, UUIDs, Dates, StructTypes
using Base: Ryu

"""An immutable (read only) struct which provides an efficient view of a JSON object. Supports the `AbstractDict` interface. See [built in types](#Builtin-types) for more detail on why we have an `Object` type."""
struct Object{S <: AbstractVector{UInt8}, TT <: AbstractVector{UInt64}} <: AbstractDict{Symbol, Any}
    buf::S
    tape::TT
    inds::Dict{Symbol, Int}
end

Object() = Object(codeunits(""), UInt64[object(Int64(2)), 0], Dict{Symbol, Int}())

"""An immutable (read only) struct which provides an efficient view of a JSON array. Supports the `AbstractArray` interface. See [built in types](#Builtin-types) for more detail on why we have an `Array` type."""
struct Array{T, S <: AbstractVector{UInt8}, TT <: AbstractVector{UInt64}} <: AbstractVector{T}
    buf::S
    tape::TT
    inds::Vector{Int}
end

Array{T}(buf::S, tape::TT, inds::Vector{Int}) where {T, S, TT} = Array{T, S, TT}(buf, tape, inds)

getbuf(j::Union{Object, Array}) = getfield(j, :buf)
gettape(j::Union{Object, Array}) = getfield(j, :tape)
getinds(j::Union{Object, Array}) = getfield(j, :inds)

include("utils.jl")

@noinline invalid(error, buf, pos, T) = throw(ArgumentError("""
invalid JSON at byte position $pos while parsing type $T: $error
$(String(buf[max(1, pos-25):min(end, pos+25)]))
"""))

@enum Error UnexpectedEOF ExpectedOpeningObjectChar ExpectedOpeningQuoteChar ExpectedOpeningArrayChar ExpectedClosingArrayChar ExpectedComma ExpectedSemiColon ExpectedNewline InvalidChar InvalidNumber ExtraField

# AbstractDict interface
Base.length(obj::Object) = getnontypemask(gettape(obj)[2])

function populateinds!(x::Object)
    inds = getinds(x)
    buf = getbuf(x)
    tape = gettape(x)
    tapeidx = 3
    @inbounds len = getnontypemask(tape[2])
    i = 1
    while i <= len
        @inbounds t = tape[tapeidx]
        key = getvalue(Symbol, buf, tape, tapeidx, t)
        tapeidx += 2
        inds[key] = tapeidx
        @inbounds tapeidx += gettapelen(Any, tape[tapeidx])
        i += 1
    end
    return
end

function populateinds!(x::Array)
    inds = getinds(x)
    buf = getbuf(x)
    tape = gettape(x)
    tapeidx = 3
    @inbounds len = getnontypemask(tape[2])
    resize!(inds, len)
    i = 1
    while i <= len
        @inbounds inds[i] = tapeidx
        @inbounds tapeidx += gettapelen(Any, tape[tapeidx])
        i += 1
    end
    return
end

@inline function Base.iterate(obj::Object, (i, tapeidx)=(1, 3))
    i > length(obj) && return nothing
    tape = gettape(obj)
    @inbounds t = tape[tapeidx]
    key = getvalue(Symbol, getbuf(obj), tape, tapeidx, t)
    tapeidx += 2
    @inbounds t = tape[tapeidx]
    x = Pair{Symbol, Any}(key, getvalue(Any, getbuf(obj), tape, tapeidx, t))
    tapeidx += gettapelen(Any, t)
    return x, (i + 1, tapeidx)
end

function Base.get(obj::Object, key::Symbol)
    ind = getinds(obj)[key]
    tape = gettape(obj)
    @inbounds t = tape[ind]
    return getvalue(Any, getbuf(obj), tape, ind, t)
end

Base.get(obj::Object, key) = get(obj, Symbol(key))

function Base.get(obj::Object, ::Type{T}, key)::T where {T}
    return get(obj, key)
end

function Base.get(obj::Object, key::Symbol, default)
    ind = getinds(obj)
    if haskey(ind, key)
        return get(obj, key)
    else
        return default
    end
end

Base.get(obj::Object, key, default) = get(obj, Symbol(key), default)

function Base.get(obj::Object, ::Type{T}, key, default::T)::T where {T}
    return get(obj, key, default)
end

function Base.get(default::Base.Callable, obj::Object, key::Symbol)
    ind = getinds(obj)
    if haskey(ind, key)
        return get(obj, key)
    else
        return default()
    end
end

Base.get(default::Base.Callable, obj::Object, key) = get(default, obj, Symbol(key))

Base.propertynames(obj::Object) = collect(keys(obj))

Base.getproperty(obj::Object, prop::Symbol) = get(obj, prop)
Base.getindex(obj::Object, key) = get(obj, key)

"""
    copy(obj)

Recursively copy [`JSON3.Object`](@ref)s to `Dict`s and [`JSON3.Array`](@ref)s to `Vector`s.  This copy can then be mutated if needed.
"""
function Base.copy(obj::Object)
    dict = Dict{Symbol, Any}()
    for (k, v) in obj
        dict[k] = v isa Object || v isa Array ? copy(v) : v
    end
    return dict
end

# AbstractArray interface
Base.IndexStyle(::Type{<:Array}) = Base.IndexLinear()

Base.size(arr::Array) = (length(getinds(arr)),)

function Base.iterate(arr::Array{T}, (i, tapeidx)=(1, 3)) where {T}
    i > length(arr) && return nothing
    tape = gettape(arr)
    @inbounds t = tape[tapeidx]
    val = getvalue(T, getbuf(arr), tape, tapeidx, t)
    tapeidx += gettapelen(T, t)
    return val, (i + 1, tapeidx)
end

@inline Base.@propagate_inbounds function Base.getindex(arr::Array{T}, i::Int) where {T}
    @boundscheck checkbounds(arr, i)
    tape = gettape(arr)
    buf = getbuf(arr)
    @inbounds ind = getinds(arr)[i]
    @inbounds t = tape[ind]
    return getvalue(T, buf, tape, ind, t)
end

Base.copy(arr::Array) = map(x->x isa Object || x isa Array ? copy(x) : x, arr)

include("read.jl")
include("strings.jl")
include("show.jl")
include("structs.jl")
include("write.jl")
include("pretty.jl")
include("gentypes.jl")

include("workload.jl")

end # module

struct PointerString <: AbstractString
    ptr::Ptr{UInt8}
    len::Int
end

function Base.hash(s::PointerString, h::UInt)
    h += Base.memhash_seed
    ccall(Base.memhash, UInt, (Ptr{UInt8}, Csize_t, UInt32), s.ptr, s.len, h % UInt32) + h
end

import Base: ==
function ==(x::String, y::PointerString)
    sizeof(x) == y.len && ccall(:memcmp, Cint, (Ptr{UInt8}, Ptr{UInt8}, Csize_t), pointer(x), y.ptr, y.len) == 0
end
==(y::PointerString, x::String) = x == y

Base.codeunit(s::PointerString) = UInt8
Base.ncodeunits(s::PointerString) = s.len
@inline function Base.codeunit(s::PointerString, i::Integer)
    @boundscheck checkbounds(s, i)
    unsafe_load(s.ptr + i - 1)
end
Base.String(x::PointerString) = unsafe_string(x.ptr, x.len)

function reverseescapechar(b)
    b == UInt8('"')  && return UInt8('"')
    b == UInt8('\\') && return UInt8('\\')
    b == UInt8('/')  && return UInt8('/')
    b == UInt8('b')  && return UInt8('\b')
    b == UInt8('f')  && return UInt8('\f')
    b == UInt8('n')  && return UInt8('\n')
    b == UInt8('r')  && return UInt8('\r')
    b == UInt8('t')  && return UInt8('\t')
    return 0x00
end

utf16_is_surrogate(c::UInt16) = (c & 0xf800) == 0xd800
utf16_get_supplementary(lead::UInt16, trail::UInt16) = Char(UInt32(lead-0xd7f7)<<10 + trail)

charvalue(b) = (UInt8('0') <= b <= UInt8('9')) ? b - UInt8('0') :
               (UInt8('a') <= b <= UInt8('f')) ? b - (UInt8('a') - 0x0a) :
               (UInt8('A') <= b <= UInt8('F')) ? b - (UInt8('A') - 0x0a) :
               throw(ArgumentError("JSON invalid unicode hex value"))

@noinline invalid_escape(str) = throw(ArgumentError("encountered invalid escape character in json string: \"$(String(str))\""))
@noinline unescaped_control(b) = throw(ArgumentError("encountered unescaped control character in json: '$(escape_string(Base.string(Char(b))))'"))

function unescape(s)
    n = ncodeunits(s)
    buf = Base.StringVector(n)
    len = 1
    i = 1
    @inbounds begin
        while i <= n
            b = codeunit(s, i)
            if b == UInt8('\\')
                i += 1
                i > n && invalid_escape(s)
                b = codeunit(s, i)
                if b == UInt8('u')
                    c = 0x0000
                    i += 1
                    i > n && invalid_escape(s)
                    b = codeunit(s, i)
                    c = (c << 4) + charvalue(b)
                    i += 1
                    i > n && invalid_escape(s)
                    b = codeunit(s, i)
                    c = (c << 4) + charvalue(b)
                    i += 1
                    i > n && invalid_escape(s)
                    b = codeunit(s, i)
                    c = (c << 4) + charvalue(b)
                    i += 1
                    i > n && invalid_escape(s)
                    b = codeunit(s, i)
                    c = (c << 4) + charvalue(b)
                    if utf16_is_surrogate(c)
                        i += 3
                        i > n && invalid_escape(s)
                        c2 = 0x0000
                        b = codeunit(s, i)
                        c2 = (c2 << 4) + charvalue(b)
                        i += 1
                        i > n && invalid_escape(s)
                        b = codeunit(s, i)
                        c2 = (c2 << 4) + charvalue(b)
                        i += 1
                        i > n && invalid_escape(s)
                        b = codeunit(s, i)
                        c2 = (c2 << 4) + charvalue(b)
                        i += 1
                        i > n && invalid_escape(s)
                        b = codeunit(s, i)
                        c2 = (c2 << 4) + charvalue(b)
                        ch = utf16_get_supplementary(c, c2)
                    else
                        ch = Char(c)
                    end
                    st = codeunits(Base.string(ch))
                    for j = 1:length(st)-1
                        @inbounds buf[len] = st[j]
                        len += 1
                    end
                    b = st[end]
                else
                    b = reverseescapechar(b)
                    b == 0x00 && invalid_escape(s)
                end
            end
            @inbounds buf[len] = b
            len += 1
            i += 1
        end
    end
    resize!(buf, len - 1)
    return String(buf)
end

Base.show(io::IO, j::Object) = _show(io, j)
# use the Base fallback AbstractArray show method instead
# Base.show(io::IO, j::Array) = _show(io, j)
_show(io::IO, x, indent=0, offset=0) = show(io, x)

function _show(io::IO, obj::Object, indent=0, offset=0)
    if isempty(obj)
        print(io, "{}")
        return
    end
    println(io, "{")
    indent += 1
    keyvals = collect(obj)
    keys = map(x->x[1], keyvals)
    vals = map(x->x[2], keyvals)
    maxlen = maximum(map(sizeof, keys)) + 5
    # @show maxlen
    for i = 1:length(keys)
        Base.write(io, "  "^indent)
        Base.write(io, lpad("\"$(keys[i])\"" * ": ", maxlen + offset, ' '))
        _show(io, vals[i], indent, maxlen + offset)
        if i == length(keys)
            indent -= 1
            Base.write(io, "\n" * ("  "^indent * " "^offset) * "}")
        else
            Base.write(io, ",\n")
        end
    end
    return
end

function _show(io::IO, arr::Array, indent=0, offset=0)
    if isempty(arr)
        print(io, "[]")
        return
    end
    println(io, "[")
    indent += 1
    vals = collect(arr)
    for (i, val) in enumerate(vals)
        Base.write(io, "  "^indent * " "^offset)
        _show(io, vals[i], indent, offset)
        if i == length(vals)
            indent -= 1
            Base.write(io, "\n" * ("  "^indent * " "^offset) * "]")
        else
            Base.write(io, ",\n")
        end
    end
    return
end

@testset "errors" begin
# Unexpected character in array
@test_throws ArgumentError JSON3.read("[1,2,3/4,5,6,7]")
# Unexpected character in object
@test_throws ArgumentError JSON3.read("{\"1\":2, \"2\":3 _ \"4\":5}")
# Invalid escaped character
@test_throws ArgumentError repr(JSON3.read("[\"alpha\\α\"]"))
# Invalid 'simple' and 'unknown value'
@test_throws ArgumentError JSON3.read("[tXXe]")
@test_throws ArgumentError JSON3.read("[fail]")
@test_throws ArgumentError JSON3.read("∞")
# Invalid number
@test_throws ArgumentError JSON3.read("[5,2,-]")
@test_throws ArgumentError JSON3.read("[5,2,+β]")
# Incomplete escape
@test_throws ArgumentError JSON3.read("\"\\")
@test_throws ArgumentError JSON3.read("[\"🍕\"_\"🍕\"")

end # @testset "errors"

@enum Animal zebra aardvark horse
@test JSON3.write(zebra) == "\"zebra\""
@test JSON3.write([aardvark, horse, Dict("z" => zebra)]) == "[\"aardvark\",\"horse\",{\"z\":\"zebra\"}]"


@testset "Symbol" begin
    symtest = Dict(:symbolarray => [:apple, :pear], :symbolsingleton => :hello)
    @test (JSON3.write(symtest) == "{\"symbolarray\":[\"apple\",\"pear\"],\"symbolsingleton\":\"hello\"}"
             || JSON3.write(symtest) == "{\"symbolsingleton\":\"hello\",\"symbolarray\":[\"apple\",\"pear\"]}")
end

@testset "Floats" begin
    @test_throws ErrorException JSON3.write([NaN])
    @test_throws ErrorException JSON3.write([Inf])
    @test JSON3.write([NaN], allow_inf=true) == "[NaN]"
    @test JSON3.write([Inf], allow_inf=true) == "[Infinity]"
    @test JSON3.write([-Inf], allow_inf=true) == "[-Infinity]"
    @test JSON3.read("[Inf]", Vector{Float64}) == [Inf]
    @test JSON3.read("[Infinity]", Vector{Float64}) == [Inf]
    @test JSON3.read("[NaN]", Vector{Float64})[1] === NaN
    @test_throws ArgumentError JSON3.read("NaN")
    @test_throws ArgumentError JSON3.read("Inf")
    @test_throws ArgumentError JSON3.read("Infinity")
    @test_skip(@test_throws ArgumentError JSON3.read("-Infinity"))
    @test JSON3.read("NaN"; allow_inf=true) === NaN
    @test JSON3.read("Inf"; allow_inf=true) === Inf
    @test JSON3.read("Infinity"; allow_inf=true) === Inf
    @test JSON3.read("-Infinity"; allow_inf=true) === -Inf
end

@testset "Char" begin
    @test JSON3.write('a') == "\"a\""
    @test JSON3.write('\\') == "\"\\\\\""
    @test JSON3.write('\n') == "\"\\n\""
    @test JSON3.write('🍩') =="\"🍩\""
end

@test sprint(JSON3.write, Float64) == "\"Float64\""

@testset "Null bytes" begin
    zeros = Dict("\0" => "\0")
    json_zeros = JSON3.write(zeros)
    @test occursin("\\u0000", json_zeros)
    @test !occursin("\\0", json_zeros)
    @test JSON3.read(json_zeros, Dict) == zeros
end

@testset "Arrays" begin
# Printing an empty array or Dict shouldn't cause a BoundsError
@test JSON3.write(String[]) == "[]"
@test JSON3.write(Dict()) == "{}"

#Multidimensional arrays
@test_broken JSON3.write([0 1; 2 0]) == "[[0,2],[1,0]]" #TODO
end

@testset "Pairs" begin
@test JSON3.write(1 => 2) == "{\"1\":2}"
@test JSON3.write(:foo => 2) == "{\"foo\":2}"
@test JSON3.write([1, 2] => [3, 4]) == "{\"$([1, 2])\":[3,4]}"
@test JSON3.write([1 => 2]) == "[{\"1\":2}]"
end

@testset "Sets" begin
@test JSON3.write(Set()) == "[]"
@test JSON3.write(Set([1, 2])) in ["[1,2]", "[2,1]"]
end

#Examples from http://json.org/example.html
JSON3.read("{\"menu\": {
    \"id\": \"file\",
    \"value\": \"File\",
    \"popup\": {
      \"menuitem\": [
        {\"value\": \"New\", \"onclick\": \"CreateNewDoc()\"},
        {\"value\": \"Open\", \"onclick\": \"OpenDoc()\"},
        {\"value\": \"Close\", \"onclick\": \"CloseDoc()\"}
      ]
    }
  }}
  ")


JSON3.read("{
\"glossary\": {
   \"title\": \"example glossary\",
\"GlossDiv\": {
       \"title\": \"S\",
 \"GlossList\": {
           \"GlossEntry\": {
               \"ID\": \"SGML\",
     \"SortAs\": \"SGML\",
     \"GlossTerm\": \"Standard Generalized Markup Language\",
     \"Acronym\": \"SGML\",
     \"Abbrev\": \"ISO 8879:1986\",
     \"GlossDef\": {
                   \"para\": \"A meta-markup language, used to create markup languages such as DocBook.\",
       \"GlossSeeAlso\": [\"GML\", \"XML\"]
               },
     \"GlossSee\": \"markup\"
           }
       }
   }
}
}
")

JSON3.read("""
{"widget": {
"debug": "on",
"window": {
   "title": "Sample Konfabulator Widget",
   "name": "main_window",
   "width": 500,
   "height": 500
},
"image": {
   "src": "Images/Sun.png",
   "name": "sun1",
   "hOffset": 250,
   "vOffset": 250,
   "alignment": "center"
},
"text": {
   "data": "Click Here",
   "size": 36.5,
   "style": "bold",
   "name": "text1",
   "hOffset": 250,
   "vOffset": 100,
   "alignment": "center",
   "onMouseUp": "sun1.opacity = (sun1.opacity / 100) * 90;"
}
}}""")

JSON3.read("{\"web-app\": {
\"servlet\": [
{
 \"servlet-name\": \"cofaxCDS\",
 \"servlet-class\": \"org.cofax.cds.CDSServlet\",
 \"init-param\": {
   \"configGlossary:installationAt\": \"Philadelphia, PA\",
   \"configGlossary:adminEmail\": \"ksm@pobox.com\",
   \"configGlossary:poweredBy\": \"Cofax\",
   \"configGlossary:poweredByIcon\": \"/images/cofax.gif\",
   \"configGlossary:staticPath\": \"/content/static\",
   \"templateProcessorClass\": \"org.cofax.WysiwygTemplate\",
   \"templateLoaderClass\": \"org.cofax.FilesTemplateLoader\",
   \"templatePath\": \"templates\",
   \"templateOverridePath\": \"\",
   \"defaultListTemplate\": \"listTemplate.htm\",
   \"defaultFileTemplate\": \"articleTemplate.htm\",
   \"useJSP\": false,
   \"jspListTemplate\": \"listTemplate.jsp\",
   \"jspFileTemplate\": \"articleTemplate.jsp\",
   \"cachePackageTagsTrack\": 200,
   \"cachePackageTagsStore\": 200,
   \"cachePackageTagsRefresh\": 60,
   \"cacheTemplatesTrack\": 100,
   \"cacheTemplatesStore\": 50,
   \"cacheTemplatesRefresh\": 15,
   \"cachePagesTrack\": 200,
   \"cachePagesStore\": 100,
   \"cachePagesRefresh\": 10,
   \"cachePagesDirtyRead\": 10,
   \"searchEngineListTemplate\": \"forSearchEnginesList.htm\",
   \"searchEngineFileTemplate\": \"forSearchEngines.htm\",
   \"searchEngineRobotsDb\": \"WEB-INF/robots.db\",
   \"useDataStore\": true,
   \"dataStoreClass\": \"org.cofax.SqlDataStore\",
   \"redirectionClass\": \"org.cofax.SqlRedirection\",
   \"dataStoreName\": \"cofax\",
   \"dataStoreDriver\": \"com.microsoft.jdbc.sqlserver.SQLServerDriver\",
   \"dataStoreUrl\": \"jdbc:microsoft:sqlserver://LOCALHOST:1433;DatabaseName=goon\",
   \"dataStoreUser\": \"sa\",
   \"dataStorePassword\": \"dataStoreTestQuery\",
   \"dataStoreTestQuery\": \"SET NOCOUNT ON;select test='test';\",
   \"dataStoreLogFile\": \"/usr/local/tomcat/logs/datastore.log\",
   \"dataStoreInitConns\": 10,
   \"dataStoreMaxConns\": 100,
   \"dataStoreConnUsageLimit\": 100,
   \"dataStoreLogLevel\": \"debug\",
   \"maxUrlLength\": 500}},
{
 \"servlet-name\": \"cofaxEmail\",
 \"servlet-class\": \"org.cofax.cds.EmailServlet\",
 \"init-param\": {
 \"mailHost\": \"mail1\",
 \"mailHostOverride\": \"mail2\"}},
{
 \"servlet-name\": \"cofaxAdmin\",
 \"servlet-class\": \"org.cofax.cds.AdminServlet\"},

{
 \"servlet-name\": \"fileServlet\",
 \"servlet-class\": \"org.cofax.cds.FileServlet\"},
{
 \"servlet-name\": \"cofaxTools\",
 \"servlet-class\": \"org.cofax.cms.CofaxToolsServlet\",
 \"init-param\": {
   \"templatePath\": \"toolstemplates/\",
   \"log\": 1,
   \"logLocation\": \"/usr/local/tomcat/logs/CofaxTools.log\",
   \"logMaxSize\": \"\",
   \"dataLog\": 1,
   \"dataLogLocation\": \"/usr/local/tomcat/logs/dataLog.log\",
   \"dataLogMaxSize\": \"\",
   \"removePageCache\": \"/content/admin/remove?cache=pages&id=\",
   \"removeTemplateCache\": \"/content/admin/remove?cache=templates&id=\",
   \"fileTransferFolder\": \"/usr/local/tomcat/webapps/content/fileTransferFolder\",
   \"lookInContext\": 1,
   \"adminGroupID\": 4,
   \"betaServer\": true}}],
\"servlet-mapping\": {
\"cofaxCDS\": \"/\",
\"cofaxEmail\": \"/cofaxutil/aemail/*\",
\"cofaxAdmin\": \"/admin/*\",
\"fileServlet\": \"/static/*\",
\"cofaxTools\": \"/tools/*\"},

\"taglib\": {
\"taglib-uri\": \"cofax.tld\",
\"taglib-location\": \"/WEB-INF/tlds/cofax.tld\"}}}")

JSON3.read("""
{"menu": {
"header": "SVG\\tViewer\\u03b1",
"items": [
   {"id": "Open"},
   {"id": "OpenNew", "label": "Open New"},
   null,
   {"id": "ZoomIn", "label": "Zoom In"},
   {"id": "ZoomOut", "label": "Zoom Out"},
   {"id": "OriginalView", "label": "Original View"},
   null,
   {"id": "Quality"},
   {"id": "Pause"},
   {"id": "Mute"},
   null,
   {"id": "Find", "label": "Find..."},
   {"id": "FindAgain", "label": "Find Again"},
   {"id": "Copy"},
   {"id": "CopyAgain", "label": "Copy Again"},
   {"id": "CopySVG", "label": "Copy SVG"},
   {"id": "ViewSVG", "label": "View SVG"},
   {"id": "ViewSource", "label": "View Source"},
   {"id": "SaveAs", "label": "Save As"},
   null,
   {"id": "Help"},
   {"id": "About", "label": "About Adobe SVG Viewer..."}
]
}}""")

#Example JSON strings from http://www.jquery4u.com/json/10-example-json-files/
JSON3.read("{\"markers\": [
   {
       \"point\":\"new GLatLng(40.266044,-74.718479)\",
       \"homeTeam\":\"Lawrence Library\",
       \"awayTeam\":\"LUGip\",
       \"markerImage\":\"images/red.png\",
       \"information\": \"Linux users group meets second Wednesday of each month.\",
       \"fixture\":\"Wednesday 7pm\",
       \"capacity\":\"\",
       \"previousScore\":\"\"
   },
   {
       \"point\":\"new GLatLng(40.211600,-74.695702)\",
       \"homeTeam\":\"Hamilton Library\",
       \"awayTeam\":\"LUGip HW SIG\",
       \"markerImage\":\"images/white.png\",
       \"information\": \"Linux users can meet the first Tuesday of the month to work out harward and configuration issues.\",
       \"fixture\":\"Tuesday 7pm\",
       \"capacity\":\"\",
       \"tv\":\"\"
   },
   {
       \"point\":\"new GLatLng(40.294535,-74.682012)\",
       \"homeTeam\":\"Applebees\",
       \"awayTeam\":\"After LUPip Mtg Spot\",
       \"markerImage\":\"images/newcastle.png\",
       \"information\": \"Some of us go there after the main LUGip meeting, drink brews, and talk.\",
       \"fixture\":\"Wednesday whenever\",
       \"capacity\":\"2 to 4 pints\",
       \"tv\":\"\"
   }
] }")

JSON3.read("{
\"colorsArray\":[{
       \"colorName\":\"red\",
       \"hexValue\":\"#f00\"
   },
   {
       \"colorName\":\"green\",
       \"hexValue\":\"#0f0\"
   },
   {
       \"colorName\":\"blue\",
       \"hexValue\":\"#00f\"
   },
   {
       \"colorName\":\"cyan\",
       \"hexValue\":\"#0ff\"
   },
   {
       \"colorName\":\"magenta\",
       \"hexValue\":\"#f0f\"
   },
   {
       \"colorName\":\"yellow\",
       \"hexValue\":\"#ff0\"
   },
   {
       \"colorName\":\"black\",
       \"hexValue\":\"#000\"
   }
]
}")

JSON3.read("{
\"colorsArray\":[{
       \"red\":\"#f00\",
       \"green\":\"#0f0\",
       \"blue\":\"#00f\",
       \"cyan\":\"#0ff\",
       \"magenta\":\"#f0f\",
       \"yellow\":\"#ff0\",
       \"black\":\"#000\"
   }
]
}")

JSON3.read("{
\"red\":\"#f00\",
\"green\":\"#0f0\",
\"blue\":\"#00f\",
\"cyan\":\"#0ff\",
\"magenta\":\"#f0f\",
\"yellow\":\"#ff0\",
\"black\":\"#000\"
}")

JSON3.read("{\"results\":[

{\"text\":\"@twitterapi  http://tinyurl.com/ctrefg\",
\"to_user_id\":396524,
\"to_user\":\"TwitterAPI\",
\"from_user\":\"jkoum\",
\"metadata\":
    {
     \"result_type\":\"popular\",
     \"recent_retweets\": 109
    },
\"id\":1478555574,
\"from_user_id\":1833773,
\"iso_language_code\":\"nl\",
\"source\":\"<a href=\\\"http://twitter.com/\\\">twitter</a>\",
\"profile_image_url\":\"http://s3.amazonaws.com/twitter_production/profile_images/118412707/2522215727_a5f07da155_b_normal.jpg\",
\"created_at\":\"Wed, 08 Apr 2009 19:22:10 +0000\"}],
\"since_id\":0,
\"max_id\":1480307926,
\"refresh_url\":\"?since_id=1480307926&q=%40twitterapi\",
\"results_per_page\":15,
\"next_page\":\"?page=2&max_id=1480307926&q=%40twitterapi\",
\"completed_in\":0.031704,
\"page\":1,
\"query\":\"%40twitterapi\"}")

JSON3.read("{
\"data\": [
 {
    \"id\": \"X999_Y999\",
    \"from\": {
       \"name\": \"Tom Brady\", \"id\": \"X12\"
    },
    \"message\": \"Looking forward to 2010!\",
    \"actions\": [
       {
          \"name\": \"Comment\",
          \"link\": \"http://www.facebook.com/X999/posts/Y999\"
       },
       {
          \"name\": \"Like\",
          \"link\": \"http://www.facebook.com/X999/posts/Y999\"
       }
    ],
    \"type\": \"status\",
    \"created_time\": \"2010-08-02T21:27:44+0000\",
    \"updated_time\": \"2010-08-02T21:27:44+0000\"
 },
 {
    \"id\": \"X998_Y998\",
    \"from\": {
       \"name\": \"Peyton Manning\", \"id\": \"X18\"
    },
    \"message\": \"Where's my contract?\",
    \"actions\": [
       {
          \"name\": \"Comment\",
          \"link\": \"http://www.facebook.com/X998/posts/Y998\"
       },
       {
          \"name\": \"Like\",
          \"link\": \"http://www.facebook.com/X998/posts/Y998\"
       }
    ],
    \"type\": \"status\",
    \"created_time\": \"2010-08-02T21:27:44+0000\",
    \"updated_time\": \"2010-08-02T21:27:44+0000\"
 }
]
}")

JSON3.read("""{
"title": "Talk On Travel Pool",
"link": "http://www.flickr.com/groups/talkontravel/pool/",
"description": "Travel and vacation photos from around the world.",
"modified": "2009-02-02T11:10:27Z",
"generator": "http://www.flickr.com/",
"totalItems":222,
"items": [
       {
       "title": "View from the hotel",
       "link": "http://www.flickr.com/photos/33112458@N08/3081564649/in/pool-998875@N22",
       "media": {"m":"http://farm4.static.flickr.com/3037/3081564649_4a6569750c_m.jpg"},
       "date_taken": "2008-12-04T04:43:03-08:00",
       "description": "<p><a href=\\"http://www.flickr.com/people/33112458@N08/\\"> Talk On Travel</a> has added a photo to the pool:</p> <p><a href=\\"http:// www.flickr.com/photos/33112458@N08/3081564649/\\" title=\\"View from the hotel\\"> <img src=\\"http://farm4.static.flickr.com/3037/3081564649_4a6569750c_m.jpg\\" width=\\"240\\" height=\\"180\\" alt=\\"View from the hotel\\" /></a></p> ",
       "published": "2008-12-04T12:43:03Z",
       "author": "nobody@flickr.com (Talk On Travel)",
       "author_id": "33112458@N08",
       "tags": "spain dolphins tenerife canaries lagomera aqualand playadelasamericas junglepark losgigantos loscristines talkontravel"
       }
]
}""")

JSON3.read("{\"apiVersion\":\"2.0\",
\"data\":{
\"updated\":\"2010-01-07T19:58:42.949Z\",
\"totalItems\":800,
\"startIndex\":1,
\"itemsPerPage\":1,
\"items\":[
   {\"id\":\"hYB0mn5zh2c\",
    \"uploaded\":\"2007-06-05T22:07:03.000Z\",
    \"updated\":\"2010-01-07T13:26:50.000Z\",
    \"uploader\":\"GoogleDeveloperDay\",
    \"category\":\"News\",
    \"title\":\"Google Developers Day US - Maps API Introduction\",
    \"description\":\"Google Maps API Introduction ...\",
    \"tags\":[
       \"GDD07\",\"GDD07US\",\"Maps\"
    ],
    \"thumbnail\":{
       \"default\":\"http://i.ytimg.com/vi/hYB0mn5zh2c/default.jpg\",
       \"hqDefault\":\"http://i.ytimg.com/vi/hYB0mn5zh2c/hqdefault.jpg\"
    },
    \"player\":{
       \"default\":\"http://www.youtube.com/watch?v\u003dhYB0mn5zh2c\"
    },
    \"content\":{
       \"1\":\"rtsp://v5.cache3.c.youtube.com/CiILENy.../0/0/0/video.3gp\",
       \"5\":\"http://www.youtube.com/v/hYB0mn5zh2c?f...\",
       \"6\":\"rtsp://v1.cache1.c.youtube.com/CiILENy.../0/0/0/video.3gp\"
    },
    \"duration\":2840,
    \"aspectRatio\":\"widescreen\",
    \"rating\":4.63,
    \"ratingCount\":68,
    \"viewCount\":220101,
    \"favoriteCount\":201,
    \"commentCount\":22,
    \"status\":{
       \"value\":\"restricted\",
       \"reason\":\"limitedSyndication\"
    },
    \"accessControl\":{
       \"syndicate\":\"allowed\",
       \"commentVote\":\"allowed\",
       \"rate\":\"allowed\",
       \"list\":\"allowed\",
       \"comment\":\"allowed\",
       \"embed\":\"allowed\",
       \"videoRespond\":\"moderated\"
    }
   }
]
}
}")

JSON3.read("{
\"menu\": {
   \"header\": \"xProgress SVG Viewer\",
   \"items\": [
       {
           \"id\": \"Open\"
       },
       {
           \"id\": \"OpenNew\",
           \"label\": \"Open New\"
       },
       null,
       {
           \"id\": \"ZoomIn\",
           \"label\": \"Zoom In\"
       },
       {
           \"id\": \"ZoomOut\",
           \"label\": \"Zoom Out\"
       },
       {
           \"id\": \"OriginalView\",
           \"label\": \"Original View\"
       },
       null,
       {
           \"id\": \"Quality\"
       },
       {
           \"id\": \"Pause\"
       },
       {
           \"id\": \"Mute\"
       },
       null,
       {
           \"id\": \"Find\",
           \"label\": \"Find...\"
       },
       {
           \"id\": \"FindAgain\",
           \"label\": \"Find Again\"
       },
       {
           \"id\": \"Copy\"
       },
       {
           \"id\": \"CopyAgain\",
           \"label\": \"Copy Again\"
       },
       {
           \"id\": \"CopySVG\",
           \"label\": \"Copy SVG\"
       },
       {
           \"id\": \"ViewSVG\",
           \"label\": \"View SVG\"
       },
       {
           \"id\": \"ViewSource\",
           \"label\": \"View Source\"
       },
       {
           \"id\": \"SaveAs\",
           \"label\": \"Save As\"
       },
       null,
       {
           \"id\": \"Help\"
       },
       {
           \"id\": \"About\",
           \"label\": \"About xProgress CVG Viewer...\"
       }
   ]
}
}")

JSON3.read("{
\"firstName\": \"John\",
\"lastName\": \"Smith\",
\"age\": 25,
\"address\":
{
    \"streetAddress\": \"21 2nd Street\",
    \"city\": \"New York\",
    \"state\": \"NY\",
    \"postalCode\": \"10021\"
},
\"phoneNumber\":
[
    {
      \"type\": \"home\",
      \"number\": \"212 555-1234\"
    },
    {
      \"type\": \"fax\",
      \"number\": \"646 555-4567\"
    }
]
}")

JSON3.read("{
   \"name\":\"Product\",
   \"properties\":
   {
           \"id\":
           {
                   \"type\":\"number\",
                   \"description\":\"Product identifier\",
                   \"required\":true
           },
           \"name\":
           {
                   \"description\":\"Name of the product\",
                   \"type\":\"string\",
                   \"required\":true
           },
           \"price\":
           {
                   \"type\":\"number\",
                   \"minimum\":0,
                   \"required\":true
           },
           \"tags\":
           {
                   \"type\":\"array\",
                   \"items\":
                   {
                           \"type\":\"string\"
                   }
           }
   }
}")

JSON3.read("{
\"ResultSet\": {
   \"totalResultsAvailable\": \"1827221\",
   \"totalResultsReturned\": 2,
   \"firstResultPosition\": 1,
   \"Result\": [
       {
           \"Title\": \"potato jpg\",
           \"Summary\": \"Kentang Si bungsu dari keluarga Solanum tuberosum L ini ternyata memiliki khasiat untuk mengurangi kerutan  jerawat  bintik hitam dan kemerahan pada kulit  Gunakan seminggu sekali sebagai\",
           \"Url\": \"http://www.mediaindonesia.com/spaw/uploads/images/potato.jpg\",
           \"ClickUrl\": \"http://www.mediaindonesia.com/spaw/uploads/images/potato.jpg\",
           \"RefererUrl\": \"http://www.mediaindonesia.com/mediaperempuan/index.php?ar_id=Nzkw\",
           \"FileSize\": 22630,
           \"FileFormat\": \"jpeg\",
           \"Height\": \"362\",
           \"Width\": \"532\",
           \"Thumbnail\": {
               \"Url\": \"http://thm-a01.yimg.com/nimage/557094559c18f16a\",
               \"Height\": \"98\",
               \"Width\": \"145\"
           }
       },
       {
           \"Title\": \"potato jpg\",
           \"Summary\": \"Introduction of puneri aloo This is a traditional potato preparation flavoured with curry leaves and peanuts and can be eaten on fasting day  Preparation time   10 min\",
           \"Url\": \"http://www.infovisual.info/01/photo/potato.jpg\",
           \"ClickUrl\": \"http://www.infovisual.info/01/photo/potato.jpg\",
           \"RefererUrl\": \"http://sundayfood.com/puneri-aloo-indian-%20recipe\",
           \"FileSize\": 119398,
           \"FileFormat\": \"jpeg\",
           \"Height\": \"685\",
           \"Width\": \"1024\",
           \"Thumbnail\": {
               \"Url\": \"http://thm-a01.yimg.com/nimage/7fa23212efe84b64\",
               \"Height\": \"107\",
               \"Width\": \"160\"
           }
       }
   ]
}
}")

JSON3.read("""
{"অলিম্পিকস": {
"অ্যাথলেট": "২২টি দেশ থেকে ২,০৩৫ জন প্রতিযোগী",
"ইভেন্ট": "২২টি ইভেন্টের মধ্যে ছিল দড়ি টানাটানি",
"রেকর্ড": [
   {"১০০মি. স্প্রিন্ট": "রেজি ওয়াকার, দক্ষিণ আফ্রিকা"},
   {"Marathon": "জনি হেইস"},
   {" ফ্রি-স্টাইল সাঁতার": "Henry Taylor, Britain"}
]
}}
""")

# issue #5
issue5 = "[\"A\",\"B\",\"C\\n\"]"
@test JSON3.read(issue5) == ["A", "B", "C\n"]

# $ escaping issue
dollars = ["all of the \$s", "µniçø∂\$"]
@test JSON3.read(JSON3.write(dollars)) == dollars

# unmatched brackets
brackets = Dict("foo"=>"ba}r", "be}e]p"=>"boo{p")
@test JSON3.read(JSON3.write(brackets), Dict{String, String}) == brackets

test21 = "[\r\n{\r\n\"a\": 1,\r\n\"b\": 2\r\n},\r\n{\r\n\"a\": 3,\r\n\"b\": 4\r\n}\r\n]"
a = JSON3.read(test21, Vector{Any})
@test isa(a, Vector{Any})
@test length(a) == 2

obj = JSON3.read("{\"a\":2e10}")
@test obj.a == 2e10

obj = JSON3.read("{\"\U0001d712\":\"\\ud835\\udf12\"}")
@test obj.𝜒 == "𝜒"

struct t109
    i::Int
end
JSON3.StructType(::Type{t109}) = JSON3.Struct()

let iob = IOBuffer()
    JSON3.write(iob, t109(1))
    @test (JSON3.read(String(take!(iob)))).i == 1
end

# issue #127 support AbstractCmd
if !Sys.iswindows()
@test (JSON3.read(`echo \{\"i\":1\}`)).i == 1
@test (JSON3.read(`echo` & `echo \{\"i\":1\}`)).i == 1
end

@test_broken JSON3.write([Int64[] Int64[]]) == "[[],[]]" #TODO
@test JSON3.write([Int64[] Int64[]]') == "[]"

@test Float32(JSON3.read(JSON3.write(2.1f-8))) == 2.1f-8

# PR 60
@test JSON3.write(String([0xff])) == "\"\xff\""

# PR 116
@test mktemp() do path, io
    JSON3.write(path, [1, 2, 3])
    open(JSON3.read, path) == [1, 2, 3]
end

@test mktemp() do path, io
    str = "σ"^127
    JSON3.write(path, str)
    open(path, "r") do io
        JSON3.read(io) == str
    end
end

using Test, JSON3, StructTypes, UUIDs, Dates

@static if Base.VERSION < v"1.5"
    ismutable(o::T) where {T} = T.mutable
end

struct data
    t :: Tuple{Symbol, String}
end

@enum Fruit apple banana

struct XInt
    x::Int64
end

struct A
    a::Int
    b::Int
    c::Int
    d::Int
end

mutable struct B
    a::Int
    b::Int
    c::Int
    d::Int
    B() = new()
end

struct C
end

struct D
    a::Int
    b::Float64
    c::String
end

struct ParametricSingleton{T} end

abstract type Vehicle end

struct Car <: Vehicle
    type::String
    make::String
    model::String
    seatingCapacity::Int
    topSpeed::Float64
end

struct Truck <: Vehicle
    type::String
    make::String
    model::String
    payloadCapacity::Float64
end

abstract type Vehicle2 end

mutable struct Car2 <: Vehicle2
    make::String
    model::String
    seatingCapacity::Int
    topSpeed::Float64
    Car2() = new()
end

abstract type Expression end

abstract type Literal <: Expression end

abstract type BinaryFunction <: Expression end

struct LiteralValue <: Literal
    exprType::String
    value::Any
end

struct AndFunction <: BinaryFunction
    exprType::String
    lhs::Expression
    rhs::Expression
end

struct LotsOfFields
    x1::String
    x2::String
    x3::String
    x4::String
    x5::String
    x6::String
    x7::String
    x8::String
    x9::String
    x10::String
    x11::String
    x12::String
    x13::String
    x14::String
    x15::String
    x16::String
    x17::String
    x18::String
    x19::String
    x20::String
    x21::String
    x22::String
    x23::String
    x24::String
    x25::String
    x26::String
    x27::String
    x28::String
    x29::String
    x30::String
    x31::String
    x32::String
    x33::String
    x34::String
    x35::String
end

mutable struct DateStruct
    date::Date
    datetime::DateTime
    time::Time
end
DateStruct() = DateStruct(Date(0), DateTime(0), Time(0))

struct DictWithoutLength end

struct Wrapper
    x::NamedTuple{(:a, :b), Tuple{Int, String}}
end

struct NaNStruct
    x::Float64
end

StructTypes.StructType(::Type{NaNStruct}) = StructTypes.CustomStruct()
StructTypes.lower(x::NaNStruct) = x.x
StructTypes.construct(::Type{NaNStruct}, x) = NaNStruct(x)

Base.@kwdef mutable struct System
    duration::Real = 0 # mandatory
    cwd::Union{Nothing, String} = nothing
    environment::Union{Nothing, Dict} = nothing
    batch::Union{Nothing, Dict} = nothing
    shell::Union{Nothing, Dict} = nothing
end
StructTypes.StructType(::Type{System}) = StructTypes.Mutable()
StructTypes.omitempties(::Type{System}) = (:cwd, :environment, :batch, :shell)

roundtrip(x::T) where T = JSON3.read(JSON3.write(x), T)

mutable struct UndefGuy
    id::Int
    name::String
    UndefGuy() = new()
end

StructTypes.StructType(::Type{UndefGuy}) = StructTypes.Mutable()

@testset "JSON3" begin

@testset "read.jl" begin

for readfunc in [JSON3.read, JSON3.parse]
    @test_throws ArgumentError readfunc("")
    @test readfunc("{\"hey\":1}").hey == 1
    @test readfunc("[\"hey\",1]") == ["hey",1]
    @test readfunc("1.0") === Int64(1)
    @test readfunc("1") === Int64(1)
    @test readfunc("1.1") === 1.1
    @test readfunc("+1.1") === 1.1
    @test readfunc("-1.1") === -1.1
    @test readfunc("\"hey\"") == "hey"
    @test readfunc("null") === nothing
    @test readfunc("true") === true
    @test readfunc("false") === false
end

# numbertype
@test JSON3.read("1.0", numbertype=Float64) === 1.0
@test JSON3.read("1", numbertype=Float64) === 1.0
@test_throws ArgumentError JSON3.read("1", numbertype=Float32)
@test JSON3.read("{\"hey\":1}", numbertype=Float64).hey === 1.0
@test JSON3.read("[\"hey\",1]", numbertype=Float64)[2] === 1.0
@test JSON3.read("[[1]]", numbertype=Float64)[1][1] === 1.0
@test JSON3.read("1.0"; jsonlines=true, numbertype=Float64)[1] === 1.0

# more robust Int vs. Float detection: https://github.com/quinnj/JSON3.jl/issues/124
@test JSON3.read("9223372036854775807") == 9223372036854775807
@test JSON3.read("9223372036854775808") == 9.223372036854776e18 # overflowed Int64 promotes to Float64 (though slightly lossy)
@test JSON3.read("-9223372036854775808") == -9223372036854775808
@test JSON3.read("-9223372036854775809") == -9.223372036854776e18
# 2^53 boundaries
@test JSON3.read("9007199254740991") == 9007199254740991
@test JSON3.read("9007199254740992") == 9007199254740992
@test JSON3.read("9007199254740993") == 9007199254740993
@test JSON3.read("9007199254740994") == 9007199254740994
@test JSON3.read("1e17") == Int64(1e17)


@test_throws ArgumentError JSON3.read("{")
@test JSON3.read("{}") == JSON3.Object()
@test_throws ArgumentError JSON3.read("{a")
@test JSON3.read("{\"a\": 1}").a == 1
@test JSON3.read("{\"\\\"hey\\\"\": 1}")["\"hey\""] == 1
@test_throws ArgumentError JSON3.read("{\"a\"}")
@test JSON3.read("{\"a\": {\"a\": {\"a\": 1}}}").a.a.a == 1
@test JSON3.read("[3.14, 1]") == [3.14, 1]
@test JSON3.read("[1, 3.14]") == [1, 3.14]
@test JSON3.read("[null, 1]") == [nothing, 1]
@test JSON3.read("[1, null]") == [1, nothing]
@test JSON3.read("[null, null]") == [nothing, nothing]
@test JSON3.read("[null, \"hey\"]") == [nothing, "hey"]
@test_throws ArgumentError JSON3.read("{\"a\": 1\"")
@test_throws ArgumentError JSON3.read("{\"a\": 1, a")
@test JSON3.read("[]") == []
@test JSON3.read("[1]") == [1]
@test JSON3.read("[1,2,3]") == [1,2,3]
@test_throws ArgumentError JSON3.read("[1 a")
@test_throws ArgumentError JSON3.read("nulL")
@test_throws ArgumentError JSON3.read("\"\b\"")

obj = JSON3.read("""
{
    "int": 1,
    "float": 2.1,
    "bool1": true,
    "bool2": false,
    "none": null,
    "str": "\\"hey there sailor\\"",
    "obj": {
                "a": 1,
                "b": null,
                "c": [null, 1, "hey"],
                "d": [1.2, 3.4, 5.6]
            },
    "arr": [null, 1, "hey"],
    "arr2": [1.2, 3.4, 5.6]
}
""")
@test obj.int === Int64(1)
@test obj.float === 2.1
@test obj.bool1 === true
@test obj.bool2 === false
@test obj.none === nothing
@test obj.str == "\"hey there sailor\""
@test obj.obj.a === Int64(1)
@test obj.obj.b === nothing
@test obj.obj.c == [nothing, 1, "hey"]
@test obj.obj.d == [1.2, 3.4, 5.6]
@test obj.arr == [nothing, 1, "hey"]
@test obj.arr2 == [1.2, 3.4, 5.6]

@test_throws ArgumentError JSON3.read("trua")
@test_throws ArgumentError JSON3.read("tru")
@test_throws ArgumentError JSON3.read("fals")
@test_throws ArgumentError JSON3.read("falst")
@test_throws ArgumentError JSON3.read("f")

@test JSON3.read("\"\\u003e\\u003d\$1B\"") == ">=\$1B"

obj = JSON3.read("""
{ "a": 1,
  "b": 2,
  "c": 3,
  "d": 4
}""")

@test length(obj) == 4
for (i, (k, v)) in enumerate(obj)
    @test i == v
end

@test get(obj, :a) == 1
@test get(obj, Int, :a) == 1
@test_throws KeyError get(obj, :e)
@test_throws KeyError get(obj, Int, :e)
@test get(obj, :a, 2) == 1
@test get(obj, :e, 5) == 5
@test get(()->5, obj, :e) == 5
@test propertynames(obj) == [:a, :b, :c, :d]
@test obj["a"] == 1
@test get(obj, "a") == 1
@test get(obj, Int, "a") == 1
@test_throws KeyError get(obj, "e") == 1
@test_throws KeyError get(obj, Int, "e") == 1
@test get(obj, "a", 2) == 1
@test get(obj, Int, "a", 2) == 1
@test get(obj, "e", 5) == 5
@test get(obj, Int, "e", 5) == 5

arr = JSON3.read("""
[ 1,
  2,
  3,
  4
]""")

@test length(arr) == 4
@test size(arr) == (4,)

for (i, v) in enumerate(arr)
    @test i == v
end

@test arr[1] == 1
@test arr[end] == 4

arr = JSON3.read(SubString("""
[ 1,
  2,
  3,
  4
]""", 1, 20))

@test length(arr) == 4
@test size(arr) == (4,)

for (i, v) in enumerate(arr)
    @test i == v
end

@test arr[1] == 1
@test arr[end] == 4

end # @testset "read.jl"

@testset "structs.jl" begin

arr = JSON3.read(SubString("""
[ 1,
  2,
  3,
  4
]""", 1, 20), Vector{Int})

@test length(arr) == 4
@test size(arr) == (4,)

for (i, v) in enumerate(arr)
    @test i == v
end

@test arr[1] == 1
@test arr[end] == 4

@test JSON3.write(arr) == "[1,2,3,4]"

x = JSON3.read("1", Union{Int, Missing})
@test x == 1

x = JSON3.read("null", Union{Int, Missing})
@test x === missing

x = JSON3.read("1", Union{Int, Float64})
@test x === 1.0

StructTypes.construct(::Type{JSON3.PointerString}, ptr::Ptr{UInt8}, len::Int) = JSON3.PointerString(ptr, len)
str = "\"hey\""
x = JSON3.read(str, JSON3.PointerString);
@test x == "hey"
@test typeof(x) == JSON3.PointerString
@test JSON3.write(x) == str

@test JSON3.read("\"apple\"", Fruit) == apple
@test_throws Union{UndefVarError, ArgumentError} JSON3.read("\"watermelon\"", Fruit)
@test JSON3.write(apple) == "\"apple\""

@test JSON3.read("\"apple\"", Symbol) == :apple
@test JSON3.write(:apple) == "\"apple\""

@test JSON3.read("true", Bool)
@test JSON3.read("false", Bool) === false
@test JSON3.write(true) == "true"
@test JSON3.write(false) == "false"

StructTypes.StructType(::Type{XInt}) = StructTypes.NumberType()
StructTypes.numbertype(::Type{XInt}) = Int64
StructTypes.construct(::Type{Int64}, x::XInt) = x.x
x = XInt(10)
@test JSON3.read("10", XInt) == x
@test JSON3.write(x) == "10"

@test JSON3.read("[1,2,3]", Array) == Any[1,2,3]
@test JSON3.write(Any[1,2,3]) == "[1,2,3]"
@test JSON3.read("[1,2,3]", Tuple) == (1,2,3)
@test JSON3.write((1,2,3)) == "[1,2,3]"
@test JSON3.read("[1,2,3]", Set) == Set([1,2,3])
@test JSON3.write(Set([1,2])) in ("[1,2]", "[2,1]")

@test JSON3.read("{\"a\": 1, \"b\": 2}", Dict) == Dict("a"=>1, "b"=>2)
@test JSON3.write(Dict("a"=>1, "b"=>2)) in ("{\"a\":1,\"b\":2}", "{\"b\":2,\"a\":1}")
@test JSON3.read("{\"a\": 1, \"b\": 2}", Dict{String, Any}) == Dict("a"=>1, "b"=>2)
@test JSON3.read("{\"a\": 1, \"b\": 2}", Dict{Symbol, Int}) == Dict(:a=>1, :b=>2)
@test JSON3.write(Dict(:a=>1, :b=>2)) in ("{\"a\":1,\"b\":2}", "{\"b\":2,\"a\":1}")
@test JSON3.read("{\"a\": 1, \"b\": 2}", NamedTuple) == (a=1, b=2)
@test JSON3.write((a=1, b=2)) == "{\"a\":1,\"b\":2}"
@test JSON3.read("{\"a\": 1, \"b\": 2}", NamedTuple{(:a, :b)}) == (a=1, b=2)
@test JSON3.read("{\"a\": 1, \"b\": 2}", NamedTuple{(:a,)}) == (a=1,)
@test JSON3.write((a=1,)) == "{\"a\":1}"
@test JSON3.read("{\"a\": 1, \"b\": 2}", NamedTuple{(:a, :b), Tuple{Int, Int}}) == (a=1, b=2)
@test JSON3.read("{\"a\": 1, \"b\": 2}", NamedTuple{(:a, :b), Tuple{Float64, Float64}}) == (a=1.0, b=2.0)
@test JSON3.write((a=1.0, b=2.0)) == "{\"a\":1.0,\"b\":2.0}"

mktemp() do path, io
    str = "{\"a\":1.0,\"b\":2.0}"
    write(io, str)
    obj =  JSON3.read(str)
    close(io)
    @test JSON3.read(path) == obj
    @test JSON3.read(path, Dict) == Dict("a" => 1.0, "b" => 2.0)
end

# Test that writing DictType works even when length(pairs(dict_type)) isn't
# available. Issue #37.
StructTypes.StructType(::Type{DictWithoutLength}) = StructTypes.DictType()
Base.pairs(x::DictWithoutLength) =
    Iterators.filter(x -> last(x) !== nothing, ("a" => 1, "b" => nothing))
@test JSON3.write(DictWithoutLength()) == "{\"a\":1}"

StructTypes.StructType(::Type{A}) = StructTypes.Struct()

obj = JSON3.read("""
{ "a": 1,
  "b": 2,
  "c": 3,
  "d": 4
}
""", A)

@test obj.a == 1
@test obj.d == 4

# test order doesn't matter
obj2 = JSON3.read("""
{ "d": 1,
  "b": 2,
  "c": 3,
  "a": 4
}
""", A)

@test obj2.d == 1
@test obj2.a == 4

@test_throws ArgumentError JSON3.read("", A)
@test_throws ArgumentError JSON3.read("a", A)
@test_throws ArgumentError JSON3.read("{a", A)
@test_throws ArgumentError JSON3.read("{\"a\"a", A)
@test_throws ArgumentError JSON3.read("{\"a\": 1a", A)
@test_throws ArgumentError JSON3.read("{\"a\": 1, a", A)
@test_throws ArgumentError JSON3.read("}", A)

# `JSON3.read!` should not work for immutable structs
@test_throws ArgumentError JSON3.read!("", A(1, 2, 3, 4))
@test_throws ArgumentError JSON3.read!("a", A(1, 2, 3, 4))
@test_throws ArgumentError JSON3.read!("{a", A(1, 2, 3, 4))
@test_throws ArgumentError JSON3.read!("{\"a\"a", A(1, 2, 3, 4))
@test_throws ArgumentError JSON3.read!("{\"a\": 1a", A(1, 2, 3, 4))
@test_throws ArgumentError JSON3.read!("{\"a\": 1, a", A(1, 2, 3, 4))
@test_throws ArgumentError JSON3.read!("}", A(1, 2, 3, 4))

@test JSON3.write(C()) == "\"C()\""
@test JSON3.write(ParametricSingleton{Int64}()) == "\"ParametricSingleton{Int64}()\""

@test_throws MethodError JSON3.read("{}", C)
StructTypes.StructType(::Type{C}) = StructTypes.Struct()

@test JSON3.read("{}", C) == C()
@test JSON3.write(obj) == "{\"a\":1,\"b\":2,\"c\":3,\"d\":4}"

StructTypes.StructType(::Type{D}) = StructTypes.OrderedStruct()
obj = JSON3.read("""
{ "a": 1,
  "b": 3.14,
  "c": "hey"
}
""", D)

@test obj.a == 1
@test obj.b == 3.14
@test obj.c == "hey"

# if order of fields is switched, error is thrown
@test_throws ArgumentError JSON3.read("""
{ "c": "hey",
  "b": 3.14,
  "a": 1
}
""", D)

@test JSON3.read("1", Union{String, Int}) == 1
@test JSON3.read("\"1\"", Union{String, Int}) == "1"
@test JSON3.read("null", Union{Int, String, Nothing}) === nothing
@test JSON3.read("1.0", Union{Float64, Int}) === 1.0

@test JSON3.read("1", Any) == 1
@test JSON3.read("3.14", Any) == 3.14
@test JSON3.read("\"a\"", Any) == "a"
@test JSON3.read("true", Any) === true
@test JSON3.read("false", Any) === false
@test JSON3.read("null", Any) === nothing
@test JSON3.read("[1,2,3]", Any) == [1,2,3]
@test JSON3.read("\"a\"", String) == "a"
@test JSON3.read("1", Int64) === Int64(1)
@test JSON3.read("3.14", Float64) === 3.14
@test JSON3.read("true", Bool) === true
@test JSON3.read("false", Bool) === false
@test JSON3.read("null", Nothing) === nothing
@test JSON3.read("null", Missing) === missing
@test JSON3.read("\"a\"", Char) == 'a'
@test JSON3.read("{\"a\": 1}", Any)["a"] == 1
@test JSON3.read("{\"a\": 1}", Dict{Symbol, Any})[:a] == 1
@test JSON3.read("[1,2,3]", Base.Array{Any}) == [1,2,3]
@test JSON3.read("[]", Vector{Any}) == []
@test JSON3.read("{}", Dict{Symbol, Any}) == Dict{Symbol, Any}()
@test JSON3.read("{\"a\":\"b\\/c\"}").a == "b/c"

@test_throws ArgumentError JSON3.read("hey", Any)
@test_throws ArgumentError JSON3.read("hey", String)
@test_throws ArgumentError JSON3.read("\"hey", String)
@test_throws ArgumentError JSON3.read("\"hey\\", String)
@test_throws ArgumentError JSON3.read("\"hey\\\\", String)
@test_throws ArgumentError JSON3.read("\"a", Char)
@test_throws ArgumentError JSON3.read("\"ab\"", Char)
@test_throws ArgumentError JSON3.read("trua", Bool)
@test_throws ArgumentError JSON3.read("tru", Bool)
@test_throws ArgumentError JSON3.read("fals", Bool)
@test_throws ArgumentError JSON3.read("falst", Bool)
@test_throws ArgumentError JSON3.read("f", Bool)
@test_throws ArgumentError JSON3.read("a1bc", Int)
@test_throws ArgumentError JSON3.read("a1.0b", Float64)
@test_throws ArgumentError JSON3.read("a1bc", Vector{Any})
@test_throws ArgumentError JSON3.read("[1,2n", Vector{Any})
@test_throws ArgumentError JSON3.read("a1bc", Dict{Symbol, Any})
@test_throws ArgumentError JSON3.read("{a1bc", Dict{Symbol, Any})
@test_throws ArgumentError JSON3.read("{\"a\"1bc", Dict{Symbol, Any})
@test_throws ArgumentError JSON3.read("{\"a\": 1bc", Dict{Symbol, Any})
@test_throws ArgumentError JSON3.read("{\"a\": 1, bc", Dict{Symbol, Any})

StructTypes.StructType(::Type{B}) = StructTypes.Mutable()

b = JSON3.read("""
{
    "d": 4,
    "b": 2,
    "a": 1,
    "c": 3
}""", B)

@test b.a == 1
@test b.b == 2
@test b.c == 3
@test b.d == 4

b = B()
JSON3.read!("""
{
    "d": 4,
    "b": 2,
    "a": 1,
    "c": 3
}""", b)

@test b.a == 1
@test b.b == 2
@test b.c == 3
@test b.d == 4

@test_throws ArgumentError JSON3.read("", B)
@test_throws ArgumentError JSON3.read("a", B)
@test_throws ArgumentError JSON3.read("{a", B)
@test_throws ArgumentError JSON3.read("{\"a\": 1b", B)
@test_throws ArgumentError JSON3.read("{\"a\": 1, b", B)
@test_throws ArgumentError JSON3.read("}", B)
b = JSON3.read("{}", B)
@test typeof(b) == B

@test_throws ArgumentError JSON3.read!("", B())
@test_throws ArgumentError JSON3.read!("a", B())
@test_throws ArgumentError JSON3.read!("{a", B())
@test_throws ArgumentError JSON3.read!("{\"a\": 1b", B())
@test_throws ArgumentError JSON3.read!("{\"a\": 1, b", B())
@test_throws ArgumentError JSON3.read!("}", B())
b = JSON3.read("{}", B)
@test typeof(b) == B

b = JSON3.read("""
{
    "d": 4,
    "b": 2,
    "a": 1,
    "c": 3,
    "e": 5
}""", B)

@test b.a == 1
@test JSON3.write(b) == "{\"a\":1,\"b\":2,\"c\":3,\"d\":4}"

b = B()
JSON3.read!("""
{
    "d": 4,
    "b": 2,
    "a": 1,
    "c": 3,
    "e": 5
}""", b)

@test b.a == 1
@test JSON3.write(b) == "{\"a\":1,\"b\":2,\"c\":3,\"d\":4}"

# Incremental updating of mutable structs with `JSON3.read!`
@testset "Incremental updating of mutable structs with `JSON3.read!`" begin
    b = B()
    b.a = 0
    b.b = 0
    b.c = 0
    b.d = 0

    @test b.a == 0
    @test b.b == 0
    @test b.c == 0
    @test b.d == 0

    foo = JSON3.read!("""
    {
        "b": 1
    }""", b)
    @test b.a == 0
    @test b.b == 1
    @test b.c == 0
    @test b.d == 0
    @test foo == b
    @test foo === b

    bar = JSON3.read!("""
    {
        "d": 30,
        "b": 20,
        "a": 10,
        "e": 40
    }""", b)
    @test b.a == 10
    @test b.b == 20
    @test b.c == 0
    @test b.d == 30
    @test bar == b
    @test bar === b

    baz = JSON3.read!("""
    {
        "d": 400,
        "b": 200,
        "a": 100,
        "c": 300,
        "e": 500
    }""", b)
    @test b.a == 100
    @test b.b == 200
    @test b.c == 300
    @test b.d == 400
    @test baz == b
    @test baz === b
end

StructTypes.names(::Type{B}) = ((:a, :z),)
b = JSON3.read("""
{
    "d": 4,
    "b": 2,
    "z": 1,
    "c": 3,
    "e": 5
}""", B)

@test b.a == 1
@test JSON3.write(b) == "{\"z\":1,\"b\":2,\"c\":3,\"d\":4}"

StructTypes.excludes(::Type{B}) = (:c, :d)
b = JSON3.read("""
{
    "d": 4,
    "b": 2,
    "z": 1,
    "c": 3,
    "e": 5
}""", B)
@test JSON3.write(b) == "{\"z\":1,\"b\":2}"

StructTypes.StructType(::Type{Vehicle}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{Vehicle}) = (car=Car, truck=Truck)

StructTypes.StructType(::Type{Car}) = StructTypes.Struct()
StructTypes.StructType(::Type{Truck}) = StructTypes.Struct()

car = JSON3.read("""
{
    "type": "car",
    "make": "Mercedes-Benz",
    "model": "S500",
    "seatingCapacity": 5,
    "topSpeed": 250.1
}""", Vehicle)

@test typeof(car) == Car
@test car.make == "Mercedes-Benz"
@test car.topSpeed === 250.1
@test JSON3.write(car) == "{\"type\":\"car\",\"make\":\"Mercedes-Benz\",\"model\":\"S500\",\"seatingCapacity\":5,\"topSpeed\":250.1}"

truck = JSON3.read("""
{
    "type": "truck",
    "make": "Isuzu",
    "model": "NQR",
    "payloadCapacity": 7500.5
}""", Vehicle)

@test typeof(truck) == Truck
@test truck.make == "Isuzu"
@test truck.payloadCapacity == 7500.5
@test JSON3.write(truck) == "{\"type\":\"truck\",\"make\":\"Isuzu\",\"model\":\"NQR\",\"payloadCapacity\":7500.5}"

@test_throws ArgumentError JSON3.read("", Vehicle)
@test_throws ArgumentError JSON3.read("a", Vehicle)
@test_throws ArgumentError JSON3.read("{a", Vehicle)
@test_throws ArgumentError JSON3.read("{}", Vehicle)
@test_throws ArgumentError JSON3.read("{\"a\"a", Vehicle)
@test_throws ArgumentError JSON3.read("{\"a\": 1a", Vehicle)
@test_throws ArgumentError JSON3.read("{\"a\": 1, a", Vehicle)
@test_throws ArgumentError JSON3.read("{\"a\": 1}", Vehicle)

StructTypes.StructType(::Type{Vehicle2}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{Vehicle2}) = (Car2=Car2,)
StructTypes.StructType(::Type{Car2}) = StructTypes.Mutable()
car2 = JSON3.read("""
{
    "topSpeed": 250.1,
    "model": "S500",
    "make": "Mercedes-Benz",
    "seatingCapacity": 5
}""", Vehicle2)

@test typeof(car2) == Car2
@test car2.make == "Mercedes-Benz"
@test car2.topSpeed === 250.1
@test JSON3.write(car2) == "{\"make\":\"Mercedes-Benz\",\"model\":\"S500\",\"seatingCapacity\":5,\"topSpeed\":250.1}"

StructTypes.StructType(::Type{Expression}) = StructTypes.AbstractType()
StructTypes.subtypes(::Type{Expression}) = (AND=AndFunction, LITERAL=LiteralValue)
StructTypes.subtypekey(::Type{Expression}) = :exprType

StructTypes.StructType(::Type{AndFunction}) = StructTypes.Struct()
StructTypes.StructType(::Type{LiteralValue}) = StructTypes.Struct()

expr = JSON3.read("""
{
    "exprType": "AND",
    "lhs": {
        "exprType": "LITERAL",
        "value": 3.14
    },
    "rhs": {
        "exprType": "AND",
        "lhs": {
            "exprType": "LITERAL",
            "value": null
        },
        "rhs": {
            "exprType": "LITERAL",
            "value": "hey"
        }
    }
}
""", Expression)
@test expr.exprType == "AND"
@test JSON3.write(expr) == "{\"exprType\":\"AND\",\"lhs\":{\"exprType\":\"LITERAL\",\"value\":3.14},\"rhs\":{\"exprType\":\"AND\",\"lhs\":{\"exprType\":\"LITERAL\",\"value\":null},\"rhs\":{\"exprType\":\"LITERAL\",\"value\":\"hey\"}}}"

@test JSON3.write(Int64) == "\"Int64\""
@test JSON3.write(Float64) == "\"Float64\""
@test JSON3.write(String) == "\"String\""
@test startswith(JSON3.write(Dict{Symbol, Any}), "\"Dict{Symbol,")
@test JSON3.write(Bool) == "\"Bool\""
@test JSON3.write(Nothing) == "\"Nothing\""
@test JSON3.write(Missing) == "\"Missing\""
@test JSON3.write(A) == "\"A\""
@test JSON3.write(B) == "\"B\""
@test JSON3.write(Vehicle) == "\"Vehicle\""

StructTypes.StructType(::Type{LotsOfFields}) = StructTypes.Struct()
lotsoffields = LotsOfFields(fill("hey", 35)...)
jlots = JSON3.write(lotsoffields)
@test jlots == "{\"x1\":\"hey\",\"x2\":\"hey\",\"x3\":\"hey\",\"x4\":\"hey\",\"x5\":\"hey\",\"x6\":\"hey\",\"x7\":\"hey\",\"x8\":\"hey\",\"x9\":\"hey\",\"x10\":\"hey\",\"x11\":\"hey\",\"x12\":\"hey\",\"x13\":\"hey\",\"x14\":\"hey\",\"x15\":\"hey\",\"x16\":\"hey\",\"x17\":\"hey\",\"x18\":\"hey\",\"x19\":\"hey\",\"x20\":\"hey\",\"x21\":\"hey\",\"x22\":\"hey\",\"x23\":\"hey\",\"x24\":\"hey\",\"x25\":\"hey\",\"x26\":\"hey\",\"x27\":\"hey\",\"x28\":\"hey\",\"x29\":\"hey\",\"x30\":\"hey\",\"x31\":\"hey\",\"x32\":\"hey\",\"x33\":\"hey\",\"x34\":\"hey\",\"x35\":\"hey\"}"
@test JSON3.read(jlots, LotsOfFields) == lotsoffields
jlots = "{\"x1\":\"1\",\"x11\":\"11\",\"x2\":\"2\",\"x12\":\"12\",\"x3\":\"3\",\"x13\":\"13\",\"x4\":\"4\",\"x14\":\"14\",\"x5\":\"5\",\"x15\":\"15\",\"x6\":\"6\",\"x16\":\"16\",\"x7\":\"7\",\"x17\":\"17\",\"x8\":\"8\",\"x18\":\"18\",\"x9\":\"9\",\"x19\":\"19\",\"x10\":\"10\",\"x20\":\"20\",\"x26\":\"26\",\"x27\":\"27\",\"x28\":\"28\",\"x29\":\"29\",\"x30\":\"30\",\"x21\":\"21\",\"x22\":\"22\",\"x23\":\"23\",\"x24\":\"24\",\"x25\":\"25\",\"x35\":\"35\",\"x34\":\"34\",\"x33\":\"33\",\"x32\":\"32\",\"x31\":\"31\"}"
@test JSON3.read(jlots, LotsOfFields) == LotsOfFields(string.(collect(1:35))...)

StructTypes.StructType(::Type{Wrapper}) = StructTypes.CustomStruct()
StructTypes.lower(x::Wrapper) = x.x
StructTypes.lowertype(::Type{Wrapper}) = fieldtype(Wrapper, :x)
w = Wrapper((a=1, b="hey"))
json = JSON3.write(w)
@test json == "{\"a\":1,\"b\":\"hey\"}"
@test JSON3.read(json, Wrapper) == w

end # @testset "structs.jl"

@testset "show.jl" begin

@test repr(JSON3.read("{}")) == "{}"
@test repr(JSON3.read("{\"a\": 1}")) == "{\n   \"a\": 1\n}"
@test repr(JSON3.read("{\"a\": {\"b\": 2}}")) == "{\n   \"a\": {\n           \"b\": 2\n        }\n}"
# @test repr(JSON3.read("[]")) == "[]"
# @test repr(JSON3.read("[1,2,3]")) == "[\n  1,\n  2,\n  3\n]"
# @test repr(JSON3.read("[1,[2.1,2.2,2.3],3]")) == "[\n  1,\n  [\n    2.1,\n    2.2,\n    2.3\n  ],\n  3\n]"

end # @testset "show.jl"

include("json.jl")

# more tests for coverage
obj = JSON3.read("{\"hey\":1}")
@test get(obj, Int, :hey) == 1
@test get(obj, Int, :ho, 2) == 2

@test JSON3.read("{\"hey\":1}") == JSON3.read(b"{\"hey\":1}") == JSON3.read(IOBuffer("{\"hey\":1}"))

arr = JSON3.read("[\"hey\",1, null, false, \"ho\", {\"a\": 1}, 2]")
@test Base.IndexStyle(arr) == Base.IndexLinear()
@test arr[7] == 2

str = "hey"
ptr = JSON3.PointerString(pointer(str), 3)
@test hash(str) == hash(ptr)
@test codeunit(ptr) == UInt8
@test StructTypes.names(1) == ()
@test StructTypes.names(Any) == ()
@test StructTypes.excludes(1) == ()
@test StructTypes.excludes(Any) == ()
@test StructTypes.omitempties(1) == ()
@test StructTypes.omitempties(Any) == ()

@test StructTypes.subtypekey(1) == :type
@test StructTypes.subtypekey(Any) == :type
@test StructTypes.subtypes(1) == NamedTuple()
@test StructTypes.subtypes(Any) == NamedTuple()

@test JSON3.read(b"\"a\"", String) == "a"
@test JSON3.read(IOBuffer("\"a\""), String) == "a"
@test StructTypes.StructType(Char) == StructTypes.StringType()
@test StructTypes.construct(String, "hey") == "hey"
@test StructTypes.StructType(Bool) == StructTypes.BoolType()
@test StructTypes.construct(Bool, true) === true
@test StructTypes.StructType(UInt8) == StructTypes.NumberType()
@test StructTypes.numbertype(UInt8) == UInt8
@test StructTypes.numbertype(1) == Float64
@test StructTypes.construct(String, "hey") == "hey"
@test StructTypes.StructType(typeof((1,2))) == StructTypes.ArrayType()
x = Dict(:hey=>1)
@test StructTypes.construct(Dict{Symbol, Any}, x) == x

@test JSON3.gettapelen(Int64) == 2
@test JSON3.regularstride(Missing) == false
@test JSON3.regularstride(Int64) == true
@test JSON3.regularstride(Union{Int64, Float64}) == true
@test JSON3.getvalue(Nothing, [], [], 1, 2) === nothing
@test JSON3.defaultminimum(nothing) == 4
@test JSON3.defaultminimum(Int64) == 16
@test JSON3.defaultminimum('1') == 3

# https://github.com/quinnj/JSON3.jl/issues/1
txt = """
{ "a" : { "b" : [ 1, 2 ],
          "c" : [ 3, 4 ] } }
"""

@test JSON3.read(txt).a.b == [1,2]

# https://github.com/quinnj/JSON3.jl/issues/8
@test eltype(JSON3.read("[1.2, 2.0]")) === Float64
@test eltype(JSON3.read("[1.2, 2.0, 3.3]")) === Float64
@test eltype(JSON3.read("[1.2, null, 3.3]")) === Union{Float64, Nothing}
@test eltype(JSON3.read("[1.2, null, 3.0]")) === Union{Float64, Nothing}

# https://github.com/quinnj/JSON3.jl/issues/9
d = Dict(uuid1() => i for i in 1:3)
t = JSON3.write(d)
@test JSON3.read(t, Dict{UUID, Int}) == d
u = uuid1()
@test JSON3.read(JSON3.write(u), UUID) == u

d = Date(2019, 11, 16)
@test JSON3.read(JSON3.write(d), Date) == d
df = dateformat"dd-mm-yyyy"
@test JSON3.read(JSON3.write(d; dateformat=df), Date; dateformat=df) == d

# get issue
obj = JSON3.read("{\"hey\":1}")
@test get(obj, :hey) == get(obj, "hey") == get(obj, "hey", "") == get(()->"", obj, "hey")

# copy issue
obj = JSON3.read("{\"a\":\"b\", \"b\":null, \"c\":[null,null]}")
@test copy(obj) == Dict(:a => "b", :b => nothing, :c => [nothing, nothing])

# better Tuple reading support
@test JSON3.read("[\"car\",\"Mercedes\"]", Tuple{Symbol, String}) == (:car, "Mercedes")
@test JSON3.read("[\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\",\"hey\"]", NTuple{35, String}) ==
    ("hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey", "hey")

StructTypes.StructType(::Type{data}) = StructTypes.Struct()
@test JSON3.read("{\"t\":[\"car\",\"Mercedes\"]}", data) == data((:car, "Mercedes"))

# new StructTypes.keywordargs option
StructTypes.StructType(::Type{DateStruct}) = StructTypes.Mutable()
StructTypes.keywordargs(::Type{DateStruct}) = (date=(dateformat=dateformat"dd-mm-yyyy",), datetime=(dateformat=dateformat"dd-mm-yyyy HH:MM:SS",), time=(dateformat=dateformat"HH MM SS",))
ds = DateStruct(Date(2019, 11, 16), DateTime(2019, 11, 16, 1, 25), Time(1, 26))
@test JSON3.write(ds) == "{\"date\":\"16-11-2019\",\"datetime\":\"16-11-2019 01:25:00\",\"time\":\"01 26 00\"}"
ds2 = JSON3.read(JSON3.write(ds), DateStruct)
@test ds.date == ds2.date && ds.datetime == ds2.datetime && ds.time == ds2.time

# 63
@test JSON3.read(JSON3.write([Symbol("before \" after")])) == ["before \" after"]

# @pretty
@testset "pretty.jl" begin
io = IOBuffer()
JSON3.pretty(io, 3.14)
@test String(take!(io)) == "3.14"
JSON3.pretty(io, "hey")
@test String(take!(io)) == "hey"
JSON3.pretty(io, "{}")
@test String(take!(io)) == "{\n}"
JSON3.pretty(io, "[]")
@test String(take!(io)) == "[\n]"
JSON3.pretty(io, (a=1, b=true, c=3.14, d="hey", e=(abcdefghijklmnopqrstuvwxyz=1000, aa=1e8, dd=[nothing, nothing, nothing, 3.14])), JSON3.AlignmentContext(alignment=:Colon, indent=2))
@test String(take!(io)) == """{
   "a": 1,
   "b": true,
   "c": 3.14,
   "d": "hey",
   "e": {
           "abcdefghijklmnopqrstuvwxyz": 1000,
                                   "aa": 100000000,
                                   "dd": [
                                           null,
                                           null,
                                           null,
                                           3.14
                                         ]
        }
}"""
JSON3.pretty(io, (a=1, b=true, c=3.14, d="hey", e=(abcdefghijklmnopqrstuvwxyz=1000, aa=1e8, dd=[nothing, nothing, nothing, 3.14])))
@test String(take!(io)) == """{
    "a": 1,
    "b": true,
    "c": 3.14,
    "d": "hey",
    "e": {
        "abcdefghijklmnopqrstuvwxyz": 1000,
        "aa": 100000000,
        "dd": [
            null,
            null,
            null,
            3.14
        ]
    }
}"""
JSON3.pretty(io, (a=1, b=D(1, 3.14, "cool")), JSON3.AlignmentContext(alignment=:Colon, indent=2))
@test String(take!(io)) == """{
   "a": 1,
   "b": {
           "a": 1,
           "b": 3.14,
           "c": "cool"
        }
}"""
JSON3.pretty(io, (a=1, b=D(1, 3.14, "cool")))
@test String(take!(io)) == """{
    "a": 1,
    "b": {
        "a": 1,
        "b": 3.14,
        "c": "cool"
    }
}"""

# 77
io = IOBuffer()
JSON3.pretty(io,  JSON3.write(Dict( "x" => Inf64), allow_inf=true), allow_inf=true )
@test String(take!(io)) == "{\n    \"x\": Infinity\n}"

end # @testset "pretty.jl"

# parsequoted
@test JSON3.read("{\"a\":\"10\",\"b\":\"1\",\"c\":\"45\",\"d\":\"100\"}", A; parsequoted=true) == A(10, 1, 45, 100)

json = "{\"a\": 1, \"b\": 2}\n{\"a\": 3, \"b\": 4}"
x = JSON3.read(json; jsonlines=true)
@test length(x) == 2
@test all(values(x[1]) .== (1, 2))

json = "1\r\n2\r\n3\r\n4\r\n5\r\n"
x = JSON3.read(json; jsonlines=true)
@test length(x) == 5
@test x == [1, 2, 3, 4, 5]

json = "1"
x = JSON3.read(json; jsonlines=true)
@test length(x) == 1
@test x == [1]

json = "  1\r\n\t2"
x = JSON3.read(json; jsonlines=true)
@test length(x) == 2
@test x == [1, 2]

# 171
for d_jsonl in [
    """
    { "a": 1,  "b": 3.14,  "c": "hey" }
    { "a": 2,  "b": 6.28,  "c": "hi"  }
    """,
    # No newline at end
    """
    { "a": 1,  "b": 3.14,  "c": "hey" }
    { "a": 2,  "b": 6.28,  "c": "hi"  }""",
    # No newline, extra whitespace at end
    """
    { "a": 1,  "b": 3.14,  "c": "hey" }
    { "a": 2,  "b": 6.28,  "c": "hi"  }   """,
    # Whitespace at start of line
    """
      { "a": 1,  "b": 3.14,  "c": "hey" }
      { "a": 2,  "b": 6.28,  "c": "hi"  }
    """,
    # Extra whitespace at beginning, end of lines, end of string
    " { \"a\": 1,  \"b\": 3.14,  \"c\": \"hey\" }  \n" *
    "  { \"a\": 2,  \"b\": 6.28,  \"c\": \"hi\"  }  \n  ",
]
    for nl in ["\n", "\r", "\r\n"]
        d_jsonl = replace(d_jsonl, "\n" => nl)
        dss = JSON3.read(d_jsonl, Vector{D}, jsonlines=true)

        @test length(dss) == 2
        @test dss[1].a == 1
        @test dss[1].b == 3.14
        @test dss[1].c == "hey"
        @test dss[2].a == 2
        @test dss[2].b == 6.28
        @test dss[2].c == "hi"

    end
end

# allow_inf consistency
@test_throws ArgumentError JSON3.read("-Infinity")

# https://discourse.julialang.org/t/json3-jl-parse-custom-type-with-nan/61295
str = JSON3.write(NaNStruct(NaN); allow_inf=true)
@test JSON3.read(str, NaNStruct; allow_inf=true).x === NaN

# https://github.com/quinnj/JSON3.jl/issues/172
@test JSON3.read("true", Union{Bool, Int})
@test JSON3.read("42", Union{Bool, Float64}) === 42.0

# https://github.com/quinnj/JSON3.jl/issues/187
x = System(duration=3600.0)
@test roundtrip(x).duration == x.duration

include("gentypes.jl")
include("stringnumber.jl")

# https://github.com/JuliaData/StructTypes.jl/issues/85
struct Struct1
    iarr::Vector{Integer}
end

StructTypes.StructType(::Type{Struct1}) = StructTypes.Struct()

s1 = Struct1([1,2,3,4,5]);
iob = IOBuffer();
JSON3.write(iob, s1);
s1_json = String(take!(iob))
s2 = JSON3.read(s1_json, Struct1)
@test s1.iarr == s2.iarr

# https://github.com/quinnj/JSON3.jl/issues/232
@test JSON3.write(3//2) == "1.5"
@test JSON3.write(π) == "3.141592653589793"

# https://github.com/quinnj/JSON3.jl/issues/242
@test JSON3.write(BigInt(-3)) == "-3"

# tests that we handle #undef correctly
x = UndefGuy()
x.id = 10
@test JSON3.write(x) == "{\"id\":10}"

y = Vector{UndefGuy}(undef, 2)
y[1] = x
@test JSON3.write(y) == "[{\"id\":10},null]"

# Arrow tests require a 64 bit system
@static if isdefined(Base, :get_extension) && Sys.WORD_SIZE == 64
    @testset "Arrow" include("arrow.jl")
end

# https://github.com/quinnj/JSON3.jl/issues/296
struct TypeWithoutExtraField
    a::Int
end
string_with_extra_field = "{\"a\": 1, \"b\": 2}"
@test JSON3.read(string_with_extra_field, TypeWithoutExtraField) == TypeWithoutExtraField(1)
@test_throws ArgumentError JSON3.read(string_with_extra_field, TypeWithoutExtraField, ignore_extra_fields=false)

end # @testset "JSON3"

@static if Base.VERSION < v"1.2"
    function hasfield(::Type{T}, name::Symbol) where {T}
        return name in fieldnames(T)
    end
    fieldtypes(::Type{T}) where {T} = Tuple(fieldtype(T, i) for i = 1:fieldcount(T))
end

# get the type from a named tuple, given a name
get_type(NT, k) = hasfield(NT, k) ? fieldtype(NT, k) : Nothing

# if a union contains two named tuples, unify them
# if union length is > 2, u.b will have continuing fields
function unify_union(u)
    if !isa(u.b, Union)
        # because of unify methods, only need to worry about unions with len > 2
        return u
    end

    # unions are sorted alphabetically, so pairs of super types will always be adjacent
    type = Union{}
    union_types = Base.uniontypes(u)
    i = 1
    while i <= Base.unionlen(u)
        cur = union_types[i]

        # no more nexts to compare to
        if i == Base.unionlen(u)
            type = Union{type,cur}
            break
        end

        next = union_types[i+1]
        if cur <: Vector && next <: Vector
            type = Union{type,unify(cur, next)}
            i += 2
        elseif cur <: NamedTuple && next <: NamedTuple
            type = Union{type,unify(cur, next)}
            i += 2
        else
            type = Union{type,cur}
            i += 1
        end
    end

    return type
end

# unify two types to a single type
function promoteunion(::Type{T}, ::Type{S}) where {T,S}
    new = promote_type(T, S)
    if !isabstracttype(new) && isconcretetype(new)
        return new
    else
        return unify_union(Union{T,S})
    end
end

# get the type of the contents
type_or_eltype(::Type{Vector{T}}) where {T} = T
type_or_eltype(::Type{T}) where {T} = T

unify(a::Type{T}, b::Type{S}) where {T,S} = promoteunion(T, S)
unify(a::Type{T}, b::Type{S}) where {T,S<:T} = T
unify(b::Type{S}, a::Type{T}) where {T,S<:T} = T
unify(a::Type{T}, b::Type{T}) where {T} = T
unify(a::Type{Any}, b::Type{T}) where {T} = T
unify(b::Type{T}, a::Type{Any}) where {T} = T
unify(a::Type{Any}, b::Type{Any}) = Any

function unify(
    a::Type{NamedTuple{A,T}},
    b::Type{NamedTuple{B,S}},
) where {A,T<:Tuple,B,S<:Tuple}
    ks = []
    ts = []
    for (k, v) in zip(A, fieldtypes(a))
        push!(ks, k)
        push!(ts, unify(v, get_type(b, k)))
    end

    for (k, v) in zip(B, fieldtypes(b))
        if !(k in ks)
            push!(ks, k)
            push!(ts, unify(v, Nothing))
        end
    end

    return NamedTuple{tuple(ks...),Tuple{ts...}}
end
unify(a::Type{NamedTuple{A,T}}, b::Type{NamedTuple{A,T}}) where {A,T<:Tuple} =
    NamedTuple{A,T}

unify(a::Type{Vector{T}}, b::Type{Vector{S}}) where {T,S} = Vector{unify(T, S)}
unify(a::Type{Vector{T}}, b::Type{Vector{T}}) where {T} = Vector{T}

# parse json into a type, maintain field order
"""
    JSON3.generate_type(json)

Given a JSON3 Object or Array, return a "raw type" from it.  A raw type is typically a `NamedTuple`, which can contain further nested `NamedTuples`, concrete, `Array`, or `Union` types.
"""
function generate_type(o::JSON3.Object)
    ks = []
    ts = []
    for (k, v) in o
        push!(ks, k)
        push!(ts, generate_type(v))
    end

    return NamedTuple{tuple(ks...),Tuple{ts...}}
end

function generate_type(a::JSON3.Array)
    if isempty(a)
        return Vector{Any}
    end

    t = Set([])
    nt = Any
    for item in a
        it = generate_type(item)
        if it <: NamedTuple
            nt = unify(nt, it)
        else
            push!(t, it)
        end
    end

    return Vector{foldl(unify, t; init = Union{nt})}
end

generate_type(x::T) where {T} = T

# get the AST of a type
function to_ast(::Type{T}) where {T}
    io = IOBuffer()
    print(io, T)
    str = String(take!(io))
    ast = Meta.parse(str)
    return ast
end

# make a field identifer into pascal case for struct name (my_names => MyName)
function pascalcase(s::Symbol)
    str = String(s)
    new_str = ""
    next_upper = true
    for letter in str
        if next_upper
            new_str *= uppercase(letter)
            next_upper = false
        elseif letter == '_'
            next_upper = true
        else
            new_str *= letter
        end
    end

    if length(new_str) > 1 && new_str[end] == 's' && new_str[end-1:end] != "ss"
        new_str = new_str[1:end-1]
    end

    return Symbol(new_str)
end

# remove line number nodes
function remove_line_numbers!(expr::Expr)
    filter!(x -> !isa(x, LineNumberNode), expr.args)
    for arg in expr.args
        remove_line_numbers!(arg)
    end
end
remove_line_numbers!(x) = nothing # no-op fallback

# collapse singleton blocks into just the contained Expr
function collapse_singleton_blocks!(expr::Expr)
    if expr.head == :block && length(expr.args) == 1
        expr.head = expr.args[1].head
        expr.args = expr.args[1].args
    end

    for arg in expr.args
        collapse_singleton_blocks!(arg)
    end
end
collapse_singleton_blocks!(x) = nothing # no-op fallback

isunion(expr::Expr) = expr.head == :curly && length(expr.args) > 0 && expr.args[1] == :Union
isunion(x) = false # fallback

# Union{A, Union{B, C}} => Union{A, B, C}
function collapse_unions!(expr::Expr)
    if isunion(expr) && isunion(expr.args[end])
        u = pop!(expr.args)
        append!(expr.args, u.args[2:3])
        collapse_unions!(expr) # catch more nested unions
    end

    for arg in expr.args
        collapse_unions!(arg)
    end
end
collapse_unions!(x) = nothing # no-op fallback

# from https://docs.julialang.org/en/v1/base/base/#Keywords
const RESERVED_WORDS = (
    :baremodule,
    :begin,
    :break,
    :catch,
    :const,
    :continue,
    :do,
    :else,
    :elseif,
    :end,
    :export,
    :false,
    :finally,
    :for,
    :function,
    :global,
    :if,
    :import,
    :let,
    :local,
    :macro,
    :module,
    :quote,
    :return,
    :struct,
    :true,
    :try,
    :using,
    :while,
)

is_valid_fieldname(x::Symbol) = Base.isidentifier(x) && !(x in RESERVED_WORDS)
is_valid_fieldname(x) = true # fallback for cases outside of x::Int

# end::Int => var"#JSON3_ESCAPE_THIS#end"::Int (the escape token gets removed later)
const JSON3_ESCAPE_TOKEN = "#JSON3_ESCAPE_THIS#"
@static if Base.VERSION < v"1.3"
    function escape_variable_names!(expr::Expr)
        if expr.head == :(::)
            if !is_valid_fieldname(expr.args[1])
                @warn """Invalid identifier found: $(expr.args[1]).

                In the types written to file, rename the field in the struct to a valid identifier and add a line `StructTypes.names(::Type{MyType}) = ((:julia_field_name, :json_field_name))` with the affected type, new Julia field name, and original JSON field name."""
            end
        else
            for arg in expr.args
                escape_variable_names!(arg)
            end
        end
    end
else
    function escape_variable_names!(expr::Expr)
        if expr.head == :(::)
            if !is_valid_fieldname(expr.args[1])
                # if the variable name is invalid, it will be escaped by `repr` later. This
                # token is used to force reserved keywords to be marked as invalid and will
                # be removed in `write_expr`..
                expr.args[1] = Symbol("$JSON3_ESCAPE_TOKEN$(expr.args[1])")
            end
        else
            for arg in expr.args
                escape_variable_names!(arg)
            end
        end
    end
end
escape_variable_names!(x) = nothing # no-op fallback

"""
    JSON3.write_exprs(expr, f)

Write an `Expr` or `Vector{Expr}` to file.  Formatted so that it can be used with `include`.
"""
function write_exprs(expr::Expr, io::IOStream)
    remove_line_numbers!(expr)
    collapse_unions!(expr)
    collapse_singleton_blocks!(expr)
    escape_variable_names!(expr)

    str = repr(expr)[3:end-1] # removes :( and )
    str = replace(str, "\n  " => "\n") # un-tab each line
    str = replace(str, JSON3_ESCAPE_TOKEN => "") # remove the escape token

    # better spacing
    str = replace(str, "end\n" => "end\n\n")
    str = replace(str, r"(module \w+)" => @s_str("\\1\n"))
    str = replace(str, r"(import \w+)" => @s_str("\\1\n"))
    str = str[1:end-3] * "\nend # module\n"

    Base.write(io, str)

    return nothing
end

function write_exprs(exprs::Vector, fname::AbstractString)
    open(fname, "w") do io
        for expr in exprs
            write_exprs(expr, io)
        end
    end
end

function write_exprs(expr::Expr, fname::AbstractString)
    open(fname, "w") do io
        write_exprs(expr, io)
    end
end

# entry function for turning a "raw" type from `generate_type` to Exprs
"""
    JSON3.generate_exprs(raw_type; root_name=:Root, mutable=true)

Generate a vector of `Expr` from a "raw_type".  This will un-nest any sub-types within the root type.

The name of the root type is from the `name` variable (default :Root), then nested types are named from the key that they live under in the JSON.  The key is transformed to be pascal case and singular.

If `mutable` is `true`, an empty constructor is included in the struct definition. This allows the mutable structs to be used with `StructTypes.Mutable()` out of the box.
"""
function generate_exprs(t; root_name::Symbol = :Root, mutable = true)
    exprs = []
    generate_expr!(exprs, t, root_name; mutable = mutable, is_root = true)
    return exprs
end

# turn a "raw" type into an AST for a struct
function generate_expr!(
    exprs,
    nt::Type{NamedTuple{N,T}},
    root_name::Symbol;
    mutable::Bool = true,
    kwargs...,
) where {N,T<:Tuple}
    sub_exprs = []
    for (n, t) in zip(N, fieldtypes(nt))
        push!(sub_exprs, generate_field_expr!(exprs, t, n; mutable = mutable))
    end
    struct_name = pascalcase(root_name)
    struct_exprs = filter(e -> e.head == :struct && e.args[2] == struct_name, exprs)
    if length(struct_exprs) > 0 # already a struct with this name, augment it
        new_struct_name = replace(String(gensym(struct_name)), "#" => "")
        @info "struct with name $struct_name already exists, changing name to $new_struct_name"
        struct_name = Symbol(new_struct_name)
    end

    if mutable
        push!(sub_exprs, Meta.parse("$struct_name() = new()"))
    end

    push!(exprs, Expr(:struct, mutable, struct_name, Expr(:block, sub_exprs...)))

    return struct_name
end

# If at the root of a JSON expression, use the vectors type as the type, otherwise, generate
# with the vector still wrapping the type
function generate_expr!(
    exprs,
    ::Type{Base.Array{T,N}},
    root_name::Symbol;
    is_root::Bool = false,
    kwargs...,
) where {T<:NamedTuple,N}
    if is_root
        return generate_expr!(exprs, T, root_name; kwargs...)
    else
        return Expr(:curly, :Array, generate_expr!(exprs, T, root_name; kwargs...), 1)
    end
end

function generate_expr!(exprs, t::Type{T}, root_name::Symbol; kwargs...) where {T}
    if T isa Union
        return Expr(
            :curly,
            :Union,
            generate_expr!(exprs, t.a, root_name; kwargs...),
            generate_expr!(exprs, t.b, root_name; kwargs...),
        )
    else
        return to_ast(T)
    end
end

# given the type of a field of a struct, return a node for that field's name/type
function generate_field_expr!(
    exprs,
    t::Type{NamedTuple{N,T}},
    root_name::Symbol;
    kwargs...,
) where {N,T}
    struct_name = generate_expr!(exprs, t, root_name; kwargs...)
    return Expr(:(::), root_name, struct_name)
end

function generate_field_expr!(
    exprs,
    ::Type{Base.Array{T,N}},
    root_name::Symbol;
    kwargs...,
) where {T,N}
    return Expr(
        :(::),
        root_name,
        Expr(:curly, :Array, generate_expr!(exprs, T, root_name; kwargs...), 1),
    )
end

function generate_field_expr!(exprs, ::Type{T}, root_name::Symbol; kwargs...) where {T}
    return Expr(:(::), root_name, generate_expr!(exprs, T, root_name; kwargs...))
end

# create a module with the struct declarations as well as the StructType declarations
"""
    JSON3.generate_struct_type_module(exprs, module_name)

Given a vector of `exprs` (output of [`generate_exprs`](@ref)), return an `Expr` containing the AST for a module with name `module_name`.  The module will map all types to the appropriate `StructType`, so the result can immediately used with `JSON3.read(json, T)`.
"""
function generate_struct_type_module(exprs, module_name)
    mutable = exprs[1].args[1]
    struct_type_import = Meta.parse("import StructTypes")
    struct_type = mutable ? "Mutable" : "Struct"
    struct_type_decls = []
    for expr in exprs
        push!(
            struct_type_decls,
            Meta.parse(
                "StructTypes.StructType(::Type{$(expr.args[2])}) = StructTypes.$struct_type()",
            ),
        )
    end
    type_block = Expr(:block, struct_type_import, exprs..., struct_type_decls...)
    return Expr(:module, true, module_name, type_block)
end

"""
    JSON3.generatetypes(json, module_name; mutable=true, root_name=:Root)

Convenience function to go from a json string, an array of json strings, or a file name to an AST with a module of structs.

Performs the following:
1. If the JSON is a file, read to string
2. Call `JSON3.read` on the JSON string
3. Get the "raw type" from [`generate_type`](@ref)
4. Parse the "raw type" into a vector of `Expr` ([`generate_exprs`](@ref))
5. Generate an AST with the module containg the structs ([`generate_struct_type_module`](@ref))
"""
function generatetypes(
    json_str::AbstractString,
    module_name::Symbol;
    mutable::Bool = true,
    root_name::Symbol = :Root,
)
    # either a JSON.Array or JSON.Object
    json = read(json_str)
    raw_json_type = generate_type(json)
    json_exprs = generate_exprs(raw_json_type; root_name = root_name, mutable = mutable)
    return generate_struct_type_module(json_exprs, module_name)
end

function generatetypes(
    json_str::Vector{<:AbstractString},
    module_name::Symbol;
    mutable::Bool = true,
    root_name::Symbol = :Root,
)
    # either a JSON.Array or JSON.Object
    json = read.(json_str)
    # build a type for the JSON
    raw_json_type = reduce(unify, type_or_eltype.(generate_type.(json)); init = Any)
    json_exprs = generate_exprs(raw_json_type; root_name = root_name, mutable = mutable)
    return generate_struct_type_module(json_exprs, module_name)
end

# macro to create a module with types generated from a json string
"""
    JSON3.@generatetypes json [module_name]

Evaluate the result of the [`generatetypes`](@ref) function in the current scope.
"""
macro generatetypes(json_str, module_name)
    :(Core.eval($__module__, generatetypes($(esc(json_str)), $(esc(module_name)))))
end

macro generatetypes(json)
    :(@generatetypes $(esc(json)) :JSONTypes)
end

# convenience function to go from json_string, to file with module
"""
    JSON3.writetypes(json, file_name; module_name=:JSONTypes, root_name=:Root, mutable=true)

Write the result of the [`generatetypes`](@ref) function to file.
"""
function writetypes(
    json,
    file_name;
    module_name::Symbol = :JSONTypes,
    root_name::Symbol = :Root,
    mutable::Bool = true,
)
    mod = generatetypes(json, module_name; mutable = mutable, root_name = root_name)
    write_exprs(mod, file_name)
end

using JSON3, StructTypes, BenchmarkTools

mutable struct T
    a::Int
    b::Float64
    c::String
    null::Nothing
    maybe::Union{Int, Nothing}
    T() = new()
end

JSON3.StructType(::Type{T}) = JSON3.Mutable()
StructTypes.StructType(::Type{T}) = StructTypes.Mutable()

@btime JSON3.read("{}", T)

@btime JSON3.read(b"""
{
    "a": 1,
    "b": 3.14,
    "c": "hey",
    "null": null,
    "maybe": 10
}""", T)

# master:   4.114 μs (62 allocations: 6.70 KiB)
# 0.1.13:    3.784 μs (16 allocations: 400 bytes)
# new:   950.759 ns (11 allocations: 432 bytes)

"""
    JSON3.@pretty json_str

Pretty print a JSON string or an object as JSON.
"""
macro pretty(json)
    return esc(:(JSON3.pretty($json)))
end

"""
    JSON3.AlignmentContext(alignment=:Left, indent=4, level=0, offset=0)

Specifies the indentation of a pretty JSON string.

## Keyword Args
* `alignment`: A Symbol specifying the alignment type. Can be `:Left` to left-align
               everything or `:Colon` to align at the `:`.
* `indent`: The number of spaces to indent each new level with.
* `level`: The indentation level.
* `offset`: The indentation offset.
"""
Base.@kwdef mutable struct AlignmentContext
    alignment::Symbol = :Left
    indent::UInt16 = 4
    level::UInt16 = 0
    offset::UInt16 = 0
    function AlignmentContext(alignment, indent, level, offset)
        if alignment != :Left && alignment != :Colon
            throw(ArgumentError("Alignment :$(alignment) is not supported. " * 
                                 "Only `:Left` and `:Colon` are supported so far"))
        end
        new(alignment, indent, level, offset)
    end
end

"""
    JSON3.pretty(x, ac=JSON3.AlignmentContext(); kw...)
    JSON3.pretty(io, x, ac=JSON3.AlignmentContext(); kw...)

Pretty print a JSON string.

## Args

* `x`: A JSON string, or an object to write to JSON then pretty print.
* `io`: The `IO` object to write the pretty printed string to. [default `stdout`]
* `ac`: The `AlignmentContext` for the pretty printing. Defaults to left-aligned
        with 4 spaces indent. See [`JSON3.AlignmentContext`](@ref) for more options.

## Keyword Args

See [`JSON3.write`](@ref) and [`JSON3.read`](@ref).
"""
pretty(str, ac=AlignmentContext(); kw...) = pretty(stdout, str, ac; kw...)
pretty(out::IO, x, ac=AlignmentContext(); kw...) = pretty(out, JSON3.write(x; kw...), ac; kw...)
function pretty(out::IO, str::AbstractString, ac=AlignmentContext(); kw...)
    buf = codeunits(str)
    len = length(buf)
    if len == 0
        return
    end
    pos = 1
    b = getbyte(buf, pos)
    @wh
    # printing object?
    if b == UInt8('{')
        Base.write(out, "{\n")

        obj = JSON3.read(str; kw...)

        if length(obj) == 0
            Base.write(out, ' '^(ac.indent * ac.level + ac.offset) * "}")
            return
        end

        ks = collect(keys(obj))
        maxlen = maximum(map(sizeof, ks)) + 5
        ac.alignment == :Colon && (ac.offset += maxlen)
        ac.level += 1

        i = 1
        for (key, value) in obj
            Base.write(out, ' '^(ac.level * ac.indent))
            Base.write(out, lpad("\"$(key)\"" * ": ", ac.offset, ' '))
            pretty(out, JSON3.write(value; kw...), ac; kw...)
            if i == length(obj)
                ac.level -= 1
                ac.alignment == :Colon && (ac.offset -= maxlen)
                Base.write(out, "\n" * ' '^(ac.indent * ac.level + ac.offset) * "}")
            else
                Base.write(out, ",\n")
                i += 1
            end
        end
    # printing array?
    elseif b == UInt8('[')
        Base.write(out, "[\n")

        arr = JSON3.read(str; kw...)

        if length(arr) == 0
            Base.write(out, ' '^(ac.indent * ac.level + ac.offset) * "]")
            return
        end

        ac.level += 1

        for (i, val) in enumerate(arr)
            Base.write(out, ' '^(ac.indent * ac.level + ac.offset))
            pretty(out, JSON3.write(val; kw...), ac; kw...)
            if i == length(arr)
                ac.level -= 1
                Base.write(out, "\n" * ' '^(ac.indent * ac.level + ac.offset) * "]")
            else
                Base.write(out, ",\n")
            end
        end
    # printing constant?
    else
        Base.write(out, str)
    end
    return
@label invalid
    Base.error("error pretty-fying json: $error")
end

using Arrow

obj1 = JSON3.read("""
{
    "int": 1,
    "float": 2.1
}
""")

obj2 = JSON3.read("""
{
    "int": 1,
    "float": 2.1,
    "bool1": true,
    "bool2": false,
    "none": null,
    "str": "\\"hey there sailor\\"",
    "arr": [null, 1, "hey"],
    "arr2": [1.2, 3.4, 5.6]
}
""")

obj3 = JSON3.read("""
{
    "int": 1,
    "float": 2.1,
    "bool1": true,
    "bool2": false,
    "none": null,
    "str": "\\"hey there sailor\\"",
    "obj": {
                "a": 1,
                "b": null,
                "c": [null, 1, "hey"],
                "d": [1.2, 3.4, 5.6]
            },
    "arr": [null, 1, "hey"],
    "arr2": [1.2, 3.4, 5.6]
}
""")

tbl = (; json=[obj1, obj2, obj3])

arrow = Arrow.Table(Arrow.tobuffer(tbl))
@test tbl.json == arrow.json

# temporary wrapper to pass byte vector through
struct VectorString{T <: AbstractVector{UInt8}} <: AbstractString
    bytes::T
end

Base.codeunits(x::VectorString) = x.bytes

# high-level user API functions
read(io::Union{IO, Base.AbstractCmd}; kw...) = read(Base.read(io, String); kw...)
read(bytes::AbstractVector{UInt8}; kw...) = read(VectorString(bytes); kw...)

"""
    JSON3.read(json, [type]; kw... )

Read JSON.

## Args

* `json`: A file, string, IO, or bytes (`AbstractVector{UInt8`) containing JSON to read
* `type`: Optionally, a type to read the JSON into. If not a [built in type](#Builtin-types), must have a "struct mapping" registered with [StructTypes.jl](#Struct-API).

## Keyword Args

* `jsonlines`: A Bool indicating that the `json_str` contains newline delimited JSON strings, which will be read into a `JSON3.Array` of the JSON values.  See [jsonlines](https://jsonlines.org/) for reference. [default `false`]
* `allow_inf`: Allow reading of `Inf` and `NaN` values (not part of the JSON standard). [default `false`]
* `dateformat`: A [`DateFormat`](https://docs.julialang.org/en/v1/stdlib/Dates/#Dates.DateFormat) describing the format of dates in the JSON so that they can be read into `Date`s, `Time`s, or `DateTime`s when reading into a type. [default `Dates.default_format(T)`]
* `parsequoted`: Accept quoted values when reading into a NumberType. [default `false`]
* `numbertype`: Type to parse numbers as. [default `nothing`, which parses numbers as Int if possible, Float64 otherwise]
* `ignore_extra_fields`: Ignore extra fields in the JSON when reading into a struct. [default `true`]
"""
function read(json::AbstractString; jsonlines::Bool=false,
              numbertype::Union{DataType, Nothing}=nothing, kw...)
    return parse(read_json_str(json); jsonlines, numbertype, kw...)
end

function parse(str::AbstractString; jsonlines::Bool=false,
               numbertype::Union{DataType, Nothing}=nothing, kw...)
    buf = codeunits(str)
    len = length(buf)
    if len == 0
        error = UnexpectedEOF
        pos = 0
        @goto invalid
    end
    pos = 1
    b = getbyte(buf, pos)
    @wh
    tape = len < 1000 ? Vector{UInt64}(undef, len + 4) :
        Vector{UInt64}(undef, div(len, 10))
    if numbertype === nothing
        checkint = true
    elseif numbertype == Float64
        checkint = false
    else
        throw(ArgumentError("numbertype $numbertype is not supported. " *
                            "Only `nothing` (default) and `Float64` are supported so far."))
    end
    if jsonlines
        pos, tapeidx = jsonlines!(buf, pos, len, b, tape, Int64(1), checkint; kw...)
    else
        pos, tapeidx = read!(buf, pos, len, b, tape, Int64(1), Any, checkint; kw...)
    end
    @inbounds t = tape[1]
    if isobject(t)
        obj = Object(buf, tape, Dict{Symbol, Int}())
        populateinds!(obj)
        return obj
    elseif isarray(t)
        arr = Array{geteltype(tape[2])}(buf, tape, Int[])
        populateinds!(arr)
        return arr
    else
        return getvalue(Any, buf, tape, 1, t)
    end
@label invalid
    invalid(error, buf, pos, Any)
end

function parsefile(fname::AbstractString; jsonlines::Bool=false,
                   numbertype::Union{DataType, Nothing}=nothing, kw...)
    return parse(VectorString(Mmap.mmap(fname)); jsonlines, numbertype, kw...)
end

macro check()
    esc(quote
        if (tapeidx + 1) > length(tape)
            newsize = ceil(Int64, ((1 - pos / len) + 1) * tapeidx) + 20
            # println("resizing tape from $(pointer(tape)) $tapeidx to $newsize")
            resize!(tape, newsize)
        end
    end)
end

const FLOAT_INT_BOUND = 2.0^53

function read!(buf, pos, len, b, tape, tapeidx, ::Type{Any}, checkint=true; allow_inf::Bool=false)
    if b == UInt8('{')
        return read!(buf, pos, len, b, tape, tapeidx, Object, checkint; allow_inf=allow_inf)
    elseif b == UInt8('[')
        return read!(buf, pos, len, b, tape, tapeidx, Array, checkint; allow_inf=allow_inf)
    elseif b == UInt8('"')
        return read!(buf, pos, len, b, tape, tapeidx, String)
    elseif b == UInt8('n')
        return read!(buf, pos, len, b, tape, tapeidx, Nothing)
    elseif b == UInt8('t')
        return read!(buf, pos, len, b, tape, tapeidx, True)
    elseif b == UInt8('f')
        return read!(buf, pos, len, b, tape, tapeidx, False)
    elseif (UInt8('0') <= b <= UInt8('9')) || b == UInt8('-') || b == UInt8('+') || (allow_inf && (b == UInt8('N') || b == UInt8('I')))
        float, code, floatpos = Parsers.typeparser(Float64, buf, pos, len, b, Int16(0), Parsers.OPTIONS)
        if code > 0
            !isfinite(float) && !allow_inf && @goto invalid
            @check
            # if, for example, we've already parsed floats in an array, just keep them all as floats and don't check for ints
            if checkint
                fp, ip = modf(float)
                if fp == 0 && Float64(typemin(Int64)) <= float <= Float64(typemax(Int64))
                    # ok great, we know the number is integral and pretty much in Int64 range
                    if -FLOAT_INT_BOUND < float < FLOAT_INT_BOUND
                        # easy case, integer w/ less than or equal to 53-bits of precision
                        int = unsafe_trunc(Int64, float)
                    else
                        # if our integral float is > 53-bit precision, we need to reparse the Int so we don't get a lossy conversion
                        # there are also a few floats that satisfy Float64(typemin(Int64)) <= float <= Float64(typemax(Int64))
                        # that actually overflow Int64, like -9223372036854775809 and 9223372036854775808
                        # in those cases, we're going to verify that this Int64 parsing doesn't overflow
                        int, code, floatpos2 = Parsers.typeparser(Int64, buf, pos, len, b, Int16(0), Parsers.OPTIONS)
                        if floatpos2 < floatpos
                            # ah, but there's one more case we need to handle: a > 53-bit precision integer given in
                            # exponent form, like 1e17 or 9.007199254740994e15; in those cases, the truncation to Int64 *isn't* lossy
                            int = unsafe_trunc(Int64, float)
                        end
                    end
                    if code > 0
                        @inbounds tape[tapeidx] = INT
                        @inbounds tape[tapeidx + 1] = Core.bitcast(UInt64, int)
                        return floatpos, tapeidx + 2
                    end
                end
            end
            @inbounds tape[tapeidx] = FLOAT
            @inbounds tape[tapeidx + 1] = Core.bitcast(UInt64, float)
            return floatpos, tapeidx + 2
        end
        invalid(InvalidNumber, buf, pos, Float64)
    end
@label invalid
    invalid(InvalidChar, buf, pos, Any)
end

function read!(buf, pos, len, b, tape, tapeidx, ::Type{String})
    pos += 1
    @eof
    strpos = pos
    strlen = Int64(0)
    escaped = false
    b = getbyte(buf, pos)
    while b != UInt8('"')
        if b == UInt8('\\')
            escaped = true
            # skip next character
            pos += 2
            strlen += 2
        elseif b < UInt8(' ')
            unescaped_control(b)
        else
            pos += 1
            strlen += 1
        end
        @eof
        b = getbyte(buf, pos)
    end
    @check
    @inbounds tape[tapeidx] = string(strlen)
    @inbounds tape[tapeidx+1] = ifelse(escaped, ESCAPE_BIT | strpos, strpos)
    return pos + 1, tapeidx + 2

@label invalid
    invalid(error, buf, pos, String)
end

struct True end
function read!(buf, pos, len, b, tape, tapeidx, ::Type{True})
    if pos + 3 <= len &&
        b            == UInt8('t') &&
        buf[pos + 1] == UInt8('r') &&
        buf[pos + 2] == UInt8('u') &&
        buf[pos + 3] == UInt8('e')
        @check
        @inbounds tape[tapeidx] = BOOL | UInt64(1)
        return pos + 4, tapeidx + 2
    else
        invalid(InvalidChar, buf, pos, True)
    end
end

struct False end
function read!(buf, pos, len, b, tape, tapeidx, ::Type{False})
    if pos + 4 <= len &&
        b            == UInt8('f') &&
        buf[pos + 1] == UInt8('a') &&
        buf[pos + 2] == UInt8('l') &&
        buf[pos + 3] == UInt8('s') &&
        buf[pos + 4] == UInt8('e')
        @check
        @inbounds tape[tapeidx] = BOOL
        return pos + 5, tapeidx + 2
    else
        invalid(InvalidChar, buf, pos, False)
    end
end

function read!(buf, pos, len, b, tape, tapeidx, ::Type{Nothing})
    if pos + 3 <= len &&
        b            == UInt8('n') &&
        buf[pos + 1] == UInt8('u') &&
        buf[pos + 2] == UInt8('l') &&
        buf[pos + 3] == UInt8('l')
        @check
        @inbounds tape[tapeidx] = NULL
        return pos + 4, tapeidx + 2
    else
        invalid(InvalidChar, buf, pos, Nothing)
    end
end

function read!(buf, pos, len, b, tape, tapeidx, ::Type{Object}, checkint=true; kw...)
    objidx = tapeidx
    eT = EMPTY
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    if b == UInt8('}')
        @check
        @inbounds tape[tapeidx] = object(Int64(2))
        @inbounds tape[tapeidx+1] = eltypelen(eT, Int64(0))
        tapeidx += 2
        pos += 1
        @goto done
    elseif b != UInt8('"')
        error = ExpectedOpeningQuoteChar
        @goto invalid
    end
    pos += 1
    @eof
    tapeidx += 2
    nelem = Int64(0)
    while true
        keypos = pos
        keylen = Int64(0)
        escaped = false
        # read first key character
        b = getbyte(buf, pos)
        # positioned at first character of object key
        while b != UInt8('"')
            if b == UInt8('\\')
                escaped = true
                # skip next character
                pos += 2
                keylen += 2
            else
                pos += 1
                keylen += 1
            end
            @eof
            b = getbyte(buf, pos)
        end
        @check
        @inbounds tape[tapeidx] = string(keylen)
        @inbounds tape[tapeidx+1] = ifelse(escaped, ESCAPE_BIT | keypos, keypos)
        tapeidx += 2
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8(':')
            error = ExpectedSemiColon
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        # now positioned at start of value
        prevtapeidx = tapeidx
        pos, tapeidx = read!(buf, pos, len, b, tape, tapeidx, Any, checkint; kw...)
        @eof
        b = getbyte(buf, pos)
        @wh
        @inbounds eT = promoteeltype(eT, gettypemask(tape[prevtapeidx]))
        nelem += 1
        if b == UInt8('}')
            @check
            @inbounds tape[objidx] = object(tapeidx - objidx)
            @inbounds tape[objidx+1] = eltypelen(eT, nelem)
            pos += 1
            @goto done
        elseif b != UInt8(',')
            error = ExpectedComma
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8('"')
            error = ExpectedOpeningQuoteChar
            @goto invalid
        end
        pos += 1
        @eof
    end

@label done
    return pos, tapeidx
@label invalid
    invalid(error, buf, pos, Object)
end

function read!(buf, pos, len, b, tape, tapeidx, ::Type{Array}, checkint=true; kw...)
    arridx = tapeidx
    eT = EMPTY
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    if b == UInt8(']')
        @check
        @inbounds tape[tapeidx] = array(Int64(2))
        @inbounds tape[tapeidx+1] = eltypelen(eT, Int64(0))
        tapeidx += 2
        pos += 1
        @goto done
    end
    tapeidx += 2
    nelem = Int64(0)
    while true
        # positioned at start of value
        prevtapeidx = tapeidx
        check_int = checkint ? eT != FLOAT && eT != (FLOAT | NULL) : false
        pos, tapeidx = read!(buf, pos, len, b, tape, tapeidx, Any, check_int; kw...)
        @eof
        b = getbyte(buf, pos)
        @wh
        @inbounds eT = promoteeltype(eT, gettypemask(tape[prevtapeidx]))
        nelem += 1
        if b == UInt8(']')
            @check
            @inbounds tape[arridx] = array(tapeidx - arridx)
            @inbounds tape[arridx+1] = eltypelen(eT, nelem)
            pos += 1
            @goto done
        elseif b != UInt8(',')
            error = ExpectedComma
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
    end

@label done
    return pos, tapeidx
@label invalid
    invalid(error, buf, pos, Array)
end

function jsonlines!(buf, pos, len, b, tape, tapeidx, checkint=true; kw...)
    arridx = tapeidx
    eT = EMPTY
    if pos > len
        @check
        @inbounds tape[tapeidx] = array(Int64(2))
        @inbounds tape[tapeidx+1] = eltypelen(eT, Int64(0))
        tapeidx += 2
        @goto done
    end
    tapeidx += 2
    nelem = Int64(0)
    while true
        @wh
        # positioned at start of value
        prevtapeidx = tapeidx
        check_int = checkint ? eT != FLOAT && eT != (FLOAT | NULL) : false
        pos, tapeidx = read!(buf, pos, len, b, tape, tapeidx, Any, check_int; kw...)
        @inbounds eT = promoteeltype(eT, gettypemask(tape[prevtapeidx]))
        nelem += 1
        if pos > len
            @check
            @inbounds tape[arridx] = array(tapeidx - arridx)
            @inbounds tape[arridx+1] = eltypelen(eT, nelem)
            @goto done
        end
        b = getbyte(buf, pos)
        if b != UInt8('\n') && b != UInt8('\r')
            error = ExpectedNewline
            @goto invalid
        end
        pos += 1
        if pos > len
            @check
            @inbounds tape[arridx] = array(tapeidx - arridx)
            @inbounds tape[arridx+1] = eltypelen(eT, nelem)
            @goto done
        end
        if b == UInt8('\r')
            b = getbyte(buf, pos)
            if b == UInt8('\n')
                pos += 1
                if pos > len
                    @check
                    @inbounds tape[arridx] = array(tapeidx - arridx)
                    @inbounds tape[arridx+1] = eltypelen(eT, nelem)
                    @goto done
                end
            end
        end
        b = getbyte(buf, pos)
    end

@label done
    return pos, tapeidx
@label invalid
    invalid(error, buf, pos, Array)
end

@testset "Generate Types" begin

    menu = """
    {
      "menu": {
        "header": "SVG Viewer",
        "items": [
          {
            "id": "Open"
          },
          {
            "id": "OpenNew",
            "label": "Open New"
          },
          {
            "id": "ZoomIn",
            "label": "Zoom In"
          },
          {
            "id": "ZoomOut",
            "label": "Zoom Out"
          },
          {
            "id": "OriginalView",
            "label": "Original View"
          },
          {
            "id": "Quality"
          },
          {
            "id": "Pause"
          },
          {
            "id": "Mute"
          },
          null,
          {
            "id": "Find",
            "label": "Find..."
          },
          {
            "id": "FindAgain",
            "label": "Find Again"
          },
          {
            "id": "Copy"
          },
          {
            "id": "CopyAgain",
            "label": "Copy Again"
          },
          {
            "id": "CopySVG",
            "label": "Copy SVG"
          },
          {
            "id": "ViewSVG",
            "label": "View SVG"
          },
          {
            "id": "ViewSource",
            "label": "View Source"
          },
          {
            "id": "SaveAs",
            "label": "Save As"
          },
          null,
          {
            "id": "Help"
          },
          {
            "id": "About",
            "label": "About Adobe SVG Viewer..."
          }
        ]
      }
    }
    """

    menu_array = """
    [
        {
          "menu": {
            "header": "SVG Viewer",
            "items": [
              {
                "id": "Open"
              },
              {
                "id": "OpenNew",
                "label": "Open New"
              },
              {
                "id": "ZoomIn",
                "label": "Zoom In"
              },
              {
                "id": "ZoomOut",
                "label": "Zoom Out"
              },
              {
                "id": "OriginalView",
                "label": "Original View"
              },
              {
                "id": "Quality"
              },
              {
                "id": "Pause"
              },
              {
                "id": "Mute"
              },
              null,
              {
                "id": "Find",
                "label": "Find..."
              },
              {
                "id": "FindAgain",
                "label": "Find Again"
              },
              {
                "id": "Copy"
              },
              {
                "id": "CopyAgain",
                "label": "Copy Again"
              },
              {
                "id": "CopySVG",
                "label": "Copy SVG"
              },
              {
                "id": "ViewSVG",
                "label": "View SVG"
              },
              {
                "id": "ViewSource",
                "label": "View Source"
              },
              {
                "id": "SaveAs",
                "label": "Save As"
              },
              null,
              {
                "id": "Help"
              },
              {
                "id": "About",
                "label": "About Adobe SVG Viewer..."
              }
            ]
          }
        },
        {
          "menu": {
            "header": "A second item",
            "items": [
              {
                "id": "Open"
              },
              {
                "id": "OpenNew",
                "label": "Open New"
              }
            ]
          }
        }
    ]
    """

    @testset "Object & Array" begin
        json = JSON3.read(menu) # JSON.Object

        # build a type for the JSON
        raw_json_type = JSON3.generate_type(json)
        @test raw_json_type <: NamedTuple

        # turn the type into struct expressions, including replacing sub types with references to a struct
        json_exprs = JSON3.generate_exprs(raw_json_type; root_name = :MyStruct)
        @test length(json_exprs) == 3

        # write the types to a file, then can be edited/included as needed
        path = mktempdir()
        file = joinpath(path, "test_type.jl")
        JSON3.write_exprs(json_exprs, file)
        lines = readlines(file)
        @test length(lines) > 3

        json_arr = JSON3.read(menu_array) # JSON.Array

        # build a type for the JSON
        raw_json_arr_type = JSON3.generate_type(json_arr)
        @test raw_json_arr_type <: Array

        # turn the type into struct expressions, including replacing sub types with references to a struct
        json_arr_exprs = JSON3.generate_exprs(raw_json_arr_type; root_name = :MyStruct)
        @test length(json_arr_exprs) == 3

        # write the types to a file, then can be edited/included as needed
        path = mktempdir()
        file_arr = joinpath(path, "test_arr.jl")
        JSON3.write_exprs(json_arr_exprs, file_arr)
        arr_lines = readlines(file_arr)
        @test length(arr_lines) > 3
        @test arr_lines == lines
    end

    @testset "Write & Read" begin
        path = mktempdir()
        file_path_default = joinpath(path, "default.jl")
        JSON3.writetypes(menu, file_path_default)

        include(file_path_default)
        json = JSON3.read(menu, JSONTypes.Root)

        @test json.menu.header == "SVG Viewer"
        @test length(json.menu.items) > 0
        @test json.menu.items[1].id == "Open"

        @test fieldnames(JSONTypes.Item) == (:id, :label)

        file_path_json = joinpath(path, "menu_array.json")
        Base.write(file_path_json, menu_array)
        file_path_mod = joinpath(path, "my_mod.jl")
        JSON3.writetypes(
            file_path_json,
            file_path_mod;
            module_name = :MyMod,
            root_name = :MenuArray,
        )

        include(file_path_mod)
        json_arr = JSON3.read(menu_array, Vector{MyMod.MenuArray})
        @test length(json_arr) == 2
        @test json_arr[1].menu.header == "SVG Viewer"
    end

    @testset "Struct" begin
        json = """
            [
                {"a": 1, "b": 2, "c": {"d": 4}},
                {"a": "w", "b": 5, "c": {"d": 4}},
                {"a": 3, "b": 4, "c": {"d": 6}},
                {"a": 7, "b": 7, "c": {"d": 7}}
            ]
        """

        path = mktempdir()
        file_path = joinpath(path, "struct.jl")

        JSON3.writetypes(json, file_path; mutable = false)
        include(file_path)
        parsed = JSON3.read(json, Vector{JSONTypes.Root})

        @test !ismutable(parsed[1])
        @test parsed[1].c.d == 4
        @test fieldtype(JSONTypes.Root, 1) == Union{Int64,String}
    end

    @testset "Array of Samples" begin
        jsons = [
            """{"a": 1, "b": 2, "c": {"d": 4}}""",
            """{"a": "w", "b": 5, "c": {"d": 4}}""",
            """{"a": 3, "b": 4, "c": {"d": 6}}""",
            """{"a": 7, "b": 7, "c": {"d": 7}}""",
        ]

        path = mktempdir()
        file_path = joinpath(path, "struct.jl")

        JSON3.writetypes(jsons, file_path; mutable = false)
        include(file_path)
        parsed = JSON3.read(jsons[1], JSONTypes.Root)

        @test !ismutable(parsed)
        @test parsed.c.d == 4

        weird_jsons = [
            """{"a": 1, "b": 2, "c": {"d": 4}}""",
            """[{"a": "w"}, {"b": 5}, {"c": {"d": 4}}]""",
            """{"x": 7}""",
        ]

        JSON3.writetypes(weird_jsons, file_path)
        include(file_path)

        parsed = JSON3.read(weird_jsons[1], JSONTypes.Root)
        @test parsed.c.d == 4

        parsed = JSON3.read(weird_jsons[3], JSONTypes.Root)
        @test parsed.x == 7
        @test !isdefined(parsed, :a)

        # Issue #209
        daily_menu = """{
            "object":"page",
            "date":"23.03.2022"
        }"""
        dishes = """{
            "object":"list",
            "results":[
                {
                    "object":"dish",
                    "name":"Spaghetti"
                }
            ]
        }"""

        JSON3.@generatetypes [daily_menu, dishes]

        new_daily_menu = """{
            "object":"page",
            "date":"24.03.2022"
        }"""
        new_dishes = """{
            "object":"list",
            "results":[
                {
                    "object":"dish",
                    "name":"Pizza"
                }
            ]
        }"""

        menu_struct = JSON3.read(new_daily_menu, JSONTypes.Root)
        dishes_struct = JSON3.read(new_dishes, JSONTypes.Root)
        @test dishes_struct.results[1].object == "dish"
    end

    @testset "Raw Types" begin
        json = """
            [
                {"a": 1, "b": 2, "c": 5},
                {"a": "w", "b": 5, "c": 9},
                {"a": 3, "b": 4, "c": 2},
                {"a": 7, "b": 7, "c": 0}
            ]
        """
        parsed = JSON3.read(json) # JSON.Array

        # build a type for the JSON
        raw_json_type = JSON3.generate_type(parsed)
        @test raw_json_type <: Array

        res = JSON3.read(json, raw_json_type)
        @test isa(res, raw_json_type)

        @test res[4].b == 7

        json = """{"a": 1, "b": 2, "c": 5}"""
        parsed = JSON3.read(json) # JSON.Object

        # build a type for the JSON
        raw_json_type = JSON3.generate_type(parsed)
        @test raw_json_type <: NamedTuple

        res = JSON3.read(json, raw_json_type)
        @test isa(res, raw_json_type)

        @test res.b == 2

        empty_json = "[]"
        raw_json_type = JSON3.generate_type(JSON3.read(empty_json))
        @test raw_json_type === Vector{Any}

        two_json = """[[], [\"hello\"]]"""
        raw_json_type = JSON3.generate_type(JSON3.read(two_json))
        @test raw_json_type === Vector{Vector{String}}

        @test JSON3.unify(Any, Any) == Any
        @test JSON3.unify(Any, Int64) == Int64
        @test JSON3.unify(Int64, Any) == Int64
        @test JSON3.unify(Int64, String) == Union{Int64,String}
        @test JSON3.unify(Float64, Union{Int64,String}) == Union{Float64,Int64,String}
        @test JSON3.unify(Float64, Real) == Real
        @test JSON3.unify(Float64, Union{Int64,Float64}) == Union{Int64,Float64}
        @test JSON3.unify(Union{Int64,Float64}, Float64) == Union{Int64,Float64}
        @test JSON3.unify(Float64, Float64) == Float64
        @test JSON3.unify(Vector{Int64}, Vector{Int64}) == Vector{Int64}
        @test JSON3.unify(NamedTuple{(:d,),Tuple{Int64}}, NamedTuple{(:d,),Tuple{Int64}}) ==
              NamedTuple{(:d,),Tuple{Int64}}
        @test JSON3.unify(
            NamedTuple{(:d,),Tuple{Int64}},
            NamedTuple{(:d,),Tuple{String}},
        ) == NamedTuple{(:d,),Tuple{Union{Int64,String}}}
        @test JSON3.unify(
            Union{Nothing,NamedTuple{(:d,),Tuple{Int64}}},
            NamedTuple{(:d,),Tuple{String}},
        ) == Union{Nothing,NamedTuple{(:d,),Tuple{Union{Int64,String}}}}
        @test JSON3.unify(
            Union{Nothing,NamedTuple{(:d,),Tuple{Int64}},String},
            NamedTuple{(:d,),Tuple{String}},
        ) == Union{Nothing,NamedTuple{(:d,),Tuple{Union{Int64,String}}},String}
        @test JSON3.unify(
            Union{Nothing,Vector{NamedTuple{(:d,),Tuple{Int64}}}},
            Vector{NamedTuple{(:d,),Tuple{String}}},
        ) == Union{Nothing,Vector{NamedTuple{(:d,),Tuple{Union{Int64,String}}}}}
    end

    @testset "Pascal Case" begin
        @test JSON3.pascalcase(:items) == :Item
        @test JSON3.pascalcase(:i) == :I
        @test JSON3.pascalcase(:is) == :I
        @test JSON3.pascalcase(:daisies) == :Daisie # don't let perfect be the enemy of good?
        @test JSON3.pascalcase(:ties) == :Tie
        @test JSON3.pascalcase(:my_types) == :MyType
        @test JSON3.pascalcase(:witness) == :Witness
    end

    @testset "Macro" begin
        JSON3.@generatetypes(menu)
        json = JSON3.read(menu, JSONTypes.Root)

        @test json.menu.header == "SVG Viewer"
        @test length(json.menu.items) > 0
        @test json.menu.items[1].id == "Open"

        @test fieldnames(JSONTypes.Item) == (:id, :label)

        JSON3.@generatetypes(menu_array, :MyMod)
        json_arr = JSON3.read(menu_array, Vector{MyMod.Root})
        @test length(json_arr) == 2
        @test json_arr[1].menu.header == "SVG Viewer"
    end

    @testset "Var Names" begin
        json_str = """{"end": 1, "##invalid##": 2}"""
        JSON3.@generatetypes(json_str)
        json = JSON3.read(json_str, JSONTypes.Root)

        @test json.end == 1
        @test getproperty(json, Symbol("##invalid##")) == 2

        # on lower versions of julia, there is a warning for the user to act on
        @static if Base.VERSION >= v"1.3"
            path = mktempdir()
            file_path = joinpath(path, "struct.jl")

            JSON3.writetypes(json_str, file_path; module_name = :KeywordType)
            include(file_path)
            parsed = JSON3.read(json_str, KeywordType.Root)

            @test parsed.end == 1
            @test getproperty(parsed, Symbol("##invalid##")) == 2
        end
    end

    @testset "Duplicate Names" begin
        json_str = """
        {
            "label": {
                "type": "alert",
                "label": [
                    {
                        "type": "text",
                        "text": {
                            "content": "Open New",
                            "label": {
                                "text": "open"
                            }
                        }
                    }
                ]
            }
        }
        """
        JSON3.@generatetypes(json_str)
        json = JSON3.read(json_str, JSONTypes.Root)
        @test json.label.label[1].text.label.text == "open"
    end
end

import StructTypes: StructType, CustomStruct, DictType, ArrayType, StringType, NumberType, BoolType, NullType, NoStructType, SingletonType, Struct, OrderedStruct, Mutable, construct, AbstractType, subtypes, subtypekey

struct RawType <: StructType end

struct RawValue{S}
    bytes::S
    pos::Int
    len::Int
end

function rawbytes end

read(io::Union{IO, Base.AbstractCmd}, ::Type{T}; kw...) where {T} = read(Base.read(io, String), T; kw...)
read(bytes::AbstractVector{UInt8}, ::Type{T}; kw...) where {T} = read(VectorString(bytes), T; kw...)

function _prepare_read(str::AbstractString, ::Type{T}) where {T}
    buf = codeunits(str)
    len = length(buf)
    if len == 0
        error = UnexpectedEOF
        pos = 0
        @goto invalid
    end
    pos = 1
    b = getbyte(buf, pos)
    @wh
    return buf, pos, len, b
@label invalid
    invalid(error, buf, pos, T)
end

function parse(str::AbstractString, ::Type{T}; jsonlines::Bool=false, kw...) where {T}
    buf, pos, len, b = _prepare_read(str, T)
    if jsonlines
        if StructType(T) != ArrayType()
            throw(ArgumentError("expect StructType($T) == StructTypes.ArrayType() when jsonlines=true"))
        end
        pos, x = readjsonlines(buf, pos, len, b, T; kw...)
    else
        pos, x = read(StructType(T), buf, pos, len, b, T; kw...)
    end
    return x
end

function read(str::AbstractString, ::Type{T}; jsonlines::Bool=false, kw...) where {T}
    return parse(read_json_str(str), T; jsonlines, kw...)
end

function parsefile(fname::AbstractString, ::Type{T}; jsonlines::Bool=false, kw...) where {T}
    return parse(VectorString(Mmap.mmap(fname)), T; jsonlines, kw...)
end

"""
    JSON3.read!(json_str, x; kw...)

Incrementally update an instance of a mutable object `x` with the contents of `json_str`.  See [`JSON3.read`](@ref) for more details.
"""
function read!(str::AbstractString, x::T; kw...) where {T}
    buf, pos, len, b = _prepare_read(read_json_str(str), T)
    pos, x = read!(StructType(T), buf, pos, len, b, T, x; kw...)
    return x
end

read(::NoStructType, buf, pos, len, b, ::Type{T}; kw...) where {T} = throw(ArgumentError("$T doesn't have a defined `StructTypes.StructType`"))

# https://github.com/quinnj/JSON3.jl/issues/172
# treat Union{Bool, Real} as non-StructTypes.NumberType so parsing works as expected
read(::NumberType, buf, pos, len, b, S::Type{Union{Bool, T}}; kw...) where {T <: Real} =
    read(Struct(), buf, pos, len, b, S; kw...)
# https://github.com/quinnj/JSON3.jl/issues/187
# without this, `Real` dispatches to the above definition
read(::NumberType, buf, pos, len, b, ::Type{Real}; kw...) =
    read(NumberType(), buf, pos, len, b, Union{Float64, Int64}; kw...)
read(::NumberType, buf, pos, len, b, ::Type{Integer}; kw...) =
    read(NumberType(), buf, pos, len, b, Int64; kw...)

@generated function read(::Struct, buf, pos, len, b, T::Union; kw...)
    U = first(T.parameters) # Extract Union from Type
    # Julia implementation detail: Unions are sorted :)
    # This lets us avoid the below try-catch when U <: Union{Missing,T}
    if U.a === Nothing || U.a === Missing
        :(if buf[pos] == UInt8('n')
            return read(StructType($(U.a)), buf, pos, len, b, $(U.a))
        else
            return read(StructType($(U.b)), buf, pos, len, b, $(U.b); kw...)
        end)
    else
        return :(
            try
                return read(StructType($(U.a)), buf, pos, len, b, $(U.a); kw...)
            catch e
                return read(StructType($(U.b)), buf, pos, len, b, $(U.b); kw...)
            end
        )
    end
end

const GLOBAL_IGNORED_TAPE = zeros(UInt64, 1024)

@inline function read(::RawType, buf, pos, len, b, ::Type{T}; kw...) where {T}
    newpos, _ = read!(buf, pos, len, b, GLOBAL_IGNORED_TAPE, 1, Any; kw...)
    return newpos, construct(T, RawValue(buf, pos, newpos - pos))
end

@inline function read(::Struct, buf, pos, len, b, ::Type{Any}; allow_inf::Bool=false, kw...)
    if b == UInt8('{')
        return read(DictType(), buf, pos, len, b, Dict{String, Any}; allow_inf=allow_inf, kw...)
    elseif b == UInt8('[')
        return read(ArrayType(), buf, pos, len, b, Base.Array{Any}; allow_inf=allow_inf, kw...)
    elseif b == UInt8('"')
        return read(StringType(), buf, pos, len, b, String; kw...)
    elseif b == UInt8('n')
        return read(NullType(), buf, pos, len, b, Nothing; kw...)
    elseif b == UInt8('t')
        return read(BoolType(), buf, pos, len, b, Bool; kw...)
    elseif b == UInt8('f')
        return read(BoolType(), buf, pos, len, b, Bool; kw...)
    elseif (UInt8('0') <= b <= UInt8('9')) || b == UInt8('-') || b == UInt8('+') || (allow_inf && (b == UInt8('N') || b == UInt8('I')))
        float, code, pos = Parsers.typeparser(Float64, buf, pos, len, b, Int16(0), Parsers.OPTIONS)
        if code > 0
            int = unsafe_trunc(Int64, float)
            if int == float
                return pos, int
            else
                return pos, float
            end
        end
    end
@label invalid
    invalid(InvalidChar, buf, pos, Any)
end

function read(::StringType, buf, pos, len, b, ::Type{T}; kw...) where {T}
    if b != UInt8('"')
        error = ExpectedOpeningQuoteChar
        @goto invalid
    end
    pos += 1
    @eof
    strpos = pos
    strlen = 0
    escaped = false
    b = getbyte(buf, pos)
    while b != UInt8('"')
        if b == UInt8('\\')
            escaped = true
            # skip next character
            pos += 2
            strlen += 2
        else
            pos += 1
            strlen += 1
        end
        @eof
        b = getbyte(buf, pos)
    end
    ptr = pointer(buf, strpos)
    return pos + 1, escaped ? construct(T, unescape(PointerString(ptr, strlen)); kw...) : construct(T, ptr, strlen; kw...)

@label invalid
    invalid(error, buf, pos, T)
end

function read(::BoolType, buf, pos, len, b, ::Type{T}; kw...) where {T}
    if pos + 3 <= len &&
        b            == UInt8('t') &&
        buf[pos + 1] == UInt8('r') &&
        buf[pos + 2] == UInt8('u') &&
        buf[pos + 3] == UInt8('e')
        return pos + 4, construct(T, true; kw...)
    elseif pos + 4 <= len &&
        b            == UInt8('f') &&
        buf[pos + 1] == UInt8('a') &&
        buf[pos + 2] == UInt8('l') &&
        buf[pos + 3] == UInt8('s') &&
        buf[pos + 4] == UInt8('e')
        return pos + 5, construct(T, false; kw...)
    else
        invalid(InvalidChar, buf, pos, Bool)
    end
end

function read(::NullType, buf, pos, len, b, ::Type{T}; kw...) where {T}
    if pos + 3 <= len &&
        b            == UInt8('n') &&
        buf[pos + 1] == UInt8('u') &&
        buf[pos + 2] == UInt8('l') &&
        buf[pos + 3] == UInt8('l')
        return pos + 4, construct(T, nothing; kw...)
    else
        invalid(InvalidChar, buf, pos, T)
    end
end

function read(::NumberType, buf, pos, len, b, ::Type{T}; parsequoted::Bool=false, kw...) where {T}
    quoted = false
    if parsequoted && b == UInt8('"')
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        quoted = true
    end
    x, code, pos = Parsers.typeparser(StructTypes.numbertype(T), buf, pos, len, b, Int16(0), Parsers.OPTIONS)
    if quoted
        b = getbyte(buf, pos)
        @assert b == UInt8('"')
        pos += 1
    end
    if code > 0
        return pos, construct(T, x; kw...)
    end
@label invalid
    invalid(InvalidChar, buf, pos, T)
end

@inline read(::ArrayType, buf, pos, len, b, ::Type{T}; kw...) where {T} = read(ArrayType(), buf, pos, len, b, T, Base.IteratorEltype(T) == Base.HasEltype() ? eltype(T) : Any; kw...)
@inline read(::ArrayType, buf, pos, len, b, ::Type{T}, ::Type{eT}; kw...) where {T, eT} = readarray(buf, pos, len, b, T, eT; kw...)
read(::ArrayType, buf, pos, len, b, ::Type{Tuple}, ::Type{eT}; kw...) where {eT} = readarray(buf, pos, len, b, Tuple, eT; kw...)

function readarray(buf, pos, len, b, ::Type{T}, ::Type{eT}; kw...) where {T, eT}
    if b != UInt8('[')
        error = ExpectedOpeningArrayChar
        @goto invalid
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    vals = Vector{eT}(undef, 0)
    if b == UInt8(']')
        return pos + 1, construct(T, vals; kw...)
    end
    while true
        # positioned at start of value
        pos, y = read(StructType(eT), buf, pos, len, b, eT; kw...)
        push!(vals, y)
        @eof
        b = getbyte(buf, pos)
        @wh
        if b == UInt8(']')
            return pos + 1, construct(T, vals; kw...)
        elseif b != UInt8(',')
            error = ExpectedComma
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
    end

@label invalid
    invalid(error, buf, pos, T)
end

@inline readjsonlines(buf, pos, len, b, ::Type{T}; kw...) where {T} = readjsonlines(buf, pos, len, b, T, Base.IteratorEltype(T) == Base.HasEltype() ? eltype(T) : Any; kw...)
@inline readjsonlines(buf, pos, len, b, ::Type{T}, ::Type{eT}; kw...) where {T, eT} = readjsonlinesarray(buf, pos, len, b, T, eT; kw...)

function readjsonlinesarray(buf, pos, len, b, ::Type{T}, ::Type{eT}; kw...) where {T, eT}
    vals = Vector{eT}(undef, 0)
    while true
        # positioned at start of value
        @wh_done  # remove spaces and tabs, jump to done on eof
        pos, y = read(StructType(eT), buf, pos, len, b, eT; kw...)
        push!(vals, y)
        if pos > len
            @goto done
        end
        b = getbyte(buf, pos)
        @wh_done  # remove spaces and tabs, jump to done on eof
        if b != UInt8('\n') && b != UInt8('\r')
            error = ExpectedNewline
            @goto invalid
        end
        pos += 1
        if pos > len
            @goto done
        end
        if b == UInt8('\r')  # Previous byte was \r, look for \n
            b = getbyte(buf, pos)
            if b == UInt8('\n')
                pos += 1
                if pos > len
                    @goto done
                end
            end
        end
        b = getbyte(buf, pos)
    end
@label done
    return pos, construct(T, vals; kw...)
@label invalid
    invalid(error, buf, pos, T)
end

mutable struct TupleClosure{T, KW}
    buf::T
    pos::Int
    len::Int
    b::UInt8
    kw::KW
end

@inline function (f::TupleClosure)(i, nm, TT)
    buf, pos, len, b = f.buf, f.pos, f.len, f.b
    pos, x = read(StructType(TT), buf, pos, len, b, TT; f.kw...)
    @eof
    b = getbyte(buf, pos)
    @wh
    if b == UInt8(']')
        f.pos = pos + 1
        return x
    elseif b == UInt8(',')
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        f.pos = pos
        f.b = b
        return x
    else
        error = ExpectedComma
        @goto invalid
    end
@label invalid
    invalid(error, buf, pos, TT)
end

@inline function read(::ArrayType, buf, pos, len, b, ::Type{T}, ::Type{eT}; kw...) where {T <: Tuple, eT}
    if b != UInt8('[')
        error = ExpectedOpeningArrayChar
        @goto invalid
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    if b == UInt8(']')
        pos += 1
        return pos, T()
    end
    c = TupleClosure(buf, pos, len, b, values(kw))
    x = StructTypes.construct(c, T)

    return c.pos, x
@label invalid
    invalid(error, buf, pos, T)
end

keyvalue(::Type{Symbol}, escaped, ptr, len) = escaped ? Symbol(unescape(PointerString(ptr, len))) : _symbol(ptr, len)
keyvalue(::Type{T}, escaped, ptr, len) where {T} = escaped ? construct(T, unescape(PointerString(ptr, len))) : construct(T, unsafe_string(ptr, len))

@inline read(::DictType, buf, pos, len, b, ::Type{T}; kw...) where {T} = read(DictType(), buf, pos, len, b, T, Symbol, Any; kw...)
@inline read(::Struct, buf, pos, len, b, ::Type{NamedTuple}; kw...) = read(DictType(), buf, pos, len, b, NamedTuple, Symbol, Any; kw...)
@inline read(::Struct, buf, pos, len, b, ::Type{NamedTuple{names}}; kw...) where {names} = read(DictType(), buf, pos, len, b, NamedTuple{names}, Symbol, Any; kw...)
@inline read(::DictType, buf, pos, len, b, ::Type{Dict}; kw...) = read(DictType(), buf, pos, len, b, Dict, String, Any; kw...)
@inline read(::DictType, buf, pos, len, b, ::Type{T}; kw...) where {T <: AbstractDict} = read(DictType(), buf, pos, len, b, T, keytype(T), valtype(T); kw...)

@inline function read(::DictType, buf, pos, len, b, ::Type{T}, ::Type{K}, ::Type{V}; kw...) where {T, K, V}
    if b != UInt8('{')
        error = ExpectedOpeningObjectChar
        @goto invalid
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    x = Dict{K, V}()
    if b == UInt8('}')
        return pos + 1, construct(T, x; kw...)
    elseif b != UInt8('"')
        error = ExpectedOpeningQuoteChar
        @goto invalid
    end
    pos += 1
    @eof
    while true
        keypos = pos
        keylen = 0
        escaped = false
        # read first key character
        b = getbyte(buf, pos)
        # positioned at first character of object key
        while b != UInt8('"')
            if b == UInt8('\\')
                escaped = true
                # skip next character
                pos += 2
                keylen += 2
            else
                pos += 1
                keylen += 1
            end
            @eof
            b = getbyte(buf, pos)
        end
        key = keyvalue(K, escaped, pointer(buf, keypos), keylen)
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8(':')
            error = ExpectedSemiColon
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        # now positioned at start of value
        pos, y = read(StructType(V), buf, pos, len, b, V; kw...)
        x[key] = y
        @eof
        b = getbyte(buf, pos)
        @wh
        if b == UInt8('}')
            return pos + 1, construct(T, x; kw...)
        elseif b != UInt8(',')
            error = ExpectedComma
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8('"')
            error = ExpectedOpeningQuoteChar
            @goto invalid
        end
        pos += 1
        @eof
    end

@label invalid
    invalid(error, buf, pos, Object)
end

@inline function read(::CustomStruct, buf, pos, len, b, ::Type{T}; kw...) where {T}
    S = StructTypes.lowertype(T)
    pos, x = read(StructType(S), buf, pos, len, b, S; kw...)
    return pos, StructTypes.construct(T, x)
end

mutable struct MutableClosure{T, KW}
    buf::T
    pos::Int
    len::Int
    b::UInt8
    kw::KW
end

@inline function (f::MutableClosure)(i, nm, TT; kw...)
    kw2 = merge(values(kw), f.kw)
    pos_i, y_i = read(StructType(TT), f.buf, f.pos, f.len, f.b, TT; kw2...)
    f.pos = pos_i
    return y_i
end

@inline function read(::Mutable, buf, pos, len, b, ::Type{T}; kw...) where {T}
    x = T()
    pos, x = read!(Mutable(), buf, pos, len, b, T, x; kw...)
    return pos, x
end

@inline function read!(::Any, buf, pos, len, b, ::Type{T}, x::T; kw...) where {T}
    throw(ArgumentError("read! is only defined when T is of the `Mutable` struct type"))
end

function read!(::Mutable, buf, pos, len, b, ::Type{T}, x::T; kw...) where {T}
    if b != UInt8('{')
        error = ExpectedOpeningObjectChar
        @goto invalid
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    if b == UInt8('}')
        pos += 1
        return pos, x
    elseif b != UInt8('"')
        error = ExpectedOpeningQuoteChar
        @goto invalid
    end
    pos += 1
    @eof
    while true
        keypos = pos
        keylen = 0
        escaped = false
        b = getbyte(buf, pos)
        while b != UInt8('"')
            if b == UInt8('\\')
                escaped = true
                # skip next character
                pos += 2
                keylen += 2
            else
                pos += 1
                keylen += 1
            end
            @eof
            b = getbyte(buf, pos)
        end
        key = keyvalue(Symbol, escaped, pointer(buf, keypos), keylen)
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8(':')
            error = ExpectedSemiColon
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        c = MutableClosure(buf, pos, len, b, values(kw))
        if StructTypes.applyfield!(c, x, key)
            pos = c.pos
        else
            pos, _ = read(Struct(), buf, pos, len, b, Any)
        end
        @eof
        b = getbyte(buf, pos)
        @wh
        if b == UInt8('}')
            pos += 1
            return pos, x
        elseif b != UInt8(',')
            error = ExpectedComma
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8('"')
            error = ExpectedOpeningQuoteChar
            @goto invalid
        end
        pos += 1
        @eof
    end

@label invalid
    invalid(error, buf, pos, T)
end

mutable struct StructClosure{T, KW}
    buf::T
    pos::Int
    len::Int
    b::UInt8
    values::Vector{Any}
    kw::KW
end

@inline function (f::StructClosure)(i, nm, TT; kw...)
    kw2 = merge(values(kw), f.kw)
    pos_i, y_i = read(StructType(TT), f.buf, f.pos, f.len, f.b, TT; kw2...)
    f.pos = pos_i
    f.values[i] = y_i
    return
end

function read(::Struct, buf, pos, len, b, ::Type{T}; ignore_extra_fields::Bool=true, kw...) where {T}
    values = Vector{Any}(undef, fieldcount(T))
    if b != UInt8('{')
        error = ExpectedOpeningObjectChar
        @goto invalid
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    if b == UInt8('}')
        pos += 1
        @goto done
    elseif b != UInt8('"')
        error = ExpectedOpeningQuoteChar
        @goto invalid
    end
    pos += 1
    @eof
    while true
        keypos = pos
        keylen = 0
        escaped = false
        b = getbyte(buf, pos)
        while b != UInt8('"')
            if b == UInt8('\\')
                escaped = true
                # skip next character
                pos += 2
                keylen += 2
            else
                pos += 1
                keylen += 1
            end
            @eof
            b = getbyte(buf, pos)
        end
        key = keyvalue(Symbol, escaped, pointer(buf, keypos), keylen)
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8(':')
            error = ExpectedSemiColon
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        c = StructClosure(buf, pos, len, b, values, Base.values(kw))
        if StructTypes.applyfield(c, T, key)
            pos = c.pos
        else
            if ignore_extra_fields
                pos, _ = read(Struct(), buf, pos, len, b, Any)
            else
                error = ExtraField
                @goto invalid
            end
        end
        @eof
        b = getbyte(buf, pos)
        @wh
        if b == UInt8('}')
            pos += 1
            @goto done
        elseif b != UInt8(',')
            error = ExpectedComma
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8('"')
            error = ExpectedOpeningQuoteChar
            @goto invalid
        end
        pos += 1
        @eof
    end

@label done
    return pos, StructTypes.construct(values, T)

@label invalid
    invalid(error, buf, pos, T)
end

mutable struct OrderedStructClosure{T, KW}
    buf::T
    pos::Int
    len::Int
    kw::KW
end

@inline function (f::OrderedStructClosure)(i, nm, TT)
    pos_i, x_i = readvalue(f.buf, f.pos, f.len, TT; f.kw...)
    f.pos = pos_i
    return x_i
end

@inline function read(::OrderedStruct, buf, pos, len, b, ::Type{T}; kw...) where {T}
    if b != UInt8('{')
        error = ExpectedOpeningObjectChar
        @goto invalid
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    if b == UInt8('}')
        pos += 1
        @goto done
    elseif b != UInt8('"')
        error = ExpectedOpeningQuoteChar
        @goto invalid
    end
    pos += 1
    @eof
    c = OrderedStructClosure(buf, pos, len, values(kw))
    x = StructTypes.construct(c, T)
    return c.pos, x

@label done
    return pos, StructTypes.construct(values, T)

@label invalid
    invalid(error, buf, pos, T)
end

@inline function readvalue(buf, pos, len, ::Type{T}; kw...) where {T}
    b = getbyte(buf, pos)
    while b != UInt8('"')
        pos += ifelse(b == UInt8('\\'), 2, 1)
        @eof
        b = getbyte(buf, pos)
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    if b != UInt8(':')
        error = ExpectedSemiColon
        @goto invalid
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    # read value
    pos, y = read(StructType(T), buf, pos, len, b, T; kw...)
    @eof
    b = getbyte(buf, pos)
    @wh
    if b == UInt8('}')
        pos += 1
        return pos, y
    elseif b != UInt8(',')
        error = ExpectedComma
        @goto invalid
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    if b != UInt8('"')
        error = ExpectedOpeningQuoteChar
        @goto invalid
    end
    pos += 1
    @eof
    return pos, y
@label invalid
    invalid(error, buf, pos, T)
end

@inline function read(::AbstractType, buf, pos, len, b, ::Type{T}; kw...) where {T}
    types = subtypes(T)
    if length(types) == 1
        only_subtype = types[1]
        return read(StructType(only_subtype), buf, pos, len, b, only_subtype; kw...)
    end
    return _read(AbstractType(), buf, pos, len, b, T; kw...)
end

@inline function _read(::AbstractType, buf, pos, len, b, ::Type{T}; kw...) where {T}
    startpos = pos
    startb = b
    if b != UInt8('{')
        error = ExpectedOpeningObjectChar
        @goto invalid
    end
    pos += 1
    @eof
    b = getbyte(buf, pos)
    @wh
    if b == UInt8('}')
        throw(ArgumentError("invalid json abstract type"))
    elseif b != UInt8('"')
        error = ExpectedOpeningQuoteChar
        @goto invalid
    end
    pos += 1
    @eof
    types = subtypes(T)
    skey = subtypekey(T)
    while true
        keypos = pos
        keylen = 0
        escaped = false
        b = getbyte(buf, pos)
        while b != UInt8('"')
            if b == UInt8('\\')
                escaped = true
                # skip next character
                pos += 2
                keylen += 2
            else
                pos += 1
                keylen += 1
            end
            @eof
            b = getbyte(buf, pos)
        end
        key = keyvalue(Symbol, escaped, pointer(buf, keypos), keylen)
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8(':')
            error = ExpectedSemiColon
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        # read value
        pos, val = read(Struct(), buf, pos, len, b, Any)
        if key == skey
            TT = types[Symbol(val)]
            return read(StructType(TT), buf, startpos, len, startb, TT; kw...)
        end
        @eof
        b = getbyte(buf, pos)
        @wh
        if b == UInt8('}')
            pos += 1
            throw(ArgumentError("invalid json abstract type: didn't find subtypekey"))
        elseif b != UInt8(',')
            error = ExpectedComma
            @goto invalid
        end
        pos += 1
        @eof
        b = getbyte(buf, pos)
        @wh
        if b != UInt8('"')
            error = ExpectedOpeningQuoteChar
            @goto invalid
        end
        pos += 1
        @eof
    end

@label invalid
    invalid(error, buf, pos, T)
end

_symbol(ptr, len) = ccall(:jl_symbol_n, Ref{Symbol}, (Ptr{UInt8}, Int), ptr, len)

function getbyte(buf, pos)
    unsafe_load(pointer(buf.s), pos)
end

function getbyte(buf::AbstractVector{UInt8}, pos)
    @inbounds b = buf[pos]
    return b
end

macro eof()
    esc(quote
        if pos > len
            error = UnexpectedEOF
            @goto invalid
        end
    end)
end

macro wh()
    esc(quote
        while b == UInt8('\t') || b == UInt8(' ') || b == UInt8('\n') || b == UInt8('\r')
            pos += 1
            if pos > len
                error = UnexpectedEOF
                @goto invalid
            end
            b = getbyte(buf, pos)
        end
    end)
end

macro wh_done()
    esc(quote
        while b == UInt8(' ') || b == UInt8('\t')
            pos += 1
            if pos > len
                @goto done
            end
            b = getbyte(buf, pos)
        end
    end)
end

const EMPTY   = UInt64(0b00000000) << 56
const OBJECT  = UInt64(0b00000001) << 56
const ARRAY   = UInt64(0b00000010) << 56
const STRING  = UInt64(0b00000100) << 56
const INT     = UInt64(0b00001000) << 56
const FLOAT   = UInt64(0b00010000) << 56
const BOOL    = UInt64(0b00100000) << 56
const NULL    = UInt64(0b01000000) << 56
const ANY     = UInt64(0b10000000) << 56

const TYPEMASK = 0xff00000000000000

empty(x::UInt64) = (x & TYPEMASK) == EMPTY
isany(x::UInt64) = (x & TYPEMASK) == ANY
isobject(x::UInt64) = (x & TYPEMASK) == OBJECT
isarray(x::UInt64) = (x & TYPEMASK) == ARRAY
isstring(x::UInt64) = (x & TYPEMASK) == STRING
isint(x::UInt64) = (x & TYPEMASK) == INT
isfloat(x::UInt64) = (x & TYPEMASK) == FLOAT
isbool(x::UInt64) = (x & TYPEMASK) == BOOL
isnull(x::UInt64) = (x & TYPEMASK) == NULL
isintfloat(x::UInt64) = (x & TYPEMASK) == (INT | FLOAT)
nonnull(x::UInt64) = (x & TYPEMASK) & ~NULL

function geteltype(T)
    if empty(T); return Union{}
    elseif isany(T); return Any
    elseif isobject(T); return Object
    elseif isarray(T); return Array
    elseif isstring(T); return String
    elseif isint(T); return Int64
    elseif isfloat(T); return Float64
    elseif isbool(T); return Bool
    elseif isnull(T); return Nothing
    elseif isintfloat(T); return Union{Int64, Float64}
    else return Union{geteltype(nonnull(T)), Nothing}
    end
end

object(tapelen) = OBJECT | Core.bitcast(UInt64, tapelen)
array(tapelen)  = ARRAY  | Core.bitcast(UInt64, tapelen)
eltypelen(T, len) = T | Core.bitcast(UInt64, len)
string(len) = STRING | Core.bitcast(UInt64, len)
const ESCAPE_BIT = UInt64(1) << 63

function promoteeltype(A, B)
    if A == B
        return A
    elseif A == EMPTY
        return B
    elseif (A | B) == A
        return A
    elseif A == INT && B == FLOAT
        return A | B
    elseif A == FLOAT && B == INT
        return A | B
    elseif A == (INT | NULL) && B == FLOAT
        return A | B
    elseif A == (FLOAT | NULL) && B == INT
        return A | B
    elseif A == NULL || B == NULL
        return A | B
    else
        return ANY
    end
end

gettypemask(x::UInt64) = x & TYPEMASK
getnontypemask(x::UInt64) = Core.bitcast(Int64, x & ~TYPEMASK)
getpos(x::UInt64) = Core.bitcast(Int64, getnontypemask(x) >> 16)
getlen(x::UInt64) = Core.bitcast(Int64, x & 0x000000000000ffff)

gettapelen(T, x::UInt64) = ifelse(isobject(x) | isarray(x), getnontypemask(x), 2)
gettapelen(::Union{Type{Int64}, Type{Float64}, Type{Bool}, Type{Nothing}}) = 2

regularstride(T) = false
regularstride(::Union{Type{Int64}, Type{Float64}, Type{Bool}, Type{Nothing}}) = true
regularstride(::Type{Union{Int64, Float64}}) = true

function getvalue(::Type{Object}, buf, tape, tapeidx, t)
    x = Object(buf, Base.unsafe_view(tape, tapeidx:tapeidx + getnontypemask(t)), Dict{Symbol, Int}())
    populateinds!(x)
    return x
end

function getvalue(::Type{Array}, buf, tape, tapeidx, t)
    T = tape[tapeidx+1]
    ttape = Base.unsafe_view(tape, tapeidx:tapeidx + getnontypemask(t))
    inds = Int[]
    if empty(T)
        x = Array{Union{},typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    elseif isany(T)
        x = Array{Any,typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    elseif isobject(T)
        x = Array{Object,typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    elseif isarray(T)
        x = Array{Array,typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    elseif isstring(T)
        x = Array{String,typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    elseif isint(T)
        x = Array{Int64,typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    elseif isfloat(T)
        x = Array{Float64,typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    elseif isbool(T)
        x = Array{Bool,typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    elseif isnull(T)
        x = Array{Nothing,typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    elseif isintfloat(T)
        x = Array{Union{Int64, Float64},typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    else
        x = Array{Union{geteltype(nonnull(T)), Nothing},typeof(buf),typeof(ttape)}(buf, ttape, inds)
        populateinds!(x)
        return x
    end
end

function getvalue(::Type{Symbol}, buf, tape, tapeidx, t)
    @inbounds t2 = tape[tapeidx + 1]
    if (t2 & ESCAPE_BIT) == ESCAPE_BIT
        return Symbol(unescape(PointerString(pointer(buf, getnontypemask(t2)), getnontypemask(t))))
    else
        return _symbol(pointer(buf, getnontypemask(t2)), getnontypemask(t))
    end
end
function getvalue(::Type{String}, buf, tape, tapeidx, t)
    @inbounds t2 = tape[tapeidx + 1]
    if (t2 & ESCAPE_BIT) == ESCAPE_BIT
        return unescape(PointerString(pointer(buf, getnontypemask(t2)), getnontypemask(t)))
    else
        return unsafe_string(pointer(buf, getnontypemask(t2)), getnontypemask(t))
    end
end
function getvalue(::Type{Int64}, buf, tape, tapeidx, t)
    @inbounds x = Core.bitcast(Int64, tape[tapeidx+1])
    return x
end
function getvalue(::Type{Float64}, buf, tape, tapeidx, t)
    @inbounds x = Core.bitcast(Float64, tape[tapeidx+1])
    return x
end
function getvalue(::Type{Union{Int64, Float64}}, buf, tape, tapeidx, t)
    @inbounds x = tape[tapeidx+1]
    return Core.bitcast(ifelse(isint(t), Int64, Float64), x)
end
getvalue(::Type{Bool}, buf, tape, tapeidx, t) = getnontypemask(t) == UInt64(1)
getvalue(::Type{Nothing}, buf, tape, tapeidx, t) = nothing
@inline function getvalue(T, buf, tape, tapeidx, t)
    if isobject(t)
        return getvalue(Object, buf, tape, tapeidx, t)
    elseif isarray(t)
        return getvalue(Array, buf, tape, tapeidx, t)
    elseif isstring(t)
        return getvalue(String, buf, tape, tapeidx, t)
    elseif isint(t)
        return getvalue(Int64, buf, tape, tapeidx, t)
    elseif isfloat(t)
        return getvalue(Float64, buf, tape, tapeidx, t)
    elseif isbool(t)
        return getvalue(Bool, buf, tape, tapeidx, t)
    elseif isnull(t)
        return nothing
    end
end

Base.@pure function symbolin(names::Tuple{Vararg{Symbol}}, name::Symbol)
    for nm in names
        nm === name && return true
    end
    return false
end

function read_json_str(json)
    # length check is to ensure that isfile doesn't thrown an error
    # see issue for details https://github.com/JuliaLang/julia/issues/39774
    !(json isa VectorString) && sizeof(json) < 255 && isfile(json) ?
          VectorString(Mmap.mmap(json)) : 
          json
end

defaultminimum(::Union{Nothing, Missing}) = 4
defaultminimum(::Number) = 20
defaultminimum(::T) where {T <: Base.IEEEFloat} = Parsers.neededdigits(T)
defaultminimum(x::Bool) = ifelse(x, 4, 5)
defaultminimum(x::AbstractString) = ncodeunits(x) + 2
defaultminimum(x::Symbol) = ccall(:strlen, Csize_t, (Cstring,), x) + 2
defaultminimum(x::Enum) = 16
defaultminimum(::Type{T}) where {T} = 16
defaultminimum(x::Char) = 3
defaultminimum(x::Union{Tuple, AbstractSet}) = isempty(x) ? 2 : sum(defaultminimum, x)
defaultminimum(x::AbstractArray) = isempty(x) ? 2 : sum(defaultminimum, (isassigned(x, i) ? defaultminimum(x[i]) : 4 for i in eachindex(x)))
defaultminimum(x::Union{AbstractDict, NamedTuple, Pair}) = isempty(x) ? 2 : sum(defaultminimum(k) + defaultminimum(v) for (k, v) in StructTypes.keyvaluepairs(x))
defaultminimum(x) = max(2, sizeof(x))

"""
    JSON3.write([io], x; kw...)

Write JSON.

## Args

* `io`: Optionally, an `IO` object to write the resulting JSON string to.  By default, will return a `String` if `io` is not provided.
* `x`: An object to serialize as JSON.  If not a [built in type](#Builtin-types), must have a "struct mapping" registered with [StructTypes.jl](#Struct-API).

## Keyword Args

* `allow_inf`: Allow writing of `Inf` and `NaN` values (not part of the JSON standard). [default `false`]
* `dateformat`: A [`DateFormat`](https://docs.julialang.org/en/v1/stdlib/Dates/#Dates.DateFormat) describing how to format `Date`s in the object. [default `Dates.default_format(T)`]
"""
function write(io::IO, obj::T; kw...) where {T}
    len = defaultminimum(obj)
    buf = Base.StringVector(len)
    buf, pos, len = write(StructType(obj), buf, 1, length(buf), obj; kw...)
    return Base.write(io, resize!(buf, pos - 1))
end

function write(obj::T; kw...) where {T}
    len = defaultminimum(obj)
    buf = Base.StringVector(len)
    buf, pos, len = write(StructType(obj), buf, 1, length(buf), obj; kw...)
    return String(resize!(buf, pos - 1))
end

function write(fname::String, obj::T; kw...) where {T}
    open(fname, "w") do io
        write(io, obj; kw...)
    end
    fname
end

@noinline function realloc!(buf, len, n)
    # println("re-allocing...")
    new = zeros(UInt8, max(n, trunc(Int, len * 1.25)))
    copyto!(new, 1, buf, 1, len)
    return new, length(new)
end

macro check(n)
    esc(quote
        if (pos + $n - 1) > len
            buf, len = realloc!(buf, len, pos + $n - 1)
        end
    end)
end

macro writechar(chars...)
    block = quote
        @check($(length(chars)))
    end
    for c in chars
        push!(block.args, quote
            @inbounds buf[pos] = UInt8($c)
            pos += 1
        end)
    end
    #println(macroexpand(@__MODULE__, block))
    return esc(block)
end

# we need to special-case writing Type{T} because of ambiguities w/ StructTypes
write(::Struct, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::Mutable, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::DictType, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::ArrayType, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::StringType, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::NumberType, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::NullType, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::BoolType, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::AbstractType, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::SingletonType, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))
write(::NoStructType, buf, pos, len, ::Type{T}; kw...) where {T} = write(StringType(), buf, pos, len, Base.string(T))

write(::NoStructType, buf, pos, len, ::T; kw...) where {T} = throw(ArgumentError("$T doesn't have a defined `StructTypes.StructType`"))

@inline function write(::RawType, buf, pos, len, x::T; kw...) where {T}
    bytes = rawbytes(x)
    @check length(bytes)
    for b in bytes
        @inbounds buf[pos] = b
        pos += 1
    end
    return buf, pos, len
end

mutable struct WriteClosure{T, KW}
    buf::T
    pos::Int
    len::Int
    afterfirst::Bool
    kw::KW
end

@inline function (f::WriteClosure)(i, nm, TT, v; kw...)
    buf, pos, len = f.buf, f.pos, f.len
    if f.afterfirst
        @writechar ','
    else
        f.afterfirst = true
    end
    kw2 = merge(values(kw), f.kw)
    buf, pos, len = write(StringType(), buf, pos, len, nm; kw2...)
    @writechar ':'
    buf, pos, len = write(StructType(v), buf, pos, len, v; kw2...)
    f.buf = buf
    f.pos = pos
    f.len = len
    return
end

# generic object writing
@inline function write(::Union{Struct, Mutable}, buf, pos, len, x::T; kw...) where {T}
    @writechar '{'
    c = WriteClosure(buf, pos, len, false, values(kw))
    StructTypes.foreachfield(c, x)
    buf = c.buf
    pos = c.pos
    len = c.len
    @writechar '}'
    return buf, pos, len
end

@inline function write(::CustomStruct, buf, pos, len, x; kw...)
    y = StructTypes.lower(x)
    return write(StructType(y), buf, pos, len, y; kw...)
end

function write(::DictType, buf, pos, len, x::T; kw...) where {T}
    @writechar '{'
    pairs = StructTypes.keyvaluepairs(x)

    next = iterate(pairs)
    while next !== nothing
        (k, v), state = next

        buf, pos, len = write(StringType(), buf, pos, len, Base.string(k))
        @writechar ':'
        buf, pos, len = write(StructType(v), buf, pos, len, v; kw...)

        next = iterate(pairs, state)
        next === nothing || @writechar ','
    end
    @writechar '}'
    return buf, pos, len
end

function write(::ArrayType, buf, pos, len, x::T; kw...) where {T}
    @writechar '['
    n = length(x)
    i = 1
    for y in x
        buf, pos, len = write(StructType(y), buf, pos, len, y; kw...)
        if i < n
            @writechar ','
        end
        i += 1
    end
    @writechar ']'
    return buf, pos, len
end

function write(::ArrayType, buf, pos, len, x::AbstractArray; kw...)
    @writechar '['
    n = 0
    for i in eachindex(x)
        if isassigned(x, i)
            y = x[i]
            buf, pos, len = write(StructType(y), buf, pos, len, y; kw...)
        else
            buf, pos, len = write(NullType(), buf, pos, len, nothing; kw...)
        end
        @writechar ','
        n += 1
    end
    if n > 0
        # for non-empty arrays, we eagerly write a comma after each element
        # so backtrack one pos where we'll write ']'
        pos -= 1
    end
    @writechar ']'
    return buf, pos, len
end

function write(::NullType, buf, pos, len, x; kw...)
    @writechar 'n' 'u' 'l' 'l'
    return buf, pos, len
end

write(::BoolType, buf, pos, len, x; kw...) = write(BoolType(), buf, pos, len, StructTypes.construct(Bool, x); kw...)
function write(::BoolType, buf, pos, len, x::Bool; kw...)
    if x
        @writechar 't' 'r' 'u' 'e'
    else
        @writechar 'f' 'a' 'l' 's' 'e'
    end
    return buf, pos, len
end

write(::SingletonType, buf, pos, len, x; kw...) = write(StringType(), buf, pos, len, x; kw...)

# adapted from base/intfuncs.jl
_split_sign(x) = Base.split_sign(x)
_split_sign(x::BigInt) = (abs(x), x < 0)

function write(::NumberType, buf, pos, len, y::Integer; kw...)
    x, neg = _split_sign(y)
    if neg
        @writechar UInt8('-')
    end
    n = i = ndigits(x, base=10, pad=1)
    @check i
    while i > 0
        @inbounds buf[pos + i - 1] = 48 + rem(x, 10)
        x = oftype(x, div(x, 10))
        i -= 1
    end
    return buf, pos + n, len
end

# default fallback for non-Integer/non-AbstractFloat numbers
# conver to Float64 and write the string representation
"""
    JSON3.tostring(x::Real) -> String

For some number types that are `<: Real`, but not `<: Integer` or `<: AbstractFloat`,
`tostring` provides an overload to convert `x` to an appropriate string representation
which will be used for the JSON numeric representation. By default, `x` is converted
to a `Float64` and then to a `String`.
"""
tostring(x::Real) = Base.string(convert(Float64, x))

function write(::NumberType, buf, pos, len, x::T; kw...) where {T}
    NT = StructTypes.numbertype(T)
    if NT === T
        # this means T hasn't overloaded numbertype
        # and we can't StructTypes.construct since we'll just stack overflow
        # so we call last-chance tostring that can be overloaded
        bytes = codeunits(tostring(x))
        sz = sizeof(bytes)
        @check sz
        for i = 1:sz
            @inbounds @writechar bytes[i]
        end

        return buf, pos, len
    else
        write(NumberType(), buf, pos, len, StructTypes.construct(NT, x); kw...)
    end
end

function write(::NumberType, buf, pos, len, x::AbstractFloat; allow_inf::Bool=false, kw...)
    isfinite(x) || allow_inf || error("$x not allowed to be written in JSON spec")
    bytes = codeunits(Base.string(x))
    sz = sizeof(bytes)
    @check sz
    for i = 1:sz
        @inbounds @writechar bytes[i]
    end

    return buf, pos, len
end

@inline function write(::NumberType, buf, pos, len, x::T; allow_inf::Bool=false, kw...) where {T <: Base.IEEEFloat}
    isfinite(x) || allow_inf || error("$x not allowed to be written in JSON spec")
    if isinf(x)
        # Although this is non-standard JSON, "Infinity" is commonly used.
        # See https://docs.python.org/3/library/json.html#infinite-and-nan-number-values.
        if sign(x) == -1
            @writechar '-'
        end
        @writechar 'I' 'n' 'f' 'i' 'n' 'i' 't' 'y'
        return buf, pos, len
    end
    @check Ryu.neededdigits(T)
    pos = Ryu.writeshortest(buf, pos, x)
    return buf, pos, len
end

const NEEDESCAPE = Set(map(UInt8, ('"', '\\', '\b', '\f', '\n', '\r', '\t')))

function escapechar(b)
    b == UInt8('"')  && return UInt8('"')
    b == UInt8('\\') && return UInt8('\\')
    b == UInt8('\b') && return UInt8('b')
    b == UInt8('\f') && return UInt8('f')
    b == UInt8('\n') && return UInt8('n')
    b == UInt8('\r') && return UInt8('r')
    b == UInt8('\t') && return UInt8('t')
    return 0x00
end

iscntrl(c::Char) = c <= '\x1f' || '\x7f' <= c <= '\u9f'
function escaped(b)
    if b == UInt8('/')
        return [UInt8('/')]
    elseif b >= 0x80
        return [b]
    elseif b in NEEDESCAPE
        return [UInt8('\\'), escapechar(b)]
    elseif iscntrl(Char(b))
        return UInt8[UInt8('\\'), UInt8('u'), Base.string(b, base=16, pad=4)...]
    else
        return [b]
    end
end

const ESCAPECHARS = [escaped(b) for b = 0x00:0xff]
const ESCAPELENS = [length(x) for x in ESCAPECHARS]

function escapelength(str)
    x = 0
    @simd for i = 1:ncodeunits(str)
        @inbounds len = ESCAPELENS[codeunit(str, i) + 1]
        x += len
    end
    return x
end

write(::StringType, buf, pos, len, x::T; dateformat::Dates.DateFormat=Dates.default_format(T), kw...) where {T <: Dates.TimeType} = write(StringType(), buf, pos, len, Dates.format(x, dateformat); kw...)
write(::StringType, buf, pos, len, x; kw...) = write(StringType(), buf, pos, len, Base.string(x); kw...)
function write(::StringType, buf, pos, len, x::AbstractString; kw...)
    sz = ncodeunits(x)
    el = escapelength(x)
    @check (el + 2)
    @inbounds @writechar '"'
    if el > sz
        for i = 1:sz
            @inbounds escbytes = ESCAPECHARS[codeunit(x, i) + 1]
            for j = 1:length(escbytes)
                @inbounds buf[pos] = escbytes[j]
                pos += 1
            end
        end
    else
        @simd for i = 1:sz
            @inbounds buf[pos] = codeunit(x, i)
            pos += 1
        end
    end
    @inbounds @writechar '"'
    return buf, pos, len
end

write(::StringType, buf, pos, len, x::Symbol; kw...) = write(StringType(), buf, pos, len, String(x); kw...)

using PrecompileTools

@compile_workload begin
    str = """{"a": 1, "b": "hello, world", "c": [1, 2], "d": true, "e": null, "f": 1.92, "g": {"a": {"a" : "b"}}}"""

    JSON3.read(IOBuffer(str))
    json = JSON3.read(str)
    for i in "abcdef"
        json[i]
    end
    json[:g][:a][:a]

    JSON3.read(
        str,
        NamedTuple{(:a, :b, :c, :d, :e, :f), Tuple{Int, String, Vector{Int}, Bool, Nothing, Float32}}
    )

    JSON3.write(IOBuffer(), json)
    JSON3.pretty(IOBuffer(), json)
end

module JSON3ArrowExt

using JSON3
using ArrowTypes

const JSON3_ARROW_NAME = Symbol("JuliaLang.JSON3.Object")

# It might looks strange to have this as a StructKind when JSON objects are
# very dict-like, but the valtype is Any, which Arrow.jl really not like
# and even if we add a
# toarrow(d::JSON3.Object) d = Dict{String, Union{typeof.(values(d))...}
# that does not seem to solve the problem.
ArrowTypes.ArrowKind(::Type{<:JSON3.Object}) = ArrowTypes.StructKind()
ArrowTypes.arrowname(::Type{<:JSON3.Object}) = JSON3_ARROW_NAME
ArrowTypes.JuliaType(::Val{JSON3_ARROW_NAME}) = JSON3.Object

end # module

using Documenter, JSON3, StructTypes

makedocs(;
    modules=[JSON3],
    format=Documenter.HTML(edit_link="main"),
    pages=[
        "Home" => "index.md",
    ],
    repo=Remotes.GitHub("quinnj", "JSON3.jl"),
    sitename="JSON3.jl",
    authors="Jacob Quinn",
)

deploydocs(;
    repo="github.com/quinnj/JSON3.jl",
    devbranch = "main",
)

using JSON3
using StructTypes
using Test

struct StringNumber
    value::String
end

@inline Base.getindex(x::StringNumber) = x.value::String

@inline StructTypes.StructType(::Type{StringNumber}) = JSON3.RawType()
@inline StructTypes.construct(::Type{StringNumber}, x::JSON3.RawValue) = StringNumber(unsafe_string(pointer(x.bytes, x.pos), x.len))
@inline JSON3.rawbytes(x::StringNumber) = codeunits(x.value)

@inline function test_roundtrip(json::String, object, ::Type{T}) where T
    # starting with object
    a = JSON3.write(object)
    @test typeof(a) === String
    b = JSON3.read(a, T)
    @test typeof(b) === typeof(object)
    c = JSON3.write(b)
    @test typeof(c) === String
    @test a === c

    # starting with json
    a = JSON3.read(json, T)
    @test typeof(a) == T
    @test typeof(a) == typeof(object)
    mutable_struct_equality(a, object)
    b = JSON3.write(a)
    @test typeof(b) === String
    @test b === json

    # @test false

    return nothing
end

@inline function mutable_struct_equality(a::T, b::T)::Bool where T
    if isstructtype(T) && ismutable(a)
        T_fieldnames = fieldnames(T)
        T_num_fieldnames = length(T_fieldnames)
        temp_vector = Vector{Bool}(undef, T_num_fieldnames)
        for i in 1:T_num_fieldnames
            name_i = T_fieldnames[i]
            temp_vector[i] = mutable_struct_equality(getfield(a, name_i), getfield(b, name_i))
        end
        return all(temp_vector)
    else
        return a == b
    end
end

mutable struct StringNumberTests_A{S}
    entries::Vector{S}
    StringNumberTests_A{S}()        where {S} = new{S}()
    StringNumberTests_A{S}(entries) where {S} = new{S}(entries)
end
mutable struct StringNumberTests_B{T}
    foo::T
    StringNumberTests_B{T}()    where {T} = new{T}()
    StringNumberTests_B{T}(foo) where {T} = new{T}(foo)
end
mutable struct StringNumberTests_C
    bar::StringNumber
    StringNumberTests_C() = new()
    StringNumberTests_C(bar) = new(bar)
end
StructTypes.StructType(::Type{<:StringNumberTests_A}) = StructTypes.Mutable()
StructTypes.StructType(::Type{<:StringNumberTests_B}) = StructTypes.Mutable()
StructTypes.StructType(::Type{<:StringNumberTests_C}) = StructTypes.Mutable()

@testset "JSON3.RawType: StringNumber" begin
    @testset "Basic tests" begin
        test_cases = ["1.2", "1.20", "1.200", "1.2000", "1.20000"]
        @testset "Reading" begin
            for a in test_cases
                b = JSON3.read(a, StringNumber)
                @test typeof(b) === StringNumber
                @test typeof(b[]) === String
                @test b[] === a
            end
        end
        @testset "Writing" begin
            for c in test_cases
                d = StringNumber(c)
                e = JSON3.write(d)
                @test typeof(e) === String
                @test e === c
            end
        end
        @testset "Roundtrip" begin
            for json in test_cases
                object = StringNumber(json)
                test_roundtrip(json, object, StringNumber)
            end
        end
    end
    @testset "More complex test" begin
        a = StringNumber("1.20")
        b = StringNumber("34.5600")
        c = StringNumberTests_C(a)
        d = StringNumberTests_C(b)
        e = StringNumberTests_B{StringNumberTests_C}(c)
        f = StringNumberTests_B{StringNumberTests_C}(d)
        g = [e, f]
        object = StringNumberTests_A{StringNumberTests_B{StringNumberTests_C}}(g)
        json = "{\"entries\":[{\"foo\":{\"bar\":1.20}},{\"foo\":{\"bar\":34.5600}}]}"
        T = StringNumberTests_A{StringNumberTests_B{StringNumberTests_C}}
        test_roundtrip(json, object, T)
    end
end

# JSON3.jl Documentation

```@contents
Depth = 4
```

## Getting Started

> Yet another JSON package for Julia; this one is for speed and slick struct mapping

JSON3 provides two main functions: [`JSON3.read`](@ref) and [`JSON3.write`](@ref).  These allow, in the basic case, reading a JSON string into a [`JSON3.Object`](@ref) or [`JSON3.Array`](@ref), which allow for dot or bracket indexing and can be copied into base `Dict`s or `Vector`s if needed.  The slick struct mapping allows reading a JSON string directly into (almost) any type you wish and then writing directly from those types into JSON as well.

### Examples

#### Basic reading and writing
```@example
using JSON3 # hide
json_string = """{"a": 1, "b": "hello, world"}"""

hello_world = JSON3.read(json_string)

# can access the fields with dot or bracket notation
println(hello_world.b)
println(hello_world["a"])

JSON3.write(hello_world)
```

#### Write with pretty printing
```@example
using JSON3 # hide
json_string = """{"a": 1, "b": "hello, world"}"""

hello_world = JSON3.read(json_string)
JSON3.pretty(hello_world)
```

The alignment of the string produced  by `JSON3.pretty` can be controlled by
passing an [`JSON3.AlignmentContext`](@ref) to `JSON3.pretty`. To align each
level at the `:` Symbol and indent each new level by 2 additional spaces, use
```@example
using JSON3 # hide
json_string = """{"a":"abc","aaaaaaaaaaaaaa":{"a":"abc","aaaaaaaaaaaaaa":"abc"},"c":"abc"}""";
JSON3.pretty(JSON3.read(json_string), JSON3.AlignmentContext(alignment=:Colon, indent=2))
```
to left align the JSON string and indent each new level by 4 additional spaces
(this is also the default) use
```@example
using JSON3 # hide
json_string = """{"a":"abc","aaaaaaaaaaaaaa":{"a":"abc","aaaaaaaaaaaaaa":"abc"},"c":"abc"}""";
JSON3.pretty(JSON3.read(json_string), JSON3.AlignmentContext(alignment=:Left, indent=4))
```


#### Read and write from/to a file
```jl
json_string = read("my_file.json", String)

hello_world = JSON3.read(json_string)

open("my_new_file.json", "w") do io
    JSON3.write(io, hello_world)
end
```

#### Write pretty JSON to a file
```jl
hello_world = Dict("a" => Dict("b" => 1, "c" => 2), "b" => Dict("c" =>3, "d" => 4))

open("my_new_file.json", "w") do io
    JSON3.pretty(io, hello_world)
end
```

#### Read JSON into a type

See more details on the types that are provided and how to customize parsing [below](#Struct-API).

```@example
using JSON3 # hide
using StructTypes

json_string = """{"a": 1, "b": "hello, world"}"""

struct MyType
    a::Int
    b::String
end

StructTypes.StructType(::Type{MyType}) = StructTypes.Struct()

hello_world = JSON3.read(json_string, MyType)

println(hello_world)

JSON3.write(hello_world)
```

#### Read JSON into an already instantiated struct

```@example
using JSON3 # hide
using StructTypes

Base.@kwdef mutable struct MyType
    a::Int = 0
    b::String = ""
    c::String = ""
end

StructTypes.StructType(::Type{MyType}) = StructTypes.Mutable()

t = MyType(c = "foo")

json_string = """{"a": 1, "b": "hello, world"}"""

JSON3.read!(json_string, t)
```

#### Mutating read-JSON

Note that the `JSON3.Object` and `JSON3.Array` types are immutable, and hence can't be used like a normal `Dict` or `Array` to replace or add additional values. Calling `copy(obj_or_arr)` will convert a `JSON3.Object` into a mutable `Dict` or a `JSON3.Array` into a `Base.Array`, recursively calling `copy` on any nested objects/arrays.

```@example
using JSON3 # hide
read_only_json = JSON3.read("{\"a\": 3}")

writable_json = copy(read_only_json) # writable_json is now mutable
writable_json[:a] = 2 
```

#### Generate a type from your JSON

See the [section on generating types](#Generated-Types) for more details.

```@example
using JSON3 # hide
using StructTypes

json_string = """{"a": 1, "b": "hello, world"}"""

JSON3.@generatetypes json_string
hello_world = JSON3.read(json_string, JSONTypes.Root)
```

#### Read in a date
```@example
using JSON3 # hide
using Dates

json_string = "\"2000-01-01\""
df = dateformat"yyyy-mm-dd"
my_date = JSON3.read(json_string, Date; dateformat=df)
```

#### Read a quoted number
```@example
using JSON3 # hide
using StructTypes

json_string = """{"a": "1", "b": "hello, world"}"""

struct MyType
    a::Int
    b::String
end

StructTypes.StructType(::Type{MyType}) = StructTypes.Struct()

hello_world = JSON3.read(json_string, MyType; parsequoted=true)
```

### API

```@docs
JSON3.read
JSON3.read!
JSON3.write
JSON3.pretty
JSON3.@pretty
JSON3.AlignmentContext
JSON3.Object
JSON3.Array
Base.copy
JSON3.tostring
```

### In Relation to Other JSON Packages

#### JSON.jl

While the [JSON.jl](https://github.com/JuliaIO/JSON.jl) package has been around since the very early days of Julia, JSON3.jl aims a faster core implementation of JSON parsing (via [`JSON3.read`](@ref)), as well as better integration with custom types using the [Struct API](#Struct-API). Via the [StructTypes.jl](https://github.com/JuliaData/StructTypes.jl) package, JSON3 provides numerous configurations for reading/writing custom types.

#### JSONTables.jl

[JSONTables.jl](https://github.com/JuliaData/JSONTables.jl) uses JSON3 under the hood to read and write JSON sources to/from [Tables.jl](https://github.com/JuliaData/Tables.jl) compatible tables.

## Builtin types

The JSON format is made up of just a few types: Object, Array, String, Number, Bool, and Null.
In the JSON3 package, there are two main interfaces for interacting with these JSON types: 1) builtin and 2) struct mapping.
For builtin reading, called like `JSON3.read(json_string)`, the JSON3 package will parse a string or `Vector{UInt8}`,
returning a default object that maps to the type of the JSON. For a JSON Object, it will return a `JSON3.Object` type, which
acts like an immutable `Dict`, but has a more efficient view representation. For a JSON Array, it will return a `JSON3.Array` type,
which acts like an immutable `Vector`, but also has a more efficient view representation. If the JSON Array has homogenous elements,
the resulting `JSON3.Array` will be strongly typed accordingly. For the other JSON types (string, number, bool, and null),
they are returned as Julia equivalents (`String`, `Int64` or `Float64`, `Bool`, and `nothing`).

One might wonder why custom `JSON3.Object` and `JSON3.Array` types exist instead of just returning `Dict` and `Vector` directly. JSON3 employs a novel technique [inspired by the simdjson project](https://github.com/lemire/simdjson), that is a
semi-lazy parsing of JSON to the `JSON3.Object` or `JSON3.Array` types. The technique involves using a type-less "tape" to note
the *positions* of objects, arrays, and strings in a JSON structure, while avoiding the cost of *materializing* such
objects. For "scalar" types (number, bool, and null), the values are parsed immediately and stored inline in the "tape". This can result in best of both worlds performance: very fast initial parsing of a JSON input, and very cheap access afterwards. It also enables efficiencies in workflows where only small pieces of a JSON structure are needed, because expensive objects, arrays, and strings aren't materialized unless accessed. One additional advantage this technique allows is strong typing of `JSON3.Array{T}`; because the type of each element is noted while parsing, the `JSON3.Array` object can then be constructed with the most narrow type possible without having to reallocate any underlying data (since all data is stored in a type-less "tape" anyway).

The `JSON3.Object` supports the `AbstractDict` interface, but is read-only (it represents a *view* into the JSON source input), thus it supports `obj[:x]` and `obj["x"]`, as well as `obj.x` for accessing fields. It supports `keys(obj)` to see available keys in the object structure. You can call `length(obj)` to see how many key-value pairs there are, and it iterates `(k, v)` pairs like a normal `Dict`. It also supports the regular `get(obj, key, default)` family of methods.

The `JSON3.Array{T}` supports the `AbstractArray` interface, but like `JSON3.Object` is a *view* into the input JSON, hence is read-only. It supports normal array methods like `length(A)`, `size(A)`, iteration, and `A[i]` `getindex` methods.

If you really need `Dict`s and `Vector`s, then you can use `copy(x)` to recursively convert `JSON3.Object`s to `Dict`s and `JSON3.Array`s to `Vector`s.

## Struct API

The builtin JSON API in JSON3 is efficient and simple, but sometimes a direct mapping to a Julia structure is desirable. JSON3 uses the simple, yet powerful "struct mapping" techniques from the [StructTypes.jl](https://github.com/JuliaData/StructTypes.jl) package.

In general, custom Julia types tend to be one of: 1) "data types", 2) "interface types" and sometimes 3) "abstract types" with a known set of concrete subtypes or 4) "custom types" that just don't really fit in any other categories. Data types tend to be "collection of fields" kind of types; fields are generally public and directly accessible, they might also be made to model "objects" in the object-oriented sense. In any case, the type is "nominal" in the sense that it's "made up" of the fields it has, sometimes even if just for making it more convenient to pass them around together in functions.

Interface types, on the other hand, are characterized by *private* fields; they contain optimized representations "under the hood" to provide various features/functionality and are useful via interface methods implemented: iteration, `getindex`, accessor methods, etc. Many package-provided libraries or Base-provided structures are like this: `Dict`, `Array`, `Socket`, etc. For these types, their underlying fields are mostly cryptic and provide little value to users directly, and are often explictly documented as being implementation details and not to be accessed under warning of breakage.

What does all this have to do with mapping Julia structures to JSON? A lot! For data types, the most typical JSON representation is for each field name to be a JSON key, and each field value to be a JSON value. And when *reading* data types from JSON, we need to specify how to construct the Julia structure for the key-value pairs encountered while parsing. This can be considered a "direct" mapping of Julia struct types to JSON objects in that we try to map field to key directly. This is the "data type" view of json-to-Julia struct mapping.

For interface types, however, we don't want to consider the type's fields at all, since they're "private" and not very meaningful. For these types, an alternative API is provided where a user can specify the `StructTypes.StructType` their type most closely maps to, one of `StructTypes.DictType()`, `StructTypes.ArrayType()`, `StructTypes.StringType()`, `StructTypes.NumberType()`, `StructTypes.BoolType()`, or `StructTypes.NullType()`.

For abstract types, it can sometimes be useful when reading a JSON structure to say that it will be one of a limited set of related types, with a specific JSON key in the structure signaling which concrete type the rest of the structure represents. JSON3 uses StructTypes.jl functionality to specify a `StructTypes.AbstractType()` for a type, along with a mapping of JSON key-type values to Julia subtypes that can be used to identify the concrete type while parsing.

We briefly mentioned a 4th category above: "custom types". Sometimes a type is just a "wrapper" around an internal type that has a well defined representation, be that data or interface. Sometimes, we're just in the middle of developing something and our structs are just not that well defined. `StructTypes.CustomStruct` provides a bit of an "escape hatch" of sorts in that we get explicit "hooks" into the pre-serialization and pre-deserialization steps when calling `JSON3.read(json, T)`. These are available via the `StructTypes.lower(x::T)` and `StructTypes.lowertype(::Type{T})` methods. The former will be called on any type with the `StructTypes.CustomStruct` trait before serializing, and then serializing will continue anew on whatever was returned, hence `StructTypes.lower` needs to return or transform `x::T` into something that also has a well-defined `StructType` trait. So our custom type `T` can essentially be serialized however we want by whatever we return from `StructTypes.lower`. `StructTypes.lowertype` works similarly, but for deserialization. We defined a mapping from our custom type to the type of object that should first be deserialized, which will then be passed to our type's `StructType.construct` method. An example of all this is:

```julia
struct Person
    id::Int
    name::String
end
StructTypes.StructType(::Type{Person}) = StructTypes.Struct()
struct PersonWrapper
    person::Person
end
StructTypes.StructType(::Type{PersonWrapper}) = StructTypes.CustomStruct()
StructTypes.lower(x::PersonWrapper) = x.person
StructTypes.lowertype(::Type{PersonWrapper}) = Person
StructTypes.construct(::Type{PersonWrapper}, x::Person) = PersonWrapper(x) # not strictly needed, because the default is `construct(T, x) = T(x)`
```

### DataTypes

For "data types", we aim to directly specify the JSON reading/writing behavior with respect to a Julia type's fields. This kind of data type can signal its struct type in a couple of ways:
```julia
StructTypes.StructType(::Type{MyType}) = StructTypes.Struct()
# or
StructTypes.StructType(::Type{MyType}) = StructTypes.Mutable()
# or assuming certain conditions
StructTypes.StructType(::Type{MyType}) = StructTypes.OrderedStruct()
```
`StructTypes.Struct` and `StructTypes.Mutable` correspond to the existing difference between Julia `struct` and `mutable struct` types: that is, immutable (`Struct`) vs. mutable (`Mutable`).
`StructTypes.OrderedStruct()` is less flexible, yet more performant. For reading a `StructTypes.OrderedStruct()` from a JSON string input, each key-value pair is read in the order it is encountered in the JSON input, the keys are ignored, and the values are directly passed to the type at the end of the object parsing like `MyType(val1, val2, val3)`. Yes, the JSON specification says that Objects are specifically *un-ordered* collections of key-value pairs, but the truth is that many JSON libraries provide ways to maintain JSON Object key-value pair order when reading/writing. Because of the minimal processing done while parsing, and the "trusting" that the Julia type constructor will be able to handle fields being present, missing, or even extra fields that should be ignored, this is the fastest possible method for mapping a JSON input to a Julia structure. If your workflow interacts with non-Julia APIs for sending/receiving JSON, you should take care to test and confirm the use of `StructTypes.OrderedStruct()` in the cases mentioned above: what if a field is missing when parsing? what if the key-value pairs are out of order? what if there extra fields get included that weren't anticipated? If your workflow is questionable on these points, or it would be too difficult to account for these scenarios in your type constructor, it would be better to consider the `StructTypes.Struct` or `StructTypes.Mutable()` options.

The slightly less performant, yet much more robust method for directly mapping Julia struct fields to JSON objects is via `StructTypes.Mutable()`. This technique requires your Julia type to be defined, *at a minimum*, like:
```julia
mutable struct MyType
    field1
    field2
    field3
    # etc.

    MyType() = new()
end
# or if not an "empty" inner construct, can be empty outer constructor
MyType() = ...
```
Note specifically that we're defining a `mutable struct` to allow field mutation, and providing a `MyType() = new()` inner constructor which constructs an "empty" `MyType` where isbits fields will be randomly initialized, and reference fields will be `#undef`. (Note that the constructor doesn't need to be *exactly* this (i.e. inner), but at least needs to be callable like `MyType()`. If certain fields need to be intialized or zeroed out for security, then this should be accounted for in the constructor). For these mutable types, the type will first be initizlied like `MyType()`, then JSON parsing will parse each key-value pair in a JSON object, setting the field as the key is encountered, and converting the JSON value to the appropriate field value. This flow has the nice properties of: allowing parsing success even if fields are missing in the JSON structure, and if "extra" fields exist in the JSON structure that aren't apart of the Julia struct's fields, they will automatically be ignored. This allows for maximum robustness when mapping Julia types to arbitrary JSON objects that may be generated via web services, other language JSON libraries, etc.

`StructTypes.Struct` work similarly, but due to their immutability, fields are parsed from JSON, then passed to `StructTypes.construct(T, x...)` where `T` is our struct type, and `x...` are the fields we've parsed from the JSON, provided _in field order_, even if the JSON had fields out of order. If fields are missing from the JSON itself, the `nothing` value will be passed for those fields, so constructors should account for the potential of missing fields by setting a default value in case of `nothing` or perhaps typeing the field like `Union{String, Nothing}` explicitly.

There are a few additional helper methods that can be utilized by these `StructTypes.DataType` types to hand-tune field reading/writing behavior:

* `StructTypes.names(::Type{MyType}) = ((:field1, :json1), (:field2, :json2))`: provides a mapping of Julia field name to expected JSON object key name. This affects both reading and writing. When reading the `json1` key, the `field1` field of `MyType` will be set. When writing the `field2` field of `MyType`, the JSON key will be `json2`.
* `StructTypes.excludes(::Type{MyType}) = (:field1, :field2)`: specify fields of `MyType` to ignore when reading and writing, provided as a `Tuple` of `Symbol`s. When reading, if `field1` is encountered as a JSON key, it's value will be read, but the field will not be set in `MyType`. When writing, `field1` will be skipped when writing out `MyType` fields as key-value pairs.
* `StructTypes.omitempties(::Type{MyType}) = (:field1, :field2)`: specify fields of `MyType` that shouldn't be written if they are "empty", provided as a `Tuple` of `Symbol`s. This only affects writing. If a field is a collection (AbstractDict, AbstractArray, etc.) and `isempty(x) === true`, then it will not be written. If a field is `#undef`, it will not be written. If a field is `nothing`, it will not be written.
* `StructTypes.keywordargs(::Type{MyType}) = (field1=(dateformat=dateformat"mm/dd/yyyy",), field2=(dateformat=dateformat"HH MM SS",))`: Specify for a `StructTypes.Mutable` `StructType` the keyword arguments by field, given as a `NamedTuple` of `NamedTuple`s, that should be passed to the `StructTypes.construct` method when deserializing `MyType`. This essentially allows defining specific keyword arguments you'd like to be passed for each field in your struct. Note that keyword arguments can be passed when reading, like `JSON3.read(source, MyType; dateformat=...)` and they will be passed down to each `StructTypes.construct` method. `StructTypes.keywordargs` just allows the defining of specific keyword arguments per field.

### Interface Types

For interface types, we don't want the internal fields of a type exposed, so an alternative API is to define the closest JSON type that our custom type should map to. This is done by choosing one of the following definitions:
```julia
StructTypes.StructType(::Type{MyType}) = StructTypes.DictType()
StructTypes.StructType(::Type{MyType}) = StructTypes.ArrayType()
StructTypes.StructType(::Type{MyType}) = StructTypes.StringType()
StructTypes.StructType(::Type{MyType}) = StructTypes.NumberType()
StructTypes.StructType(::Type{MyType}) = StructTypes.BoolType()
StructTypes.StructType(::Type{MyType}) = StructTypes.NullType()
StructTypes.StructType(::Type{MyType}) = JSON3.RawType()
```

Now we'll walk through each of these and what it means to map my custom Julia type to an interface type.

#### StructTypes.DictType

    StructTypes.StructType(::Type{MyType}) = StructTypes.DictType()

Declaring my type is `StructTypes.DictType()` means it should map to a JSON object of unordered key-value pairs, where keys are `Symbol` or `String`, and values are any other type (or `Any`).

Types already declared as `StructTypes.DictType()` include:
  * Any subtype of `AbstractDict`
  * Any `NamedTuple` type
  * Any `Pair` type

So if your type subtypes `AbstractDict` and implements its interface, then JSON reading/writing should just work!

Otherwise, the interface to satisfy `StructTypes.DictType()` for reading is:

  * `MyType(x::Dict{Symbol, Any})`: implement a constructor that takes a `Dict{Symbol, Any}` of key-value pairs parsed from JSON
  * `StructTypes.construct(::Type{MyType}, x::Dict; kw...)`: alternatively, you may overload the `StructTypes.construct` method for your type if defining a constructor is undesirable (or would cause other clashes or ambiguities)

The interface to satisfy for writing is:

  * `pairs(x)`: implement the `pairs` iteration function (from Base) to iterate key-value pairs to be written out to JSON
  * `StructTypes.keyvaluepairs(x::MyType)`: alternatively, you can overload the `StructTypes.keyvaluepairs` function if overloading `pairs` isn't possible for whatever reason

#### StructTypes.ArrayType

    StructTypes.StructType(::Type{MyType}) = StructTypes.ArrayType()

Declaring my type is `StructTypes.ArrayType()` means it should map to a JSON array of ordered elements, homogenous or otherwise.

Types already declared as `StructTypes.ArrayType()` include:
  * Any subtype of `AbstractArray`
  * Any subtype of `AbstractSet`
  * Any `Tuple` type

So if your type already subtypes these and satifies the interface, things should just work.

Otherwise, the interface to satisfy `StructTypes.ArrayType()` for reading is:

  * `MyType(x::Vector)`: implement a constructo that takes a `Vector` argument of values and constructs a `MyType`
  * `StructTypes.construct(::Type{MyType}, x::Vector; kw...)`: alternatively, you may overload the `StructTypes.construct` method for your type if defining a constructor isn't possible
  * Optional: `Base.IteratorEltype(::Type{MyType})` and `Base.eltype(x::MyType)`: this can be used to signal to JSON3 that elements for your type are expected to be a single type and JSON3 will attempt to parse as such

The interface to satisfy for writing is:

  * `iterate(x::MyType)`: just iteration over each element is required; note if you subtype `AbstractArray` and define `getindex(x::MyType, i::Int)`, then iteration is already defined for your type

#### StructTypes.StringType

    StructTypes.StructType(::Type{MyType}) = StructTypes.StringType()

Declaring my type is `StructTypes.StringType()` means it should map to a JSON string value.

Types already declared as `StructTypes.StringType()` include:
  * Any subtype of `AbstractString`
  * The `Symbol` type
  * Any subtype of `Enum` (values are written with their symbolic name)
  * The `Char` type

So if your type is an `AbstractString` or `Enum`, then things should already work.

Otherwise, the interface to satisfy `StructTypes.StringType()` for reading is:

  * `MyType(x::String)`: define a constructor for your type that takes a single String argument
  * `StructTypes.construct(::Type{MyType}, x::String; kw...)`: alternatively, you may overload `StructTypes.construct` for your type
  * `StructTypes.construct(::Type{MyType}, ptr::Ptr{UInt8}, len::Int; kw...)`: another option is to overload `StructTypes.construct` with pointer and length arguments, if it's possible for your custom type to take advantage of avoiding the full string materialization; note that your type should implement both `StructTypes.construct` methods, since JSON strings with escape characters in them will be fully unescaped before calling `StructTypes.construct(::Type{MyType}, x::String)`, i.e. there is no direct pointer/length method for escaped strings

The interface to satisfy for writing is:

  * `Base.string(x::MyType)`: overload `Base.string` for your type to return a "stringified" value

#### StructTypes.NumberType

    StructTypes.StructType(::Type{MyType}) = StructTypes.NumberType()

Declaring my type is `StructTypes.NumberType()` means it should map to a JSON number value.

Types already declared as `StructTypes.NumberType()` include:
  * Any subtype of `Signed`
  * Any subtype of `Unsigned`
  * Any subtype of `AbstractFloat`

In addition to declaring `StructTypes.NumberType()`, custom types can also specify a specific, *existing* number type it should map to. It does this like:
```julia
StructTypes.numbertype(::Type{MyType}) = Float64
```

In this case, I'm declaring the `MyType` should map to an already-supported number type `Float64`. This means that when reading, JSON3 will first parse a `Float64` value, and then call `MyType(x::Float64)`. Note that custom types may also overload `StructTypes.construct(::Type{MyType}, x::Float64; kw...)` if using a constructor isn't possible. Also note that the default for any type declared as `StructTypes.NumberType()` is `Float64`.

Similarly for writing, JSON3 will first call `Float64(x::MyType)` before writing the resulting `Float64` value out as a JSON number.

#### StructTypes.BoolType

    StructTypes.StructType(::Type{MyType}) = StructTypes.BoolType()

Declaring my type is `StructTypes.BoolType()` means it should map to a JSON boolean value.

Types already declared as `StructTypes.BoolType()` include:
  * `Bool`

The interface to satisfy for reading is:
  * `MyType(x::Bool)`: define a constructor that takes a single `Bool` value
  * `StructTypes.construct(::Type{MyType}, x::Bool; kw...)`: alternatively, you may overload `StructTypes.construct`

The interface to satisfy for writing is:
  * `Bool(x::MyType)`: define a conversion to `Bool` method

#### StructTypes.NullType

    StructTypes.StructType(::Type{MyType}) = StructTypes.NullType()

Declaring my type is `StructTypes.NullType()` means it should map to the JSON value `null`.

Types already declared as `StructTypes.NullType()` include:
  * `nothing`
  * `missing`

The interface to satisfy for reading is:
  * `MyType()`: an empty constructor for `MyType`
  * `StructTypes.construct(::Type{MyType}, x::Nothing; kw...)`: alternatively, you may overload `StructTypes.construct`

There is no interface for writing; if a custom type is declared as `StructTypes.NullType()`, then the JSON value `null` will be written.

#### JSON3.RawType

`JSON3.RawType` is a `StructType` that
custom types may define as their trait in order to get access to the
"raw value" while parsing. After declaring
`StructTypes.StructType(::Type{MyType}) = JSON3.RawType()`, the custom
`MyType` must also define
`StructTypes.construct(::Type{MyType}, x::JSON3.RawValue) = ...`. A
`JSON3.RawValue` has 3 fields, `bytes`,
`pos`, and `len`, corresponding to the raw byte buffer, byte position at
which the raw value starts, and the length of the raw value,
respectively. Users are then free to "construct" an instance of their
`MyType` however they want from the `JSON3.RawValue`.

For serializing, i.e. `JSON3.write`, `MyType` must implement a method
like `JSON3.rawbytes(x::MyType) = ...`, which must return an iterator of
bytes (`UInt8`) with known length (`Base.IteratorSize` must be
`Base.HasLength()` and `length(JSON3.rawbytes(x))` must work). Care must be taken in providing bytes as no
additional processing or escape analysis is done, the bytes are written
"as-is". If bytes are written with unescaped control characters (`'{'`,
`','`, etc.), it will result in corrupt JSON documents.

For example, suppose that you want to read a JSON number verbatim into a
Julia string:
```jldoctest
julia> using JSON3, StructTypes

julia> struct StringNumber
       value::String
       end

julia> @inline StructTypes.StructType(::Type{StringNumber}) = JSON3.RawType()

julia> @inline StructTypes.construct(::Type{StringNumber}, x::JSON3.RawValue) = StringNumber(unsafe_string(pointer(x.bytes, x.pos), x.len))

julia> @inline JSON3.rawbytes(x::StringNumber) = codeunits(x.value)

julia> j = "1.200"
"1.200"

julia> x = JSON3.read(j, StringNumber)
StringNumber("1.200")

julia> JSON3.write(x)
"1.200"
```

### AbstractTypes

A final, uncommon option for struct mapping is declaring:
```julia
StructTypes.StructType(::Type{MyType}) = StructTypes.AbstractType()
```
When declaring my type as `StructTypes.AbstractType()`, you must also define `StructTypes.subtypes`, which should be a NamedTuple with subtype keys mapping to Julia subtype Type values. You may optionally define `StructTypes.subtypekey` that indicates which JSON key should be used for identifying the appropriate concrete subtype. A quick example should help illustrate proper use of this `StructType`:
```julia
abstract type Vehicle end

struct Car <: Vehicle
    type::String
    make::String
    model::String
    seatingCapacity::Int
    topSpeed::Float64
end

struct Truck <: Vehicle
    type::String
    make::String
    model::String
    payloadCapacity::Float64
end

StructTypes.StructType(::Type{Vehicle}) = StructTypes.AbstractType()
StructTypes.StructType(::Type{Car}) = StructTypes.Struct()
StructTypes.StructType(::Type{Truck}) = StructTypes.Struct()
StructTypes.subtypekey(::Type{Vehicle}) = :type
StructTypes.subtypes(::Type{Vehicle}) = (car=Car, truck=Truck)

car = JSON3.read("""
{
    "type": "car",
    "make": "Mercedes-Benz",
    "model": "S500",
    "seatingCapacity": 5,
    "topSpeed": 250.1
}""", Vehicle)
```
Here we have a `Vehicle` type that is defined as a `StructTypes.AbstractType()`. We also have two concrete subtypes, `Car` and `Truck`. In addition to the `StructType` definition, we also define `StructTypes.subtypekey(::Type{Vehicle}) = :type`, which signals to JSON3 that, when parsing a JSON structure, when it encounters the `type` key, it should use the value, in our example it's `car`, to discover the appropriate concrete subtype to parse the structure as, in this case `Car`. The mapping of JSON subtype key value to Julia Type is defined in our example via `StructTypes.subtypes(::Type{Vehicle}) = (car=Car, truck=Truck)`. Thus, `StructTypes.AbstractType` is useful when the JSON structure to read includes a "subtype" key-value pair that can be used to parse a specific, concrete type; in our example, parsing the structure as a `Car` instead of a `Truck`.

### Parametric types

For Julia dispatch and thereby for both `StructTypes` and `JSON3.jl` parametric types with different parameters are their own type. Consider this example where subtype of `data` depens on properties of the surrounding envelope object.
```julia
abstract type MessageTypes end
struct Envelope{MsgType <: MessageTypes}
    _id :: Int
    data :: MsgType
    _type :: String
    Envelope{MsgType}(n,t, tnm) where {MsgType} = new(n,t, tnm)
end

StructTypes.StructType(::Type{Envelope}) = StructTypes.AbstractType()
StructTypes.StructType(::Type{Envelope{T}}) where T <: MessageTypes  = StructTypes.Struct()
StructTypes.subtypekey(::Type{Envelope}) = :_type
StructTypes.subtypes(::Type{Envelope}) = (ping=Envelope{Ping}, pong=Envelope{Pong})

struct Ping <: MessageTypes
  now::String
end
StructTypes.StructType(::Type{Ping}) = StructTypes.Struct()
  
struct Pong <: MessageTypes
  now::Int
end
StructTypes.StructType(::Type{Pong}) = StructTypes.Struct()
```
So `Type{Envelope}`, `Type{Envelope{Ping}}` and `Type{Envelope{Pong}}` are distinct Julia types which each can have their own dispatch. Here `Type{Envelope}` is choosen to be an `StructTypes.AbstractType()`. Note that `Envelope` is not an abstract type. `StructTypes.AbstractType()` makes no claims about properties of the Julia type and instead causes a subtype lookup when this type is used for deserialization. Deserializing against `Envelope` triggers a look-up of a type based one value in the field `_type` in this example.
```julia
  @assert JSON3.read("""{"_id":1,"data":{"now":2023},"_type":"pong"}""", Envelope) isa Envelope{Pong}
  @assert JSON3.read("""{"_id":1,"data":{"now":"2023"},"_type":"ping"}""", Envelope) isa Envelope{Ping}
```
If given a parametric types we want define all subtypes to be a `StructTypes.StructType` `<:` is useful.
```julia
struct MyParametricType{T}
    t::T
    MyParametricType{T}(t) where {T} = new(t)
end
MyParametricType(t::T) where {T} = MyParametricType{T}(t)

x = MyParametricType(1)

StructTypes.StructType(::Type{<:MyParametricType}) = StructTypes.Struct() 
```
This match all possible parametric types `MyParametricType{T}`. When deserializing, the type parameter(s) should be provided:
```julia
JSON3.read(json_string, MyParametricType{Int}) # NOT JSON3.read(json_string, MyParametricType)
```
In the previous example `Envelope` was ultimatetly resolved to a fully parametrized type.
## Generated Types

JSON3 has the ability to generate types from sample JSON, which then can be used to parse JSON into. Inspired by the [F# type provider](http://tomasp.net/academic/papers/fsharp-data/fsharp-data.pdf).

```julia
JSON3.@generatetypes sample :MyModule
JSON3.read(full_json, MyModule.Root)

# or if sample is an array of objects
JSON3.read(full_json, Vector{MyModule.Root})
```

The [`JSON3.@generatetypes`](@ref) macro takes a JSON string or file name, generates a raw type from it, then parses that raw type into a series of mutable structs, which are then evaluated in a module (default `JSONTypes`) in the local scope.  Alternately, the [`JSON3.writetypes`](@ref) function can be used to perform these same steps, but instead write the generated module to file.

```julia
# writes a module called JSONTypes with the root struct Root as mutable
JSON3.writetypes(sample, "json_types.jl")

# write the same module, but with custom names and immutable
JSON3.writetypes(sample, "json_types.jl"; module_name=:MyModule, root_name=:ABC, mutable=false)

# these files can then be edited as needed (perhaps to prune the imported json)
include("json_types.jl")
```

### API

```@docs
JSON3.generatetypes
JSON3.@generatetypes
JSON3.writetypes
JSON3.generate_type
JSON3.generate_exprs
JSON3.write_exprs
JSON3.generate_struct_type_module
```
